-- name=cheater
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.cheats =
  {
    {
      id = "in_stage",
      name = "Level Internal",
      actions =
      {
        {
          id = "win",
          name = "Win Level", 
          action = private.Stage_Win,
          key = 87
        },
        {
          id = "fail",
          name = "Lose Level",
          action = private.Stage_Fail,
          key = 70
        },
        --{
        --  id = "ap",
        --  name = "Auto Play",
        --  action = private.Stage_Autoplay
        --},
        {
          id = "reload",
          name = "Reload",
          action = private.Stage_Reload,
          hide = true,
          key = 116
        },
        {
          id = "use_hammer",
          name = "Hammer",
          action = private.Stage_UseBoosterHammer,
          hide = true,
          key = 49
        }
      }
    },
    {
      id = "stage_start",
      name = "Level Start Window",
      actions =
      {
        {
          id = "win_all",
          name = "Win All Tiers",
          action = private.Map_WinAllStates,
          key = 87
        }
      }
    },
    {
      id = "save",
      name = "Save",
      actions =
      {
        {
          id = "freeze",
          name = "Freeze Save",
          action = private.SetNoDBMode
        },
        {
          id = "reset",
          name = "Reset Save",
          action = private.Reset
        }
      }
    },
    {
      id = "resources",
      name = "Resources",
      actions =
      {
        {
          id = "add_gold",
          name = "Add 1000 Gold Coins",
          action = private.Gold_Add,
          key = 67
        },
        {
          id = "reset_gold",
          name = "Reset Gold Coins",
          action = private.Gold_Null
        }
      }
    },
    {
      id = "hearts",
      name = "Hearts",
      actions =
      {
        {
          id = "restore",
          name = "Restore Heart",
          action = private.Hearts_Plus,
          key = 72
        },
        {
          id = "reset",
          name = "Reset Hearts",
          action = private.Hearts_Null
        },
        {
          id = "add_fb",
          name = "Add FaceBook Heart",
          action = private.Hearts_SocialAdd
        },
        {
          id = "reset_fb",
          name = "Reset FaceBook Hearts",
          action = private.Hearts_SocialNull
        },
        {
          id = "add_donate",
          name = "Add Donation Heart",
          action = private.Hearts_DonateAdd
        },
        {
          id = "reset_donate",
          name = "Reset Donation Hearts",
          action = private.Hearts_DonateNull
        },
        {
          id = "immortality",
          name = "Toggle Immortality",
          action = private.Hearts_Immortality
        },
        {
          id = "off_send_limit",
          name = "Reset Sent Count",
          action = private.Hearts_SendLimitOff
        },
        {
          id = "off_ask_limit",
          name = "Reset Ask Count",
          action = private.Hearts_AskLimitOff
        }
      }
    },
    {
      id = "game_session",
      name = "Game Session",
      actions =
      {
        {
          id = "time_shift_1",
          name = "Time Shift +1m",
          action = function() private.SetTimeShift( 60 ); end
        },
        {
          id = "time_shift_10",
          name = "Time Shift +10m",
          action = function() private.SetTimeShift( 600 ); end
        },
        {
          id = "time_shift_30",
          name = "Time Shift +30m",
          action = function() private.SetTimeShift( 1800 ); end
        }
      }
    },
    {
      id = "minievent",
      name = "Mini Events",
      actions =
      {
        {
          id = "minievent_complete_level",
          name = "Complete Level",
          action = private.Minievent_CompleteLevel,
          key = 87
        },
        {
          id = "minievent_enable_all_levels",
          name = "Enable All Levels",
          action = private.Minievent_EnableAllLevels
        },
        {
          id = "minievent_progress",
          name = "Reset Progress",
          action = private.Minievent_ResetProgress
        },
        {
          id = "minievent_context",
          name = "Notification On",
          action = private.Minievent_ResetNotification
        }
      }
    },
    {
      id = "other",
      name = "Other",
      actions =
      {
        {
          id = "highlight",
          name = "HighLight",
          action = private.ToggleHighLight
        },
        {
          id = "speed",
          name = "Speed",
          action = function() end
        },
        {
          id = "delta_time",
          name = "DT",
          action = function() end
        },
        {
          id = "daily_bonus",
          name = "Daily Bonus",
          action = private.DailyBonus
        },
        {
          id = "arena_timer",
          name = "Reset Arena Timer",
          action = private.DailyQuest
        },
        {
          id = "shop_timer",
          name = "Reset Shop Timer",
          action = private.RefreshShop
        },
        {
          id = "fast_carriers",
          name = "Fast Carriers",
          action = private.FastCarriers
        },
        {
          id = "all_boosters",
          name = "Get All Boosters",
          action = private.GetAllBoosts
        },
        {
          id = "all_skins",
          name = "Get All Skins",
          action = private.GetAllSkins
        },
        {
          id = "all_stickers",
          name = "Get All Stickers",
          action = private.GetAllStickers
        },
        {
          id = "player_video_attempts",
          name = "Reset Player Video Attempts",
          action = private.ResetPlayerVideoAttempts
        },
        {
          id = "player_video_timeout",
          name = "30 days video timer reset for player",
          action = private.ResetPlayerTimeoutVideoAttempts
        },
        {
          id = "add_mock_friend",
          name = "Add Mock Friend",
          action = private.AddMockFriend
        },
        {
          id = "easy_achievements",
          name = "Easy Achievements",
          action = private.EasyAchievements
        }
      }
    },
    {
      id = "toggles",
      name = "Toggles",
      actions =
      {
        {
          id = "starter_pack",
          name = "Toggle Starterpack",
          action = private.Starterpack
        },
        {
          id = "lowend_device",
          name = "Toggle Low-End Device",
          action = private.ToggleLowendDevice
        }
      }
    },
    {
      id = "progress",
      name = "Progress",
      actions =
      {
        {
          id = "enable_stages",
          name = "Enable All Levels",
          action = private.Map_EnableStagesHere
        },
        {
          id = "enable_zone",
          name = "Enable Zone",
          action = private.Map_EnableZone
        },
        {
          id = "progress_tier2",
          name = "Unlock the second tiers",
          action = private.Map_UnlockSecondTiers
        },
        {
          id = "progress_tier3",
          name = "Unlock the third tiers",
          action = private.Map_UnlockThirdTiers
        }
      }
    },
    {
      id = "potions",
      name = "Potions",
      actions = {}
    },
    {
      id = "notification",
      name = "Local Notifications",
      actions =
      {
        {
          id = "locnot_hearts",
          name = "Hearts",
          action = function () 
            private.CreateLocalNotification( "Hearts" );
          end
        },
        {
          id = "locnot_mines",
          name = "Mines",
          action = function () 
            private.CreateLocalNotification( "Mines" );
          end
        },
        {
          id = "locnot_dailyquest",
          name = "Dailyquest",
          action = function () 
            private.CreateLocalNotification( "Dailyquest" );
          end
        },
        {
          id = "locnot_comebacklevel",
          name = "Comeback Level",
          action = function () 
            private.CreateLocalNotification( "ComebackLevel" );
          end
        },
        {
          id = "locnot_comebackgame",
          name = "Comeback Game",
          action = function () 
            private.CreateLocalNotification( "ComebackGame" );
          end
        },
        {
          id = "locnot_carriers",
          name = "Carriers",
          action = function () 
            private.CreateLocalNotification( "Carriers" );
          end
        },
        {
          id = "locnot_minievent",
          name = "Minievent",
          action = function () 
            private.CreateLocalNotification( "Minievent" );
          end
        }
      }
    },
    {
      id = "ios",
      name = "iOS",
      actions =
      {
        {
          id = "show",
          name = "Show CCS Button",
          action = v_game.Cheat_ShowCCS
        },
        {
          id = "hide",
          name = "Hide CCS Button",
          action = v_game.Cheat_HideCCS
        }
      }
    },
    {
      id = "android",
      name = "Android",
      actions =
      {
        {
          id = "show",
          name = "Back Button",
          action = private.AndroidBackButton
        }
      }
    },
{
      id = "fake_events",
      name = "Fake Events",
      actions =
      {
        {
          id = "fake_last_purchase",
          name = "Fake Last Purchase",
          action = private.FakeLastPurchase
        },
        {
          id = "fake_event_daily_launch",
          name = "Fake Daily Launch",
          action = private.FakeEvent_DailyLaunch
        },
        {
          id = "fake_event_daily_launch_reset",
          name = "Reset Daily Launch",
          action = private.FakeEvent_DailyLaunchReset
        }
      }
    },
    {
      id = "fake_errors",
      name = "Fake Errors",
      actions =
      {
        {
          id = "fake_internet_error",
          name = "Network Down for 10s",
          action = private.FakeError_InternetDown
        }
      }
    },
    {
      id = "tests",
      name = "Tests",
      actions =
      {
        {
          id = "characters_anims",
          name = "Character Animation Test",
          action = private.Test_CharacterAnimation
        }
      }
    }
  }
  
  local tiers     = 3;
  local resources = 4;
  local sections  = v_sections.GetEnabledList();
  local potions   = v_potions.GetPotionsData();
  
  for _, category in pairs( private.cheats ) do
  
    -- Add "Test Tier" cheats
    if ( category.id == "stage_start" ) then
    
      for tier = 1, tiers do
      
        table.insert(
          category.actions,
          {
            id     = "test_"..tostring( tier ),
            name   = "Test Tier "..tostring( tier ),
            action = function ()
              private.Stage_PlayState( tier )
            end
          }
        );
      
      end;
    
    end;
    
    -- Add "Resources" cheats
    if ( category.id == "resources" ) then
    
      local colors = { "Yellow", "Blue", "Purple", "Red" };
    
      for res = 1, resources do
      
        table.insert(
          category.actions,
          {
            id     = "add_resource"..tostring( res ),
            name   = "Add 1000 "..colors[res].." Fireflies",
            action = function ()
              private.Resources_Add( res )
            end
          }
        );
        table.insert(
          category.actions,
          {
            id     = "reset_resource"..tostring( res ),
            name   = "Reset "..colors[res].." Fireflies",
            action = function ()
              private.Resources_Null( res )
            end
          }
        );
      
      end;
    
    end;
  
    -- Add "Open World" cheats
    if ( category.id == "progress" ) then
    
      for section = 2, #sections do
        
        local section_index = sections[ section ]:match( "%d+" );
      
        table.insert(
          category.actions,
          {
            id     = "open_section"..section_index,
            name   = "Open World "..section_index,
            action = function ()
              private.Unlock_Section( section )
            end
          }
        );
      
      end;
    
    end;
    
    -- Add "Potions" cheats
    if ( category.id == "potions" ) then
    
      for i = 1, #potions do
        local name = potions[ i ].name;
        table.insert(
          category.actions,
          {
            id     = "potion_"..name,
            name   = ne.strings.Get( "str_"..name ),
            action = function ()
              private.AddPotion( name );
            end
          }
        );
      
      end;
    
    end;
    
  end;
  
  -- Expanded categories
  private.expanded = {};

  ne.msg.Subscribe( "Event_Cheat_KeyPressed", private.Handle_Event_Cheat_KeyPressed );
  
  local condition = m_stage.GetSavedData( "stage_12" );
  
  if ( condition ) then
    v_stage.FastSaga_Deactive();
  end;

  mediator.Subscribe(
    "Model_Game_SessionTick",
    function ( params ) private.ShowSessionTime( params.duration ); end
  );  
  
end
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.stage_group = nil;
  
  private.app_w = ui.screen.Width();
  private.app_h = ui.screen.Height();
  
  local hub      = "hub_cheater";
  local scroller = "scc_cheater";
  local obj_header = "obj_cheater_header";
  local txt_header = "txt_cheater_header";
  local obj_button = "obj_cheater_button";
  local txt_button = "txt_cheater_button";
  
  local z = 0;
  
  for _, category in pairs( private.cheats ) do
  
    z = z + 1;
  
    local cat_suffix = "_"..category.id;
    
    ui.obj.Clone( obj_header, scroller, cat_suffix, true );
    ui.obj.Set( txt_header..cat_suffix, { text = " [ + ] "..category.name } );
    ui.obj.Set( obj_header..cat_suffix, { pos_z = z } );
    ui.control.EventsSet(
      obj_header..cat_suffix,
      {
        func_on_click = function ()
          private.ToggleGroupExpanded( category.id );
        end
      }
    );
    
    for _, cheat in pairs( category.actions ) do
    
      if ( not cheat.hide ) then
      
        z = z + 1;
      
        local act_suffix = cat_suffix.."_"..cheat.id;
        
        ui.obj.Clone( obj_button, hub, act_suffix, true );
        ui.obj.Set( txt_button..act_suffix, { text = " > "..cheat.name } );
        ui.obj.Set( obj_button..act_suffix, { pos_z = z } );
        ui.control.EventsSet(
          obj_button..act_suffix,
          {
            func_on_click = cheat.action
          }
        );
        
      end;
        
    end
  
  end

  local trans_obj_name = "obj_cheater_ted_hide";
  ui.obj.Create( trans_obj_name, "transparentobject", "cheater", {
    pos_z = 666,
    inputrect_init = true,
    inputrect_x = -1000,
    inputrect_y = -1000,
    inputrect_w = 2000,
    inputrect_h = 2000,
    event_mdown = private.DisableAllTed
  });
  
  private.CreateCheatSpeed();
  private.CreateABTestSettings();
  private.CreateCheatDT();
  private.ShowSessionTime( 0 );
  
  ne.msg.Subscribe( "Event_Common_ScriptError", function ( name, params )
  
    -- Set newline symbol
    local line_ends =
    {
      pc      = ";\r\n",
      ios     = ";\r",
      android = ";\n"
    };
    local nl = line_ends[ GetPlatform() ] or ";\n";
    
    local text = "";
    local function put_string ( str, no_nl )
    
      text = text..str;
      
      if ( not no_nl ) then
        text = text..nl;
      end;
    
    end;
    
    -- Setup message text
    put_string( "--------------------" );
    put_string( "Game" );
    put_string( "Version: "..VersionGetComponentVersion( "game" ) );
    put_string( "Platform: "..GetPlatform() );
    
    if ( IsAndroid() ) then
      put_string( "Android platform: "..wiz.Android.GetPlatform() );
    end;
    
    put_string( "User id: "..v_player.UserId() );
    put_string( "Server: "..ConfigGetInfo( "server.host" ) );
    
    put_string( "--------------------" );
    put_string( "Content" );
    put_string( "Version main: "..( parts.version.GetCurrent( "content_main" ) or "?" ) );
    put_string( "Version levels: "..( parts.version.GetCurrent( "content_levels" ) or "?" ) );
    
    local packages = {};
    for _, pack in pairs( ContentGetPacketList() or {} ) do
    
      local info_str = "%s:%s:%s";
      table.insert(
        packages, 
        info_str:format( pack.name, pack.hash, pack.state or "?" )
      );
    
    end;
    
    put_string( "Packages", true );
    put_string(
      common.table.ToString( packages, 0, nl, "" ), true
    );
    
    put_string( "--------------------" );
    put_string( "Social Info", true );
    put_string( common.table.ToString( SocialGetInfo(), 0, nl, "" ), true );
    
    put_string( "--------------------" );
    put_string( "Call Stack", true );
    put_string( common.table.ToString( params.callstack, 0, nl, "_ " ), true );
    put_string( "--------------------" );

    local module_name = params.callstack[ 2 ].chunkname;

    if ( _G[ module_name ] and _G[ module_name ].__Private ) then
 
      local module_private = _G[ module_name ].__Private();

      if ( module_private ) then
        put_string( "_PRIVATE: " );
        put_string( common.table.ToString( module_private, 0, nl, "_ " ), true );
        put_string( "--------------------" );
      end;

    end;
  
    -- Try send report
    local Complete = function ()
      wiz.bfg.SendEmail(
      {
        email   = "support.sir-match-a-lot@elephant-games.com",
        subject = "[ DEV ] Script Error: "..os.time(),
        body    = text
      });
    end
    
    if ( review ) then
      if ( IsAndroid() ) then
        Complete();
      else
        local screenshotName = "save/screenshot_debug";
        ne.dbg.Screenshot( screenshotName ); 
        wiz.ShowSystemMessage( {
          title   = "Are U sure?",
          body    = "Are you sure you want to send the report to Mantis?",
          buttons =
          {
            {
              title = "Absolutely sure",
              action = function ()
                review.SendToMantis( screenshotName, "Crash log", text );
                Complete();
              end
            },
            {
              title = "I don't care",
              action = Complete
            }
          }
        } );
      end;
    end;
  end );

end;
--------------------------------------------------------------------------------
function private.Handle_Event_Cheat_KeyPressed ( msg, params )
  
  local params = params or {};
  local key    = params.key or 0;

  --DbgTrace( key )

  -- JK: game speed up on +
  if ( key == 187 ) then

    local func_Plus =
      ObjGet( "txt_cheater_button_other_speed_plus" ).event_mdown;

    if ( type( func_Plus ) == "function" ) then

      func_Plus();

    end;

    return;

  end;

  -- JK: game speed down on -
  if ( key == 189 ) then

    local func_Minus =
      ObjGet( "txt_cheater_button_other_speed_minus" ).event_mdown;

    if ( type( func_Minus ) == "function" ) then

      func_Minus();

    end;

    return;

  end;

  -- JK: game speed reset on 0
  if ( key == 48 ) then

    local dt = -1;

    ne.dbg.SetFixedDT(dt);
    private.dt = nil;
    ObjSet( "txt_cheater_button_other_speed_current", { text = "" } );

  end;

  for _, category in pairs( private.cheats ) do
    for _, cheat in pairs( category.actions ) do
      if ( cheat.key and cheat.key == key ) then
        if ( not category.id:find( "stage" ) or
             private.stage_group == category.id ) then
          cheat.action();
        end; 
      end;
    end;
  end;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.ToggleGroupExpanded ( category_id )

  local obj_pattern = "obj_cheater_button_%s_%s"
  local header_prefix; 
  local attach_target;

  if ( private.expanded[ category_id ] ) then
  
    private.expanded[ category_id ] = false;
    attach_target = "hub_cheater";
    header_prefix = " [ + ] ";
  
  else
  
    private.expanded[ category_id ] = true;
    attach_target = "scc_cheater";
    header_prefix = " [ - ] ";
  
  end;
  
  for _, category in pairs( private.cheats ) do
    if ( category.id == category_id ) then
    
      ui.obj.Set(
        "txt_cheater_header_"..category.id,
        {
          text = header_prefix..category.name
        }
      );
    
      for _, cheat in pairs( category.actions ) do
      
        if ( not cheat.hide ) then
          local obj_name = obj_pattern:format( category.id, cheat.id )
          ui.obj.Attach( obj_name, attach_target );
          if ( cheat.id == "delta_time" ) then
            private.UpdateCheatDt();
          end;
        end;
      
      end;
      break;
    
    end;
  end;
  
  local scc_params = ui.obj.Get( "scc_cheater" );
  local capacity = math.floor( scc_params.inputrect_h / scc_params.cellsize );
  
  local items = ObjGetRelations( "scc_cheater" ).childs;
  for i = 1, #items do
  
    if ( items[ i ] == "obj_cheater_header_"..category_id ) then
    
      local pos     = i - 1;
      local pos_max = math.max( #items - capacity, 0 )
    
      ui.obj.Set( "scc_cheater", { scrollpos = math.min( pos, pos_max ) } );
      break;
    
    end;
  
  end;

end 
--------------------------------------------------------------------------------
function private.SetGroupActive ( category_id, state )
  
  for _, category in pairs( private.cheats ) do
    if ( category.id == category_id ) then
    
      for _, cheat in pairs( category.actions ) do
        if ( not cheat.hide ) then
          private.SetCheatActive( category.id, cheat.id, state, cheat.action );
        end;
      end;
      break;
    
    end;
  end;

end
--------------------------------------------------------------------------------
function private.SetCheatActive ( category_id, cheat_id, state, func_action )

  local obj_pattern = "obj_cheater_button_%s_%s"
  local obj_name = obj_pattern:format( category_id, cheat_id )
  
  local alp = 1.0;
  
  if ( state ) then
  
    ui.control.EventsSet( obj_name, { func_on_click = func_action } );
  
  else
  
    alp = 0.5;
    ui.control.EventsClear( obj_name );
  
  end;
  
  ui.obj.Set( obj_name, { alp = alp } );

end
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ()
  
  ne.mod.LoadLazily( "assets/cheater/mod_review" );
  
  ObjAttach( "cheater", InterfaceName );
  
  private.Defaults_Set();
  private.Subscribe();
  
  -- Add hook after screen open
  local function func_opened_hook ( screen_name )

    local messages = {
      scr_map   = "View_Cheater_MapOpened",
      scr_stage = "View_Cheater_StageOpened"
    };

    if ( messages[ screen_name ] ) then
      
      mediator.Notify( messages[ screen_name ] );
      
    end;
  
  end;

  mediator.Subscribe( v_screen.Notifications.ScreenOpened, func_opened_hook );

  private.ShowDrawCalls();
  private.ShowFPS();
  private.SetOnlineState( v_game.IsOnline() );
  private.SetDebugState( debug );
  private.UpdateABTestGroups();

  mediator.Subscribe( "Interface_ButtonPressed", private.ShowButtonPressed );
  mediator.Subscribe( "Interface_ButtonAction", private.ShowButtonPressed );
  mediator.Subscribe( "Interface_ButtonReleased", private.ShowButtonPressed );
  private.ShowButtonPressed();
  
  mediator.Subscribe( m_game.msg.ConnectRestored, function () 
    private.SetOnlineState( true );
  end );
  
  mediator.Subscribe( m_game.msg.ConnectLost, function () 
    private.SetOnlineState( false );
  end );

  private.SetStateButtons( false );
  
end;
--------------------------------------------------------------------------------
function private.SetStateButtons ( state )
  
  ne.obj.Set( "btn_cheater_bug", { input = state, visible = state } );
  ne.obj.Set( "btn_cheater_remark", { input = state, visible = state } );
  
end;
--------------------------------------------------------------------------------
function public.ShowSilentContent ( state )

  local txt_name = "txt_silent_content_notification";

  ui.obj.Create( txt_name, "text" );
  
  ui.obj.Set(
    txt_name,
    {
      res = "assets/fonts/sml_desc",
      fontsize = 20,
      fontcolor_r = 1.0,
      fontcolor_g = 1.0,
      fontcolor_b = 1.0,
      display_outline = true,
      outline_size = 2.0,
      outline_color_r = 0.0,
      outline_color_g = 0.0,
      outline_color_b = 0.0,
      pos_x = ui.screen.Width()  * 0.5,
      pos_y = 20,
      pos_z = 800,
      disprawtext = true,
      text  = "silent content "..tern( state )( "ready", "not ready" )
    }
  );
  
  ui.obj.Attach( txt_name, InterfaceName );
  
  mediator.Subscribe(
    lib_content.msg.DownloadProgress,
    function ( p )
    
      local text = "silent downloading (%s/%s): %s %s%%";
      ui.obj.Set(
        txt_name,
        {
          text = text:format( p.current, p.total, p.name, p.progress )
        }
      );
    
    end
  );
  
  mediator.Subscribe(
    lib_content.msg.UnpackProgress,
    function ( p )
    
      local text = "silent unpacking (%s/%s): %s %s%%";
      ui.obj.Set(
        txt_name,
        {
          text = text:format( p.current, p.total, p.name, p.progress )
        }
      );
    
    end
  );
  
  mediator.Subscribe(
    lib_content.msg.DownloadStarted,
    function ()
    
      ui.obj.Set(
        txt_name,
        {
          text = "silent download started"
        }
      );
    
    end
  );
  
  mediator.Subscribe(
    lib_content.msg.DownloadFinished,
    function ( result )
    
      ui.obj.Set(
        txt_name,
        {
          text = "silent downloading "..tern( result )( "succeeded", "failed" )
        }
      );
    
    end
  );
  
end;
--------------------------------------------------------------------------------
function private.ShowSessionTime ( seconds )

  ui.obj.Set(
    "txt_cheater_session_time",
    {
      text = "Session: "..ui.text.FormatTime( seconds )
    }
  );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Cheater_Bug()
  review.Switch(true);
  private.SetStatePanel();
  private.review_active = not private.review_active;
end;
--------------------------------------------------------------------------------
function private.Cheater_Remark()
  review.Switch(false);
  private.SetStatePanel();
  private.review_active = not private.review_active;
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Defaults_Set ()

  private.SetGroupActive( "in_stage",    false );
  private.SetGroupActive( "stage_start", false );

  local version = VersionGetComponentVersion( "game" );
  local user_id = v_player.UserId();
  local server  = ConfigGetInfo( "server.host" );
  
  local abtest = "";
  if ( v_player.IsAbtestParticipant() ) then
    local settings_variant = v_game.GetSettingsVariant();
    abtest = " | AB: "..settings_variant;
  end;

  ObjMultiSet( {
    { "cheater",                   { pos_x = private.app_w - 60, pos_y = ui.screen.TopSafeArea() } },
    { "btn_cheater",               { pos_x =  - private.app_w + 52, pos_y = -8, event_mdown = private.Cheater_Switch } },
    { "btn_cheater_bug",           { event_mdown = private.Cheater_Bug } },
    { "btn_cheater_remark",        { event_mdown = private.Cheater_Remark } },
    
    { "obj_cheater_info",          { pos_x = - private.app_w / 2 + 60, pos_y = private.app_h - 30 - ui.screen.BottomSafeArea() - ui.screen.TopSafeArea() } },
    { "obj_cheater_info_drawcalls",{ pos_x = 60 - private.app_w } },
    { "obj_cheater_info_fps",      { pos_x = 60 - private.app_w + 80 } },
    { "obj_cheater_info_online",   { pos_x = 60 - private.app_w + 140 } },
    { "obj_cheater_info_debug",    { pos_x = 60 - private.app_w + 200 } },
    { "obj_cheater_info_button",   { pos_x = 60 - private.app_w, pos_y = 45 } },
    { "txt_cheater_info",          { text = "User ID: "..user_id..abtest.." | "..server.." | ver. "..version } },
    
  } );
  
end;
--------------------------------------------------------------------------------
function private.Subscribe ()

  mediator.Subscribe( "View_Cheater_MapOpened",   private.Map_OnOpened );
  mediator.Subscribe( "View_Cheater_StageOpened", private.Stage_OnOpened );

  mediator.Subscribe( "Interface_Window_WindowOpened", private.WindowOpened );
  mediator.Subscribe( "Interface_Window_WindowClosed", private.WindowClosed );

  mediator.Subscribe(
    "View_Stage_DialogStartActivated",
    private.DialogStartOpened
  );

  mediator.Subscribe(
    "View_Stage_DialogStartDeactivated",
    private.DialogStartClosed
  );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Map_OnOpened ()

  --DbgTrace( "[ INFO ][ cheater ] private.Map_OnOpened" );

  private.stage_group = nil;
  
  private.SetGroupActive( "in_stage", false );
  private.SetGroupActive( "progress", true  );

end;
--------------------------------------------------------------------------------
function private.Stage_OnOpened ()
  
  --DbgTrace( "[ INFO ][ cheater ] private.Stage_OnOpened" );

  private.stage_group = "in_stage";

  private.SetGroupActive( "in_stage", true  );
  private.SetGroupActive( "progress", false );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.WindowOpened ( name )

  if ( name == "int_dialog_stage_start"     ) or 
     ( name == "int_dialog_minievent_start" ) then
    
    if ( v_screen.GetCurrentName():find( "map" ) ) then

      private.stage_group = "stage_start";
      private.SetGroupActive( "stage_start", true );

    end;

  end;

end;
--------------------------------------------------------------------------------
function private.WindowClosed ( name )

  if ( name == "int_dialog_stage_start"     ) or 
     ( name == "int_dialog_minievent_start" ) then
    
    if ( v_screen.GetCurrentName():find( "map" ) ) then
     
      private.stage_group = nil;
      private.SetGroupActive( "stage_start", false );
    
    end;

  end;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.DialogStartOpened ( params )

  private.dialog_start_stage_name = params.name;

end;
--------------------------------------------------------------------------------
function private.DialogStartClosed ()

  private.dialog_start_stage_name = nil;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Cheater_Switch ()

  if ( private.review_active ) then
    return;
  end;
  
  if not ( private.active ) then
    private.SetStateButtons( true );
    private.SetStatePanel( true );
  else
    private.SetStateButtons( false );
    private.SetStatePanel( false );
  end;

  private.active = not private.active;

end;
--------------------------------------------------------------------------------
function private.SetStatePanel ( state )
  
  private.active_panel = state or ( not private.active_panel );
  local state_panel = private.active_panel;
  
  ObjSet( "obj_cheater",          
  { 
    active = state_panel, 
    visible = state_panel, 
    input = state_panel 
  } );
  ObjSet( "obj_cheater_info",     
  { 
    active = state_panel, 
    visible = state_panel 
  } );
  ObjSet( "obj_cheater_info_top", 
  { 
    active = state_panel, 
    visible = state_panel, 
    input = state_panel 
  } );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Gold_Add ()

  v_player.Gold_TryChangeCount( 1000 );

end;
--------------------------------------------------------------------------------
function private.Gold_Null ()

  v_player.Gold_TryChangeCount( - v_player.Gold_GetCount() );

end;
--------------------------------------------------------------------------------
function private.Resources_Add ( id )

  v_player.Resource_TryChangeCount( "resource"..id, 1000 );

end;
--------------------------------------------------------------------------------
function private.Resources_Null ( id )

  local resource = "resource"..id;
  local count = v_player.Resource_GetCount( resource );
  
  v_player.Resource_TryChangeCount( resource, -count );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Stage_Win ()

  v_stage.ChainActivatedOnce();
  v_stage.Cheat_Win();

end;
--------------------------------------------------------------------------------
function private.Stage_Fail ()

  v_stage.ChainActivatedOnce();
  v_stage.Cheat_Fail();

end;
--------------------------------------------------------------------------------
function private.Stage_Autoplay ()
  
  common.mod.Load( "bot" );
  bot.Init();
  bot.Start();

  v_interface.ShowNotification( "Human, let robot do it for you!" );

end;
--------------------------------------------------------------------------------
function private.Stage_Reload()
  ne.msg.Send( "Cheat_Stage_Reload", {} );
end;
--------------------------------------------------------------------------------
function private.Stage_PlayState ( stage_state )

  if ( not private.dialog_start_stage_name ) then

    return;

  end;

  lib_db.Database_SetRO();

  local func_end = function ()

    v_stage.TryStart(
      private.dialog_start_stage_name,
      nil,
      stage_state
    );

  end;

  v_stage.Cheater_DialogStart_Hide( func_end, true );

  mediator.SubscribeOnce(
    "View_Map_Update_Triggered",
    function ()

      m_map.ChangeList_Clear();
      v_map.AppearClearAllQueue();

      lib_db.Database_SetRW();

    end
  );

end;
--------------------------------------------------------------------------------
function private.Stage_UseBoosterHammer ()
  
  common.MessageSend(
    Event_Match3_BoosterActivated,
    {
      name     = "hammer",
      row      = nil,
      col      = nil,
      vertical = nil }
  );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.ToggleHighLight()
  ne.dbg.FireInputEvent(1, 1, 0,                9,        9);
  --                          nE_IE_KEYPRESSED, nE_K_TAB, nE_K_TAB
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.DailyBonus ()
  
  v_dailybonus.Refresh();
  v_dailybonus.Dialog_TryShow();

end;
--------------------------------------------------------------------------------
function private.DailyQuest ()
  
  if ( _G.v_dailyquest ) then

    v_dailyquest.Cheater_Refresh();

  else

    v_interface.ShowNotification( "Arena is not available yet." );

  end;

end;
--------------------------------------------------------------------------------
function private.RefreshShop ()
  
  v_shop.Market_CheaterRefresh();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Minievent_CompleteLevel ()

  if ( v_minievent                           ) and
     ( not v_minievent.Cheat_CompleteLevel() ) then

    --v_interface.ShowNotification( "Minievent is not available." );
  
  end;

end;
--------------------------------------------------------------------------------
function private.Minievent_EnableAllLevels ()

  if ( not v_minievent_section.Cheat_EnableAllLevels() ) then

    --v_interface.ShowNotification( "Minievent is not available." );
  
  end;

end;
--------------------------------------------------------------------------------
function private.Minievent_ResetProgress ()

  if ( v_minievent.Cheat_ResetEventProgress() ) then

    --v_interface.ShowNotification( "Minievent progress reset to 1st stage." );
  
  else
  
    v_interface.ShowNotification( "Minievent is not available." );
  
  end;

end;
--------------------------------------------------------------------------------
function private.Minievent_ResetNotification ()

  local is_reset = v_minievent.Cheat_ResetNotification();

  if ( is_reset ) then

    v_interface.ShowNotification(
      "A dialog will show up on restart."
    );

  else

    v_interface.ShowNotification(
      "Failed to reset the notification."
    );

  end;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Map_WinAllStates ()

  local function func_end ()

    local stage_name = int_dialog_stage_start.GetStageName();
    local stage_data = v_stage.Cheater_GetStartData( stage_name );

    local pick_quest_item = false; -- Pick only questitem reward

    if ( stage_data.noreward ) then 

      if ( private.HasQuestItemReward( stage_data.reward ) ) then
        pick_quest_item = true;
      else
        return false;
      end;

    end;

    v_interface.Hide();

    -- Max state
    local state_max = math.min( stage_data.states, 3 );
    
    -- Collectable rewards range
    local state_from = stage_data.state;
    local state_to   = state_max;

    if ( stage_data.stateless ) then
      state_to = 1;
    end;

    if ( stage_data.type == "fight" ) then
      state_to = state_from;
    end;

    -- Collect rewards
    local rewards   = stage_data.reward;
    local collected = {};
    local collected_gold = 0;

    for state = state_from, state_to do

      -- Notify about completed fight
      if ( stage_data.type == "fight" ) then

        mediator.Notify(
          "View_Stage_EnemyDefeated", 
          { name = stage_data.enemy.name }
        );

      end;

      -- Notify about completed stage
      local no_reward = nil;

      local notify_state_from = state;
      local notify_state_to   = state + 1;

      if ( notify_state_to > state_max ) then

        notify_state_to = state_max;
        no_reward = true;

      end;
      
      local enabled = true;
      local completed   = true;
      local enable_next = true;
      local saved_type  = nil

      if ( stage_data.realtype == "misc" ) and ( stage_data.type == "fight" ) then

        notify_state_from = 4;
        notify_state_to   = 1;
        no_reward = nil;

        enable_next = false;
        completed   = false;

        saved_type  = "ride";
        
      elseif ( stage_data.realtype == "fight" ) then

        notify_state_to = 1;
        enabled = false;

      end;

      -- Update save
      local query =
      {
        query      = "update",
        group      = "player",
        collection = "stages",
        indice     = "name",
        criteria   = { like = stage_name },
        set        = {
                       completed = completed,
                       score     = 99999,
                       state     = notify_state_to,
                       noreward  = no_reward,
                       type      = saved_type,
                       enabled   = enabled
                     }
      };

      lib_db.Execute( query );
      
      loader.Module_LoadChain( true, nil, function () end );

      local notify_data = 
      { 
        name        = stage_name,
        type        = stage_data.realtype,
        state_old   = notify_state_from,
        state_new   = notify_state_to,
        noreward    = stage_data.noreward,
        enable_next = enable_next
      };

      mediator.Notify( "Model_Stage_StageWon", notify_data );

      -- Obtain rewards
      local state_rewards = rewards[ state ];
      for i = 1, #state_rewards do

        local reward = state_rewards[ i ];

        if ( pick_quest_item ) then

          if ( reward.type == "quest" ) then
            mediator.Notify( "Model_Stage_QuestItemDropped", 
                             { name = reward.name, stage = stage_name } );

            table.insert( collected, reward );

          end;

        else
          if ( reward.type ) then

            if ( reward.type == "quest" ) then

              mediator.Notify(
                "Model_Stage_QuestItemDropped", 
                {
                  name  = reward.name,
                  stage = stage_name
                }
              );

            elseif ( reward.type == "worker" ) then

              --DbgTrace( "Worker collected in visual changes" );

            elseif ( reward.type == "gold" ) then

              collected_gold = collected_gold + reward.count;

            elseif ( reward.name == "spellbook" ) then

              --DbgTrace( "Spellbook is not directly obtainable" );

            else

              reward.stage_name = stage_name;
              reward.stage_state = notify_state_from;

              v_items.TryObtain( reward );

            end;

            table.insert( collected, reward );

          end;
        end;
        
      end;

      -- Show merged reawrds at last iteration
      if ( state == state_to ) then

        -- Append resources
        for i, chip_name in pairs( stage_data.resources ) do

          local res_id = tonumber( chip_name:match( "%d+" ) );
          if ( res_id ) then

            local res_reward = 
            {
              type       = "resource",
              name       = "resource"..res_id,
              count      = math.random( 1, 50 ),
              stage_name = stage_name,
              stage_state = notify_state_from
            };
    
            v_items.TryObtain( res_reward );
            table.insert( collected, res_reward );

          end;

        end;

        -- Append merged gold
        if ( collected_gold > 0 ) then

          local gold_reward =
          { 
            name       = "gold",
            type       = "gold",
            count      = collected_gold,
            stage_name = stage_name,
            stage_state = notify_state_from
          };

          v_items.TryObtain( gold_reward );

        end;

        local is_first = ( ( state_from == 1 ) or ( state_from == 4) );
        
        if ( is_first ) then
      
          v_player.Progress_SetLastStageName(
            stage_name,
            v_sections.Section_NameCurrent(),
            true
          );
        
        end;
        
        v_map.ChangeList_Prepare(
          stage_name,
          is_first,
          private.MergeRewards( collected ),
          no_reward,
          enable_next
        );

        -- Tutorials hook
        mediator.Notify( "View_Tutorial_MapOpened" );

        v_map.Cheater_Update();

      end;

    end;
    
    common.Save( true );

    return true;

  end;

  v_stage.Cheater_DialogStart_Hide( func_end );
  
end;
--------------------------------------------------------------------------------
function private.MergeRewards ( rewards, resources )

  local states_rewards = common.table.DeepCopy( rewards );

  local merged_rewards = {};
  local collected =
  {
    gold  = nil,
    items = {}
  };

  for s = 1, #states_rewards do

    local reward = states_rewards[ s ];

    if ( reward.type == "gold" ) then

      if not ( collected.gold ) then
        collected.gold = reward;
      else
        collected.gold.count = collected.gold.count + reward.count;
      end;

    elseif ( reward.type == "resource" ) then

      -- NOTE: Resources already merged
      table.insert( merged_rewards, reward );

    else

      table.insert( collected.items, reward );

    end;

  end;

  if ( collected.gold ) then
    table.insert( merged_rewards, collected.gold );
  end;

  if ( #collected.items > 0 ) then

    table.insert( merged_rewards, collected.items[ 1 ] );

    if ( #collected.items > 1 ) then

      DbgTrace( "[ ERROR ][ CHEATER ] More then one item in rewards!" );
      DbgTrace( collected.items );

    end;

  end;

  return merged_rewards;

end;
--------------------------------------------------------------------------------
function private.HasQuestItemReward ( states_rewards )

  for state = 1, #states_rewards do

    local state_rewards = states_rewards[ state ];
    for reward = 1, #state_rewards do

      if ( state_rewards[ reward ].type == "quest" ) then
        return true;
      end;

    end;

  end;

  return false;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Unlock_Section ( section_number )

  if ( lib_db.Database_IsFreeze() ) then
    v_interface.ShowNotification( "Further progress won't be saved." );
    return;
  end;
  
  local result, value = parts.storage.data.Read( "sml/allow_sections" );
  
  if ( tonumber( value ) >= section_number ) then
    return;
  end;
  
  for s = 1, section_number do

    local section_name = string.format( "section_%s", s );

    if ( not v_sections.Section_IsEnabled( section_name ) ) then
      
      v_sections.Cheat_Unlock( section_name );
      v_player.Resource_ClearAllForSection( section_name );
      
    end;
      
    if ( s < section_number ) then

      v_sections.Section_SetIntro( section_name, true );
      v_sections.Section_SetOutro( section_name, true );
      private.EnableStages( section_name );

    end;
    
    if ( s == section_number ) then

      local stage_name = v_sections.Section_FirstStage( section_name );

      v_player.Progress_SetLastStageName( stage_name, section_name );
      v_stage.Stage_TryEnable( stage_name );

    end;

  end;

  v_game.Section_SetAllowedCount( section_number );

  -- Complete some tutorials
  local tutorials = { "worldmap" };

  for i = 1, #tutorials do

    local tutorial = tutorials[ i ];

    if not ( v_tutorial.IsCompleted( tutorial ) ) then
      v_tutorial.Complete( tutorial );
    end;

  end;

  common.Return( true );

end;
--------------------------------------------------------------------------------
function private.Map_EnableStagesHere ()

  private.EnableStages( v_sections.Section_NameCurrent() );
  common.Return( true );

end;
--------------------------------------------------------------------------------
function private.EnableStages ( section_name )
 
  local stages = v_stage.Stage_GetAllBySection( section_name, true );

  if ( stages ) then

    for _, stage in pairs( stages ) do
      
      v_stage.Stage_TryEnable( stage.name, true );

    end;

    private.Unlock_Characters( section_name );
    private.Unlock_Boosters( section_name );

  end;

end;
--------------------------------------------------------------------------------
function private.Unlock_Boosters ( section_name )

  local section_chests = v_chests.List_OnSection( section_name );

  if ( section_chests ) then

    for c = 1, #section_chests do

      v_boosters.Unlock( section_chests[ c ].content.name );

    end;

  end;

end;
--------------------------------------------------------------------------------
function private.Unlock_Characters ( section_name )

  local section_characters = v_characters.GetAllInSection( section_name );

  if ( section_characters ) then

    for _, character in pairs( section_characters ) do

      v_characters.Character_Unlock( character.name );

    end;

  end;

end;
--------------------------------------------------------------------------------
function private.Map_UnlockSecondTiers ()
  
  local section_name = v_sections.Section_NameCurrent();
  private.EnableStages( section_name );
  private.UnlockSecondStages( section_name );
  common.Return( true );
  
end;
--------------------------------------------------------------------------------
function private.UnlockSecondStages ( section_name )
  
  local stages = v_stage.Stage_GetAllBySection( section_name, true );

  if ( stages ) then
    for _, stage in pairs( stages ) do
      local stage_data = v_stage.Cheater_GetStartData( stage.name );
      local set_data = 
      {
        score     = 99999,
        state     = 2,
        completed = true
      }
      
      if ( stage_data.realtype == "misc" ) and ( stage_data.type == "fight" ) then
        set_data.type = "ride";
      elseif ( stage_data.realtype == "fight" ) then
        set_data.state = 1;
        set_data.noreward = true;
      end;
      
      if ( not stage_data.noreward ) then
        local query =
        {
          query      = "update",
          group      = "player",
          collection = "stages",
          indice     = "name",
          criteria   = { like = stage.name },
          set        = set_data
        };
        lib_db.Execute( query );
      end;
      
    end;
  end;
  
end;
--------------------------------------------------------------------------------
function private.Map_UnlockThirdTiers ()
  
  local section_name = v_sections.Section_NameCurrent();
  private.EnableStages( section_name );
  private.UnlockThirdStages( section_name );
  common.Return( true );
  
end;
--------------------------------------------------------------------------------
function private.UnlockThirdStages ( section_name )
  
  local stages = v_stage.Stage_GetAllBySection( section_name, true );

  if ( stages ) then
    for _, stage in pairs( stages ) do
      local stage_data = v_stage.Cheater_GetStartData( stage.name );
      local set_data = 
      {
        score     = 99999,
        state     = 3,
        completed = true
      }
      
      if ( stage_data.realtype == "misc" ) and ( stage_data.type == "fight" ) then
        set_data.type = "ride";
      elseif ( stage_data.realtype == "fight" ) then
        set_data.state = 1;
        set_data.noreward = true;
      end;

      if ( not stage_data.noreward ) then
        local query =
        {
          query      = "update",
          group      = "player",
          collection = "stages",
          indice     = "name",
          criteria   = { like = stage.name },
          set        = set_data
        };
        lib_db.Execute( query );
      end;
      
    end;
  end;
  
end;
--------------------------------------------------------------------------------
function private.Map_EnableZone ()

  if ( not v_map.IsActive() ) then

    v_interface.ShowNotification( "The cheat works on map only." );

    return;

  end;

  if ( v_interface.window.IsOnScreen( "int_dialog_tutorial" ) ) then

    v_interface.ShowNotification( "Complete the tutorial." );

    return;

  end;

  local function func_ListEnabled ( section_name )

    local stages_list =
      v_stage.Stage_GetAllBySection( section_name, true ) or {};

    local stages_enabled = {};
    local stages_misc    = {};
    
    for _, stage in pairs( stages_list ) do

      if ( stage.type == "misc" ) then

        table.insert( stages_misc, stage.name );

      end;

      local stage_data = v_stage.Stage_StorageData( stage.name );

      if ( stage_data ) and (
          ( stage_data.enabled   ) or
          ( stage_data.completed )
         ) then
      
        table.insert( stages_enabled, stage.name );
      
      end;
    
    end;
    
    return stages_enabled, stages_misc;

  end;

  local section_number = v_sections.Section_NumberCurrent();
  local section_name   = "section_"..section_number;

  local enabled_stages, misc_stages = func_ListEnabled( section_name );

  local common_filtered = {};

  for _, stage_name in pairs( enabled_stages ) do

    local is_bonus_stage = stage_name:find( "bonus" );

    if ( not is_bonus_stage ) then

      table.insert( common_filtered, stage_name );

    end;

  end;

  enabled_stages = common_filtered;

  local last_enabled_stage = enabled_stages[ #enabled_stages ];

  local rel_number = v_stage.Number_Relative( section_name, last_enabled_stage );

  if ( rel_number == 110 ) then
    v_interface.ShowNotification( "The world is fully unlocked." );
    return;
  end;

  if ( private.zone_processing ) then
    v_interface.ShowNotification( "Working, please wait!" );
    return;
  end;

  ui.screen.Lock( true );
  private.zone_processing = true;

  local last_number     = string.match( last_enabled_stage, "%d+" );
  local next_number     = tonumber( last_number ) + 1;
  local next_stage_name = string.gsub( last_enabled_stage, last_number, next_number );

  rel_number = v_stage.Number_Relative( section_name, next_stage_name );

  local unlock_range     = {};
  local zone_misc_stages = {};

  local function func_EnableRange ( range )
    for s = range.first, range.last do
      local stage_name = "stage_"..s;
      if ( common.IsEntityInList( misc_stages, stage_name ) ) then
        table.insert( zone_misc_stages, stage_name );
      end;
      v_stage.Stage_TryEnable( stage_name, true );
    end;
  end;

  local function func_Finish ()
    ui.screen.Lock( false );
    private.zone_processing = false;
  end;

  local zone_build;

  if ( rel_number >= 12 ) then

    local builds = v_builds.GetAllInSection( section_name, true );

    for _, build in pairs( builds ) do

      local build_data = v_builds.Build_GetData( build.name );
      local unlocklist  = build_data.unlocklist;

      if ( unlocklist                    ) and
         ( unlocklist.type == "common"   ) and
         ( next_number >= unlocklist.min ) and
         ( next_number <= unlocklist.max ) then

        zone_build = build_data;

        unlock_range = {
          first = next_number,
          last  = unlocklist.max
        };

        break;

      end;

    end;

  else

    unlock_range = {
      first = next_number,
      last  = v_stage.Number_RelativeToAbsolute( section_name, 11 )
    };

  end;

  v_stage.Stateless_Check();
  
  -- JK: unlock character in zone
  if ( type( zone_build ) == "table" ) then
    local character = v_characters.GetCharacterByBuild( zone_build.name );
    if ( character ) then
      v_characters.Character_Unlock( character.name );
    end;
  end;

  func_EnableRange( unlock_range );

  v_map.Focus(
    "obj_map_point_stage_"..unlock_range.first,
    {      
      func_after = function ()

        v_map.Focus( "obj_map_point_stage_"..unlock_range.last, { time = 4 } );

        if ( rel_number >= 12 ) then

          v_map.Stages_UpdateByBuild( zone_build, func_Finish );

        else

          v_map.Zone_ShowCascade(
            unlock_range.first,
            unlock_range.last,
            func_Finish,
            "common"
          );

        end;

      end
    }
  );

  if ( #zone_misc_stages > 0 ) then

    for f = 1, #zone_misc_stages do

      local misc_stage = zone_misc_stages[ f ];
      local fight_data = v_fights.Fight_Data( misc_stage );
      local enemy      = fight_data.enemy;

      local obj_enemy = ( "obj_map_enemy_%s_%s" ):format( enemy, misc_stage );

      if ( not ui.obj.Exists( obj_enemy ) ) then
      
        ui.obj.Clone( 
          "obj_map_enemy_"..enemy,
          "obj_map_enemy_"..misc_stage,
          "_"..stage,
          1
        );
        
        local params = ui.obj.Get( obj_enemy );

        ui.obj.Set(
          obj_enemy,
          {
            input       = false,
            inputrect_x = 0.5 * params.inputrect_x,
            inputrect_y = 0.5 * params.inputrect_y,
            inputrect_w = 0.5 * params.inputrect_w,
            inputrect_h = 0.5 * params.inputrect_h
          }
        );

      end;

      if ( not ui.obj.IsVisible( obj_enemy ) ) then

        ui.obj.Set(
          "obj_map_enemy_"..enemy.."_"..misc_stage,
          {
            visible = true,
            alp     = 0
          }
        );

        ui.anim.Play(
          "anm_map_point_enemy_"..enemy.."_"..misc_stage,
          "static_fight"
        );

        ui.anim.FadeIn( 3, "obj_map_enemy_"..enemy.."_"..misc_stage );

      end;

    end;

  end;
  
  local section_chests = v_chests.List_OnSection( section_name );

  if ( section_chests ) then

    for c = 1, #section_chests do

      local chest_data         = section_chests[ c ];
      local chest_stage_number = tonumber( string.match( chest_data.stage, "%d+" ) );
      
      if ( chest_stage_number >= unlock_range.first ) and
         ( chest_stage_number <= unlock_range.last  ) then
      
        v_boosters.Unlock( chest_data.content.name );
      
      end;

    end;

  end;

end;
--------------------------------------------------------------------------------
function private.Reset ()

  -- Clear timers and watches.
  local _, time_string = parts.storage.data.Read( "parts/time" );
  local time_collection = wiz.json.Decode( time_string );

  for t = 1, #time_collection.callbacks do
    local timer = time_collection.callbacks[ t ].token;
    parts.time.event.Finish();
    parts.time.event.Unshedule( timer );
  end;

  for w = 1, #time_collection.watches do
    local watch = time_collection.watches[ w ].token;
    parts.time.watch.Stop( watch );
  end;

  -- JK: keep hearts data
  local hearts_data = lib_db.Player.Info().hearts;

  -- JK: clear collections
  local collections = ConfigGetTable( "parts.db" ).writable_collections;

  -- JK: force attach database
  lib_db.Database_Attach();

  for i = 1, #collections do

    local collection = collections[ i ];

    local delete_query = 
    {
      query      = "delete_all",
      collection = collection.name
    };

    lib_db.DbExecute( delete_query );

    if ( #collection.items > 0 ) then

      for j = 1, #collection.items do

        local insert_query = 
        {
          query      = "insert",
          collection = collection.name,
          value      = collection.items[ j ]
        };

        lib_db.DbExecute( insert_query );

      end;

    end;

  end;
  
  -- Restore facebook hearts.
  if ( hearts_data.facebook > 0 ) then

    hearts_data.count  = 3 + hearts_data.facebook;
    
    local hearts_query =
    {
      query      = "update",
      group      = "player",
      collection = "info",
      set        = { hearts = hearts_data }
    };

    lib_db.Execute( hearts_query );

  end;

  parts.storage.data.Write( "sml/allow_sections", 1 );

  common.Return( true );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.GetAllSkins ()

  local skins = v_player.Skin_GetAllSkins();

  for i, skin in pairs( skins ) do

    if not ( skin.wearable ) then

      local total     = skin.parts or 0;
      local collected = skin.collected_parts or 0;

      if ( collected < total ) then

        local name = skin.name .. "_item";
        local what = "skinpart";
        local count = total - collected;

        for item = 1, count do

          v_items.TryObtain( name, what, 1 );

        end;

      elseif ( skin.price ) then
        
        m_player.Skin_Purchase( skin.name );
        
      end;

    end;

  end;

  v_interface.ShowNotification( "All skins unlocked." );

end;
--------------------------------------------------------------------------------
function private.GetAllStickers ()

  v_fireflies.Cheat_GetAllStickers();
  v_interface.ShowNotification( "All stickers unlocked." );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.ResetPlayerVideoAttempts ()
  
  v_player.UpdateAttemptsVideo( 0 );
  
end;
--------------------------------------------------------------------------------
function private.ResetPlayerTimeoutVideoAttempts ()
  
  v_player.UpdateVideoDataDays( false );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.GetAllBoosts()

  local boosters = v_boosters.List();
  
  for id, booster in pairs( boosters ) do
  
    v_boosters.Unlock( booster.name );
    v_items.TryObtain( booster.name, "booster", 999 );
  
  end;

  v_interface.ShowNotification( "All boosters unlocked." );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.SetNoDBMode ()
  
  if ( lib_db.Database_Detach() ) then
  
    private.SetCheatActive( "save", "freeze", false );
    v_interface.ShowNotification( "Further progress won't be saved." );

  end;
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.AddPotion ( potion_name )
  
  v_potions.AddPotion( potion_name, 1 );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Autotest ()
  
  private.Autotest_Start();
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.CreateLocalNotification ( name )
  
  local stage_name = v_sections.Stage_GetLastEnabled();

  local fake_notifications = {
    Hearts = {
      type = "hearts_restored", 
      time = 5
    },
    Mines = {
      type  = "mine_ready", 
      time  = 5, 
      param = StringGet( "str_mine_name_notification" )
    },
    Dailyquest = {
      type = "dailyquest_ready", 
      time = 5
    },
    ComebackLevel = {
      type  = "comeback_level", 
      time  = 5, 
      param = common.string.FormatNameStage( stage_name )
    },
    ComebackGame = {
      type = "comeback_over12hours",
      time = 5
    },
    Carriers = {
      type  = "carrier_ready", 
      time  = 5,
      param = ne.strings.Get( "str_int_dialog_worldmap_section_1" )..", +1 "..ne.strings.Get( "str_resource_name_resource1" )
    },
    Minievent = {
      type  = "minievent_tourney_ends", 
      time  = 5,
      param = ne.strings.Get( "str_int_dialog_minievent_tourney_1_title" )
    }
  };
  
  local notifications = {};
  
  notifications[ name ] = fake_notifications[ name ];
  
  v_game.SetFakeDataLocalNotification( notifications );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.AndroidBackButton ()

  common.MessageSend( "Event_Android_BackPressed" );

end;
--------------------------------------------------------------------------------
function private.Autotest_WinPoint ()
  
  mediator.SubscribeOnce(
    "View_Stage_DialogStartActivated",
    function()
      
      local function func_accept ()
        
        local window_name = v_interface.window.Upper_Name();
        
        if ( window_name ) then
        
          local accept_func = v_interface.window.GetAcceptHandler( window_name );
          
          if ( accept_func ) then
    
            accept_func();
            
          end;
          
        end;
        
      end;
      
      mediator.SubscribeOnce(
        "Interface_Window_WindowOpened",
        function ( window_name )
          
          --DbgTrace( "Autotest: window opened: "..window_name );
      
          common.Defer(
            "autotest_accept_reward",
            2,
            function ()
              
              func_accept();
              
            end
          );
          
        end
      );
      
      if ( private.Map_WinAllStates() ) then
      
        --
        
      else
        
        mediator.Unsubscribe(
          "Interface_Window_WindowOpened",
          func_accept
        );
        
        private.Autotest_Stop();
    
      end;
      
    end
  );
  
  local current_point = v_map.Marker_CurrentPoint();
  
  v_stage.DialogStart_Show( current_point );
  
end;
--------------------------------------------------------------------------------
function private.Autotest_Start ()

  mediator.Subscribe(
    "View_Map_Update_Finished",
    private.Autotest_Continue
  );
  
  v_tutorial.Disable();
  
  private.Autotest_Continue();

  v_interface.ShowNotification( "Autotest started." );
  
end;
--------------------------------------------------------------------------------
function private.Autotest_Continue ()
  
  common.Defer(
    "autotest_win_point",
    2,
    function ()

      private.Autotest_WinPoint();

    end
  );
  
end;
--------------------------------------------------------------------------------
function private.Autotest_Stop ()
  
  mediator.Unsubscribe(
    "View_Map_Update_Finished",
    private.Autotest_Continue
  );
  
  v_tutorial.Enable();

  v_interface.ShowNotification( "Autotest can't continue." );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Starterpack ()

  v_shop.Cheat_Starterpack();

end;
--------------------------------------------------------------------------------
function private.FastCarriers ()
  
  if ( v_carriers.Cheat() ) then
  
    int_panel_interface_top.ShowNotification(
      "Airship work takes only 20 sec."
    );

  end;
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.FakeLastPurchase ()

  local seconds = parts.time.server.Timestamp();
  local is_set  = v_player.PayingStatus_SetLastPurchaseTime( seconds );

  if ( is_set ) then

    int_panel_interface_top.ShowNotification(
      "Last purchase: a second ago."
    );

  else

    int_panel_interface_top.ShowNotification(
      "Failed to fake last purchase."
    );

  end;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.AddMockFriend ()

  v_social.Friends_Cheat_AddMockFriend();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.SetTimeShift ( seconds )

  common.time.SetShift( seconds );
  v_game.Session_ForceTick();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.FakeEvent_DailyLaunch ()

  if ( not private.launch_days ) then
    private.launch_days = 1;
  else
    private.launch_days = private.launch_days + 1;
  end;

  mediator.Notify( "Model_Player_LaunchDaysRow", private.launch_days );

end;
--------------------------------------------------------------------------------
function private.FakeEvent_DailyLaunchReset ()

  private.launch_days = nil;
  mediator.Notify( "Model_Player_LaunchDaysRow", 0 );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.FakeError_InternetDown ()

  ne.msg.Send(
    "Event_Application_InternetError",
    {
      error = "ServerTemporarilyUnavailable"
    }
  );

  common.Defer(
    "fake_error_internet_down",
    10,
    function () ne.msg.Send( "Event_HeartBeat" ); end
  );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.ToggleLowendDevice ()
  
  if ( not private.is_lowend_simulation ) then
  
    private.is_lowend_simulation = true;
    
    int_panel_interface_top.ShowNotification(
      "Low-end device simulation started"
    );
    
    common.fps.SetLimit( 15 );
    
  else
    
    private.is_lowend_simulation = nil;
    
    int_panel_interface_top.ShowNotification(
      "Low-end device simulation stopped"
    );
    
    common.fps.UnsetLimit();
    
  end;
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Test_CharacterAnimation ()
  
  if ( v_screen.GetCurrentName() ~= "scr_map" ) then
    return;
  end;
  
  local section_name = v_sections.Section_NameCurrent();
  local characters   = v_characters.GetAllInSection( section_name );
  
  local callback_list = {};
  
  for _, character in pairs( characters ) do
    
    if ( character.state ~= "locked" ) then
    
      local character_anm    = "anm_map_characters_icon_"..character.name;
      local animfuncs        = ui.obj.GetAnimfuncs( character_anm );
      local current_animfunc = ui.obj.Get( character_anm ).animfunc;
      
      --DbgTrace( animfuncs );
      
      if ( animfuncs ) then
      
        table.insert(
          callback_list,
          function ( func_next )
            v_map.Focus( character_anm, { time = 1, func_after = func_next } );
          end
        );
        
        for _, animfunc in pairs( animfuncs ) do
          
          if ( animfunc:find( "static" ) ) then
          
            table.insert(
              callback_list,
              function ( func_next )
                Log.i( nil, "Playing "..animfunc.." for "..character.name );
                ui.anim.Play( character_anm, animfunc );
                common.Defer( character.name.."_"..animfunc.."_test", 1, func_next );
              end
            );
            
          else
          
            table.insert(
              callback_list,
              function ( func_next )
                Log.i( nil, "Playing "..animfunc.." for "..character.name );
                ui.anim.Play( character_anm, animfunc, func_next );
              end
            );
          
          end;
        
        end;
        
        table.insert(
          callback_list,
          function ( func_next )
            ui.anim.Play( character_anm, current_animfunc );
            common.Defer( "cheater_test_character_animation", 1, func_next );
          end
        );
        
      else
        
        Log.w( nil, "Character "..character.name.." is locked" );
        
      end;
    
    else
      
      Log.e( nil, "Character animation has no animfuncs" );
    
    end;
    
  end;
  
  common.RunCallbackList( callback_list );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.EasyAchievements ()
  
  if ( v_interface.window.IsOnScreen( "int_dialog_player_main" ) ) and
     ( v_player.DialogMain_GetCurrentTab() == "achievements"     ) then
  
    local achievements = v_achievements.GetAll();
    local icon         = "anm_int_dialog_player_main_achievements_slot_icon";
    
    for i, achievement in pairs( achievements ) do

      local name      = achievement.name;
      local suffix    = "_"..name;
      local item_icon = icon..suffix;
        
      ui.obj.Set(
        item_icon,
        {
          inputrect_init = true,
          inputrect_x    = -50,
          inputrect_y    = -50,
          inputrect_w    = 100,
          inputrect_h    = 100
        }
      );
      
      ui.control.EventsSet(
        item_icon,
        {
          func_on_click = function ()
            v_achievements.Achievement_IncreaseCount( name );
          end
        }
      );
      
    end;
    
    int_panel_interface_top.ShowNotification(
      "Tap on icon to increase"
    );
    
  else
    
    int_panel_interface_top.ShowNotification(
      "Open achievement list first"
    );
  
  end;
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Hearts_Plus ()

  v_hearts.TryChangeCount( 1, "cheat" );

end;
--------------------------------------------------------------------------------
function private.Hearts_Null ()

  local count = v_hearts.GetCount();
  v_hearts.TryChangeCount( -count, "cheat" );

end;
--------------------------------------------------------------------------------
function private.Hearts_SocialAdd ()

  v_hearts.TryAddSocialBonus();

end;
--------------------------------------------------------------------------------
function private.Hearts_SocialNull ()

  local hearts_info = lib_db.Player.Info().hearts;
  hearts_info.facebook = 0;

  local query =
  {
    query      = "update",
    group      = "player",
    collection = "info",
    set        = { hearts = hearts_info }
  };

  lib_db.Execute( query );
  
  if ( v_hearts.GetCount() > v_hearts.GetMaxCount() ) then
  
    v_hearts.TryChangeCount( -1, "cheat" );

  end;

end;
--------------------------------------------------------------------------------
function private.Hearts_DonateAdd ()

  v_hearts.TryAddDonateBonus( 1 );

end;
--------------------------------------------------------------------------------
function private.Hearts_DonateNull ()

  local hearts_info = lib_db.Player.Info().hearts;
  hearts_info.donate = 0;

  local query =
  {
    query      = "update",
    group      = "player",
    collection = "info",
    set        = { hearts = hearts_info }
  };

  lib_db.Execute( query );
  
  if ( v_hearts.GetCount() > v_hearts.GetMaxCount() ) then
  
    v_hearts.TryChangeCount( -1, "cheat" );

  end;

end;
--------------------------------------------------------------------------------
function private.Hearts_Immortality ()

  v_hearts.Immortality_Cheat();

end;
--------------------------------------------------------------------------------
function private.Hearts_SendLimitOff ()

  v_social.FriendsLimitReset_Cheat( "send" );

end;
--------------------------------------------------------------------------------
function private.Hearts_AskLimitOff ()
  
  v_social.FriendsLimitReset_Cheat( "ask" );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.InterfaceLock_Show ()
  
  local color_object = "ng_interface_lock_spr";
  local text_object = "txt_cheater_intlock";
  
  local alp = ObjGet( color_object ).alp;
  local alp_new = 0.0;
  
  if ( alp == alp_new ) then
    
    alp_new = 0.5;  
    
  end;
  
  ObjMultiSet( {
    { color_object, { alp = alp_new } },
    { text_object, { alp = alp_new + 0.5 } }
  } );

end;

function private.CreateCheatSpeed()
  local speed_current = "txt_cheater_button_other_speed_current";
  local SetDT = function( inc )
    local dt = private.dt or 1 / 60;
    if ( inc ) then
      dt = dt * 1.1;
    else
      dt = dt / 1.1;
    end;
    ne.dbg.SetFixedDT(dt);
    private.dt = dt;
    ObjSet( speed_current, { text = string.format("%.4f", dt / (1.0 / 60.0)) } );
  end;
  
  local speed_plus = "txt_cheater_button_other_speed_plus";
  ne.obj.Create( speed_plus, "text" );
  ne.obj.Set( speed_plus,{
    pos_x = 110,
    pos_z = 2,
    fontsize = 46,
    res   = "assets/fonts/sml_desc_en",
    text  = "+",
    inputrect_init = true,
    inputrect_x = -30,
    inputrect_y = -30,
    inputrect_w = 60,
    inputrect_h = 60,
    event_mdown = function() SetDT( true ); end
    } );
  ne.obj.Attach( speed_plus, "obj_cheater_button_other_speed" );
  
  local speed_minus = "txt_cheater_button_other_speed_minus";
  ne.obj.Create( speed_minus, "text" );
  ne.obj.Set( speed_minus,{
    pos_x = 165,
    pos_z = 2,
    fontsize = 46,
    res   = "assets/fonts/sml_desc_en",
    text  = "-",
    inputrect_init = true,
    inputrect_x = -30,
    inputrect_y = -30,
    inputrect_w = 60,
    inputrect_h = 60,
    event_mdown = function() SetDT( false ); end
    } );
  ne.obj.Attach( speed_minus, "obj_cheater_button_other_speed" );
  
  ne.obj.Create( speed_current, "text" );
  ne.obj.Set( speed_current,{
    pos_x = 195,
    pos_z = 2,
    fontsize = 18,
    res   = "assets/fonts/sml_desc_en",
    text  = "",
    input = false,
    align = 0
  } );
  ne.obj.Attach( speed_current, "obj_cheater_button_other_speed" );
  
end;
--------------------------------------------------------------------------------
function private.CreateCheatDT()
  local ted_name = "ted_cheater_delta_time";
  
  local startEdit = function()
    ObjSet( ted_name, { input = true } );
    private.ted_active = true;
  end;
   
  ui.obj.Create( ted_name, "textedit", "obj_cheater_button_other_delta_time", {
    pos_z = 4,
    pos_x = 200,
    res = "assets/fonts/sml_desc_en",
    disprawtext = true,
    fontsize = 20,
    align = 2,
    input = false,
    maxchars = 6,
    allowed_characters = "-0123456789",
    show_native = true,
    trg_enter = private.DisableAllTed
  } );
  
  ObjSet( "obj_cheater_button_other_delta_time", { event_mup = startEdit } );
end;
--------------------------------------------------------------------------------
function private.UpdateCheatDt()
  local ted_name = "ted_cheater_delta_time";
  local old_dt = math.tointeger( parts.time.debug.GetDelta() / 60 );
  
  local text_delta = ObjGet(ted_name).text or "";
  local delta = tonumber(text_delta) or old_dt;
  
  parts.time.debug.UseDelta(delta * 60);
  
  ObjSet( ted_name, { input = false, text = tostring( delta ) } );
end;
--------------------------------------------------------------------------------
function private.DisableAllTed()
  if ( not private.ted_active ) then
    return;
  end;
  
  private.UpdateCheatDt();
  
  local abtest_groups = parts.features.GetFeatureData("abtest_groups");
  if ( not abtest_groups or type(abtest_groups)~="table") then
    return;
  end;
  
  local changed = false;
  for feature, max_group in pairs( abtest_groups ) do
    ObjSet( "ted_cheater_"..feature.."_group", { input = false } );
    local sel_group = math.tointeger(ObjGet("ted_cheater_"..feature.."_group").text or 1) - 1;
    if ( sel_group > max_group ) then
      sel_group = max_group - 1;
    end;
    
    local current = v_features.GetFeatureGroup( feature );
    if ( changed == false and current ~= sel_group ) then
      changed = v_features.SetCheatUserGroup( feature, sel_group );
      ObjSet( "ted_cheater_"..feature.."_group", { text = sel_group + 1 } );
    else
      ObjSet( "ted_cheater_"..feature.."_group", { text = current + 1 } );
    end;
  end;
  
  
  private.ted_active = false;
end;
--------------------------------------------------------------------------------
-- function *** TOP PANEL *** () end;
--------------------------------------------------------------------------------
function private.SetOnlineState ( state )
  
  if ( state ) then
    
    ObjSet( "txt_cheater_info_online", { text = "online" } );
    
  else
    
    ObjSet( "txt_cheater_info_online", { text = "offline" } );
    
  end;
  
end;
--------------------------------------------------------------------------------
function private.SetDebugState ( debug )
  
  if ( debug ) then
    
    ObjSet( "txt_cheater_info_debug", { text = "debug" } );
    
  else
    
    ObjSet( "txt_cheater_info_debug", { text = "no debug" } );
    
  end;
  
end;
--------------------------------------------------------------------------------
function private.ShowDrawCalls ()

  local func_update;
  func_update = function ()

    local drawcalls = ne.GetNumDrawCalls();

    ObjSet( "txt_cheater_info_drawcalls", { text = "dc: "..drawcalls } );
    ObjSet( "tmr_cheater_info_drawcalls", { time = 1, playing = true, endtrig = func_update } );

  end;

  func_update();

end;
--------------------------------------------------------------------------------
function private.ShowFPS ()

  local func_update;
  
  func_update = function ()

    local multiset = {};
    local fps = common.fps.Get();

    ui.obj.Set( 
      "txt_cheater_info_fps",
      { text = "fps: "..fps },
      multiset
    );
    
    ui.obj.Set(
      "tmr_cheater_info_fps",
      { time = 0.015, playing = true, endtrig = func_update },
      multiset
    );
    
    ui.obj.Multiset( multiset );

  end;

  func_update();

end;
--------------------------------------------------------------------------------
function private.ShowButtonPressed ()

  local button_pressed = ui.button.IsAnyPressed();

  ObjSet(
    "txt_cheater_info_button",
    {
      text = "btn: "..tostring( button_pressed )
    }
  );

end;
--------------------------------------------------------------------------------
function private.CreateABTestSettings()
  if ( not parts.features.IsActive("abtest_groups")) then
    return;
  end;
  
  local abtest_groups = parts.features.GetFeatureData("abtest_groups");
  if ( not abtest_groups or type(abtest_groups)~="table") then
    return;
  end;
  
  local startEdit = function( feature_name )
    ObjSet( "ted_cheater_"..feature_name.."_group", { input = true } );
    private.ted_active = true;
  end;
  
  local obj_y = 100;
  local obj_top_name = "obj_cheater_info_top_abtest";
  ui.obj.Create( obj_top_name, "obj", "obj_cheater_info_top", {
    pos_x = 60 - private.app_w
  });
    
  for feature, max_count in pairs( abtest_groups ) do
    local obj_name        = "obj_cheater_"..feature.."_group";
    local label_name      = "txt_cheater_"..feature.."_group_label";
    local ted_name        = "ted_cheater_"..feature.."_group";
    local max_count_name  = "txt_cheater_"..feature.."_group_max";
    
    ui.obj.Create( obj_name, "obj", obj_top_name, {
      pos_y = obj_y,
      pos_x = 300
    });
    
    ui.obj.Create( label_name, "text", obj_name, {
      res = "assets/fonts/sml_desc_en",
      text = "Feature "..feature.." group:",
      disprawtext = true,
      fontsize = 20,
      align = 2,
      inputrect_init = true,
      inputrect_x = -300,
      inputrect_y = -12,
      inputrect_w = 400,
      inputrect_h = 24,
      event_mup = function() startEdit(feature); end
    } );
    
    ui.obj.Create( ted_name, "textedit", obj_name, {
      pos_x = 30,
      res = "assets/fonts/sml_desc_en",
      text = "0",
      disprawtext = true,
      fontsize = 20,
      align = 2,
      input = false,
      maxchars = 3,
      allowed_characters = "0123456789",
      show_native = true,
      trg_enter = private.DisableAllTed
    } );
    
    ui.obj.Create( max_count_name, "text", obj_name, {
      pos_x = 30,
      res = "assets/fonts/sml_desc_en",
      text = "/ "..max_count,
      disprawtext = true,
      fontsize = 20,
      align = 0,
      input = false
    } );
    
    obj_y = obj_y + 40;
  end;
  
end;
--------------------------------------------------------------------------------
function private.UpdateABTestGroups()
  local abtest_groups = parts.features.GetFeatureData("abtest_groups");
  if ( not abtest_groups or type(abtest_groups)~="table") then
    return;
  end;
  for feature, _ in pairs( abtest_groups ) do
    local group, result = v_features.GetFeatureGroup( feature );
    if ( result ) then
      ObjSet( "ted_cheater_"..feature.."_group", { text =  group + 1 } );
    end;
  end;
end;
--------------------------------------------------------------------------------
-- function *** TEST *** () end;
--------------------------------------------------------------------------------
function private.TestMessages ( code )

  if ( not code ) then

    code = 97;

  end;

  local messages = 
  {
    [ 97 ]  = Command_ShowSupport,
    [ 98 ]  = Command_ShowPrivacyPolicy,
    [ 99 ]  = Command_ShowTermsOfService,
    [ 100 ] = Command_RateGame, 
    [ 101 ] = Command_OpenUrl
  };

  local params = nil;

  if ( code == 101 ) then

    params = "http://www.google.com/";

  end;

  --DbgTrace( "TestMessages: code = "..code );

  common.MessageSend( messages[ code ], { url = params } );  

end;
