-- name=review
function public.__InitObjects ()

  private.default = {};

  private.default.field = private.GetObjParamsForSet( "obj_review_default_field" );

  private.default.field.event_mdown = function () private.MarkAdd(); end;

  private.default.field_mark = private.GetObjParamsForSet( "spr_review_default_field_mark" );
  private.default.field_text = private.GetObjParamsForSet( "ted_review_default_field_text" );
  private.default.field_bcgr = private.GetObjParamsForSet( "spr_review_default_field_bcgr" );
  private.default.field_link = private.GetObjParamsForSet( "grd_review_default_field_link" );

  private.default.field_text.trg_enter = function () private.TextEditingDone(); end;

  private.enabled = false;

  private.mark_count = 0;

  private.mark_dragged = nil;
  private.bcgr_dragged = nil;

  DbgTrace( "[ INFO ] review -> Init -> Event_Logic_CheatKeyPressed commented!" );
  --ne.msg.Subscribe( Event_Logic_CheatKeyPressed, function ( type, params ) private.CheatKeyPressed( params.key ); end );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.CheatKeyPressed ( keycode )

  if ( keycode == 19 ) or ( keycode == 123 ) then

    private.Switch();

  elseif ( keycode == 107 ) or ( keycode == 187 ) then

    private.MarkUp();

  elseif ( keycode == 109 ) or ( keycode == 189 ) then

    private.MarkDown();

  end;

end;

function private.Switch ()

  if not ( private.enabled ) then

    private.enabled = true;

    ObjSet( "ng_level", { active = false } );

    ObjCreate( "obj_review_field", "obj" );

    ObjSet( "obj_review_field", private.default.field );
    ObjAttach( "obj_review_field", "ng_application" );

    ObjAttach( "txt_review_field", "obj_review_field" );

    ObjAnimate( "txt_review_field", "alp", 1, 0, "",
    {
      0.0, 3, 0.5,
      1.5, 3, 1.0,
      3.0, 3, 0.5
    } );

  else

    if ( private.text_editing ) then

      private.TextEditingDone();

    end;

    private.enabled = false;

    ObjDetach( "txt_review_field" );

    common.MessageSend( Command_Level_SaveScreenshot );

    ObjDelete( "obj_review_field" );

    ObjSet( "ng_level", { active = true } );

  end;

end;

function private.MarkAdd ()

  if not ( private.text_editing ) then

    private.mark_count = private.mark_count + 1;

    local mark_count_current = private.mark_count;

    local cur_pos = GetGameCursorPos();
    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
    local mark_object = "spr_review_field_mark_"..private.mark_count;
    local mark_params = private.default.field_mark;

    mark_params.pos_x = cur_pos[ 1 ];
    mark_params.pos_y = cur_pos[ 2 ];

    mark_params.event_startdrag = function () private.MarkDragStart( mark_count_current ); end;
    mark_params.event_drag      = function () private.MarkDrag( mark_count_current ); end;
    mark_params.event_dragdrop  = function () private.MarkDrop( mark_count_current ); end;

    ObjCreate( mark_object, "spr" );
    ObjSet( mark_object, mark_params );
    ObjAttach( mark_object, "obj_review_field" );

    ObjAnimate( mark_object, "color_rgb", 1, 0, "",
    {
      0.0, 3, 1, 0, 0,
      0.3, 3, 1, 1, 1,
      0.6, 3, 1, 0, 0
    } );
    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
    local bcgr_object = "spr_review_field_bcgr_"..private.mark_count;
    local bcgr_params = private.default.field_bcgr;

    bcgr_params.pos_x = 150 + 36 + mark_params.pos_x;
    bcgr_params.pos_y = mark_params.pos_y;

    if ( mark_params.pos_x > 512 ) then

      bcgr_params.pos_x = - 150 - 36 + mark_params.pos_x;

    end;

    bcgr_params.event_startdrag = function () private.BackgroundDragStart( mark_count_current ); end;
    bcgr_params.event_drag      = function () private.BackgroundDrag( mark_count_current ); end;
    bcgr_params.event_dragdrop  = function () private.BackgroundDrop( mark_count_current ); end;

    ObjCreate( bcgr_object, "spr" );
    ObjSet( bcgr_object, bcgr_params );
    ObjAttach( bcgr_object, "obj_review_field" );
    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
    local text_object = "ted_review_field_text_"..private.mark_count;
    local text_params = private.default.field_text;

    text_params.pos_x = 150 + 36 + mark_params.pos_x;
    text_params.pos_y = mark_params.pos_y;
    text_params.show_native = true;

    if ( mark_params.pos_x > 512 ) then

      text_params.pos_x = - 150 - 36 + mark_params.pos_x;

    end;

    ObjCreate( text_object, "textedit" );
    
    local updateTexteditParams;
    updateTexteditParams = function ( msg, params )

      ne.obj.Set( text_object, {
        native_h = 50,
        native_w = ui.screen.Width(),
        native_y = ui.screen.Height() - (50 + params.height)
      } );
      ne.msg.Unsubscribe("Event_Keyboard_WillShow", updateTexteditParams);

    end;
    ne.msg.Subscribe("Event_Keyboard_WillShow", updateTexteditParams);

    ObjAttach( text_object, "obj_review_field" );
    ObjSet( text_object, text_params );
    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
    local link_object = "grd_review_field_link_"..private.mark_count;
    local link_params = private.default.field_link; 

    ObjCreate( link_object, "grid" );
    ObjSet( link_object, link_params );
    ObjAttach( link_object, "obj_review_field" );

    private.LinkUpdatePos( private.mark_count );
    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
    private.text_editing = true;

    local timer_object = "tmr_review_field_text_"..private.mark_count;

    ObjCreate( timer_object, "timer" );
    ObjAttach( timer_object, "obj_review_field" );
    ObjSet( timer_object, { time = 0.01, endtrig = function () private.BackgroundUpdate(); end, playing = true } );
    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 

  end;

end;

function private.BackgroundUpdate ()

  if ( private.text_editing ) then

    local text_object = "ted_review_field_text_"..private.mark_count;
    local text_params = ObjGet( text_object );

    local bcgr_object = "spr_review_field_bcgr_"..private.mark_count;
    ObjSet( bcgr_object, { scale_y = ( text_params.draw_height / 64 ) } );

    local timer_object = "tmr_review_field_text_"..private.mark_count;
    ObjSet( timer_object, { time = 0.01, endtrig = function () private.BackgroundUpdate(); end, playing = true } );

  end;

end;

function private.TextEditingDone ()

  private.text_editing = false;

  local timer_object = "tmr_review_field_text_"..private.mark_count;
  ObjDelete( timer_object );

  local text_object = "ted_review_field_text_"..private.mark_count;
  local text_params = private.GetObjParamsForSet( text_object );
  ObjSet( text_object, { active = false } );
  ObjDelete( text_object );

  local mark_object = "spr_review_field_mark_"..private.mark_count;
  local bcgr_object = "spr_review_field_bcgr_"..private.mark_count;
  local link_object = "grd_review_field_link_"..private.mark_count;

  if ( text_params.text == "" ) then

    ObjDelete( mark_object );
    ObjDelete( bcgr_object );
    ObjDelete( link_object );

  else

    local mark_params = ObjGet( mark_object );
    
    ObjAnimate( mark_object, "color_rgb", 0, 0, "",
    {
      0.0, 3, mark_params.color_r, mark_params.color_g, mark_params.color_b,
      0.3, 3, 1, 0, 0
    } );

    ObjSet( mark_object, { input = true } );
    ObjSet( bcgr_object, { input = true } );

    -- Создание нового.
    text_object = "txt_review_field_text_"..private.mark_count;
    ObjCreate( text_object, "text" );
    text_params.input = false;
    ObjSet( text_object, text_params );
    ObjAttach( text_object, "obj_review_field" );

    table.insert( private.texts,text_params.text );
    
  end;

end;

function private.MarkDragStart ( id )

  SetCursor( CURSOR_NULL );

  private.mark_dragged = id;

end;

function private.MarkDrag ( id )

  local cur_pos = GetGameCursorPos();

  local new_x = cur_pos[ 1 ];
  local new_y = cur_pos[ 2 ];

  local mark_object = "spr_review_field_mark_"..id;

  ObjSet( mark_object, { pos_x = new_x, pos_y = new_y } );

  private.LinkUpdatePos( id );

end;

function private.MarkDrop ( id )

  SetCursor( CURSOR_DEFAULT );

  private.mark_dragged = nil;

end;

function private.BackgroundDragStart ( id )

  SetCursor( CURSOR_NULL );

end;

function private.BackgroundDrag ( id )

  local cur_pos = GetGameCursorPos();

  local new_x = cur_pos[ 1 ];
  local new_y = cur_pos[ 2 ];

  local bcgr_object = "spr_review_field_bcgr_"..id;
  local text_object = "txt_review_field_text_"..id;

  ObjSet( bcgr_object, { pos_x = new_x, pos_y = new_y } );
  ObjSet( text_object, { pos_x = new_x, pos_y = new_y } );

  private.LinkUpdatePos( id );

end;

function private.BackgroundDrop ( id )

  SetCursor( CURSOR_DEFAULT );

end;

function private.LinkUpdatePos ( id )

  local mark_object = "spr_review_field_mark_"..id;
  local mark_params = ObjGet( mark_object );

  local bcgr_object = "spr_review_field_bcgr_"..id;
  local bcgr_params = ObjGet( bcgr_object );

  local angle = math.atan2( ( bcgr_params.pos_y - mark_params.pos_y ), ( bcgr_params.pos_x - mark_params.pos_x ) );

  -- Право.
  if     ( angle >= - 0.785 ) and ( angle <   0.785 ) then

    mark_params.pos_x = mark_params.pos_x + 0.5 * 64 * mark_params.scale_x;

    bcgr_params.pos_x = bcgr_params.pos_x - 150;

  -- Верх.
  elseif ( angle >= - 2.355 ) and ( angle < - 0.785 ) then

    mark_params.pos_y = mark_params.pos_y - 0.5 * 64 * mark_params.scale_y;

    bcgr_params.pos_y = bcgr_params.pos_y + 0.5 * 64 * bcgr_params.scale_y;

  -- Низ.
  elseif ( angle >=   0.785 ) and ( angle <   2.355 ) then

    mark_params.pos_y = mark_params.pos_y + 0.5 * 64 * mark_params.scale_y;

    bcgr_params.pos_y = bcgr_params.pos_y - 0.5 * 64 * bcgr_params.scale_y;

  -- Лево.
  elseif ( ( angle >=   2.355 ) and ( angle <   3.142 ) )
  or     ( ( angle >= - 3.142 ) and ( angle < - 2.355 ) ) then

    mark_params.pos_x = mark_params.pos_x - 0.5 * 64 * mark_params.scale_x;

    bcgr_params.pos_x = bcgr_params.pos_x + 150;

  end;

  angle = math.atan2( ( bcgr_params.pos_y - mark_params.pos_y ), ( bcgr_params.pos_x - mark_params.pos_x ) );

  -- Половина высоты ресурса линка.
  local radius = 9;

  local point0 = { pos_x = mark_params.pos_x + radius * math.cos( - 1.57 + angle ),
                   pos_y = mark_params.pos_y + radius * math.sin( - 1.57 + angle ) };

  local point2 = { pos_x = mark_params.pos_x + radius * math.cos(   1.57 + angle ),
                   pos_y = mark_params.pos_y + radius * math.sin(   1.57 + angle ) };

  local point1 = { pos_x = bcgr_params.pos_x + radius * math.cos( - 1.57 + angle ),
                   pos_y = bcgr_params.pos_y + radius * math.sin( - 1.57 + angle ) };

  local point3 = { pos_x = bcgr_params.pos_x + radius * math.cos(   1.57 + angle ),
                   pos_y = bcgr_params.pos_y + radius * math.sin(   1.57 + angle ) };

  local link_object = "grd_review_field_link_"..id;
  GridSet( link_object, 0,
  {
    0, point0,
    2, point2,
    1, point1,
    3, point3,
  } );

end;

function private.MarkUp ()

  if ( private.mark_dragged ) then

    local mark_object = "spr_review_field_mark_"..private.mark_dragged;
    local mark_params = ObjGet( mark_object );

    local scale_new = mark_params.scale_x + 0.1;

    ObjSet( mark_object, { scale_x = scale_new, scale_y = scale_new } );

  end;

end;

function private.MarkDown ()

  if ( private.mark_dragged ) then

    local mark_object = "spr_review_field_mark_"..private.mark_dragged;
    local mark_params = ObjGet( mark_object );

    local scale_new = mark_params.scale_x - 0.1;

    ObjSet( mark_object, { scale_x = scale_new, scale_y = scale_new } );

  end;

end;

function private.GetObjParamsForSet( object )

  local params = ObjGet( object );

  if ( params ) then

    params.name = nil;

  end;

  return params;

end;

function private.Release ()
  
  ne.msg.Unsubscribe( Event_Level_ScreenshotSaved, private.Release );
  private.enabled = false;
  ObjDetach( "txt_review_field" );
  ObjDetach( "obj_review_info" );
  ObjDelete( "obj_review_field" );
  ObjSet( "ng_level", { active = true } );
  ObjSet( "int_control_hub", { active = true } );
  private.text_editing = false;

end;

function private.GetInfo ()
  -- Set newline symbol
  private.line_ends =
  {
    pc      = ";\r\n",
    ios     = ";\r",
    android = ";\n"
  };
  local nl = private.line_ends[ GetPlatform() ] or ";\n";
  local info = {
    game_version = VersionGetComponentVersion( "game" ),
    client_version = VersionGetComponentVersion( "game" ).." platform:"..GetPlatform(),
    server_version = ConfigGetInfo( "server.host" ).." ",
    content_version = 
      "main: "..( parts.version.GetCurrent( "content_main" ) or "?" ).." "..
      "levels: "..( parts.version.GetCurrent( "content_levels" ) or "?" ),
    user_id = v_player.UserId()
  };
  
  if ( IsAndroid() ) then
    info.client_version = info.client_version.." android:".. wiz.Android.GetPlatform();
  end;
  
  return info;
  
end;
--------------------------------------------------------------------------------
function private.Switch ( bug )

  if not ( private.enabled ) then

    ObjSet( "txt_review_field", { pos_x = GetAppWidth() - 10 } );
    
    private.enabled = true;

    ObjSet( "ng_level", { active = false } );
    ObjSet( "int_control_hub", { active = false } );
    ObjCreate( "obj_review_field", "obj" );
    
    ObjSet( "obj_review_field", private.default.field );
    ObjSet( "obj_review_field", { pos_z = -1, pos_x = - GetAppWidth() + 60 } );
    
    ObjAttach( "obj_review_field", "cheater" );
    ObjAttach( "txt_review_field", "obj_review_field" );
    ObjAnimate( "txt_review_field", "alp", 1, 0, "",
    {
      0.0, 3, 0.5,
      1.5, 3, 1.0,
      3.0, 3, 0.5
    } );
  
    private.texts = {};
    
    local info = private.GetInfo();
    local text = ne.strings.Get( "str_loader_info",
                                  info.user_id,
                                  info.client_version,
                                  info.server_version,
                                  info.content_version
                                  
    );
    ne.obj.Set( "txt_review_info", { text = text } );
    ObjAttach( "obj_review_info", "obj_review_field" );
      
    DbgTrace( "*** Start editing ***" );
  
  else
      
    DbgTrace( "*** TextEditingDone: found "..#private.texts.." texts." );
    
    if ( private.text_editing ) then

      private.TextEditingDone();

    end;
    
    if ( #private.texts > 0 ) then
      
      local screenshotName = "save/screenshot_debug";
      ne.dbg.Screenshot( screenshotName ); 
      
      if ( bug ) then 
        public.SendToMantis( screenshotName );
      else
        public.SendToTrello( screenshotName );
      end;
      
    end;
    
    private.Release();
    
  end;
  
end;
--------------------------------------------------------------------------------
function public.Switch ( bug )
  
  private.Switch( bug );
  
end;
--------------------------------------------------------------------------------
function public.SendToMantis ( screenshotName, summary, text )
  
  DbgTrace( "*** SendToMantis ***" );
  
  local protocol = "https";
  if ( IsAndroid() ) then protocol = "http"; end;
  local host = protocol.."://qaserver.elephant-games.com/api/report_issue";
  local auth = "Basic dGVzdF9hcGlAZWxlcGhhbnQtZ2FtZXMuY29tOnRoaXNpc3RoZWVuZA==";
  
  local bugCreated;
  bugCreated = function ( msg, params )
    
    ne.msg.Unsubscribe( "Event_MantisBugCreatedResponse", bugCreated );
    DbgTrace( "*** statusCode "..params.statusCode.." ***" );
    DbgTrace( common.table.ToString( params ) );
    
  end;
  ne.msg.Subscribe( "Event_MantisBugCreatedResponse", bugCreated );

  local summary = summary or private.texts[ 1 ];
  local desctxt = text or "";
  if ( desctxt == "" ) then
    if ( #private.texts > 1 ) then
      for i = 2, #private.texts do
        desctxt = desctxt..( i - 1 )..") "..private.texts[ i ].."\n";
      end;
    else
      desctxt = private.texts[ 1 ];
    end;
  end;
  
  local headers = {};
  headers[ "Authorization" ] = auth;
  headers[ "Content-Type" ]  = "multipart/form-data";
  headers[ "Accept" ] = "application/vnd.project_red.v1+json";
  
  local info = private.GetInfo();
  local additional_info = "Client: "..info.client_version.."\n"
  additional_info = additional_info.."Server: "..info.server_version.."\n"
  additional_info = additional_info.."Content: "..info.content_version.."\n"

  parts.net.SendHttpRequest(
  {
    url = host,
    headers = headers,
    form = {
      project = "Sir Match-a-Lot",
      summary = summary,
      description = desctxt,
      file = { path = screenshotName..".jpg", key = "attachment_file" },
      save = parts.storage.GetSave( "player" ),
      custom_version = info.game_version,
      custom_revision = "",
      additional_information = additional_info,
    },
  }, "Event_MantisBugCreatedResponse" );
  
end;
--------------------------------------------------------------------------------
function public.SendToTrello ( screenshotName, summary, text, idList )

  local nl = private.line_ends[ GetPlatform() ] or ";\n";
  DbgTrace("*** SendToTrello player "..common.table.ToString( SocialGetInfo(), 0, nl, "" ));
  
  local social_info = SocialGetInfo();
   
  local function ToUnicode(a)
    local a1,a2,a3,a4 = a:byte(1, -1);
    local ans = string.format ("%%%02X", a1);
    local n = a2;
    if (n) then
      ans = ans .. string.format ("%%%02X", n);
    end
    n = a3;
    if (n) then
      ans = ans .. string.format ("%%%02X", n);
    end
    n = a4;
    if (n) then
      ans = ans .. string.format ("%%%02X", n);
    end
    return ans
  end

  local function UrlEncode(str)
    if (str) then
      str = string.gsub (str, "\n", "\r\n");
      str = string.gsub (str, "([^%w ])", ToUnicode);
      str = string.gsub (str, " ", "+");
    end
    return str;
  end

  
  local key = "644d9abb62cebae104b20fdb3fa52b10";
  local token = "53877c61229a5b1535479d5e3a490243562a3b0a37d783773e5790d434d77dac";
  local name = "&name="..UrlEncode( social_info.name..": "..( summary or private.texts[1] ) );
  local idList = idList or "5a561a7fa0c34705408e4011";
  
  local addAttachFunc;
  addAttachFunc = function ( msg, params )
    ne.msg.Unsubscribe("Event_TrelloCardCreatedResponse", addAttachFunc);
    if ( params.data ) then
      parts.net.SendHttpRequest(
      {
        url = "https://api.trello.com/1/cards/"..params.data.id.."/attachments",
        form = {
          key = key,
          token = token,
          name = "scr.jpg",
          file = { path = screenshotName..".jpg", key = "file" }
        },
      }, "Event_TrelloAttachAddedResponse" );
    end;
  end;
  ne.msg.Subscribe("Event_TrelloCardCreatedResponse", addAttachFunc);

  local desctxt = text or "";
  if ( desctxt == "" ) then
    if ( #private.texts > 1 ) then
      for i = 2, #private.texts do
        desctxt = desctxt..(i - 1)..") "..private.texts[i].."\n";
      end;
    else
      desctxt = private.texts[1];
    end;
  end;
  local desc = "&desc="..UrlEncode(desctxt);
  parts.net.SendHttpRequest(
  {
    url = "https://api.trello.com/1/lists/"..idList.."/cards?key="..key.."&token="..token..name..desc,
    post = {},
  }, "Event_TrelloCardCreatedResponse" );
  

end;
--------------------------------------------------------------------------------