-- name=dbg_simulate
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.simulation = 
  { 
    platform = "unknown", 
    vendor   = "unknown" 
  };

  private.google_play =
  {
    connected = false,
    username  = "Sir Mulator"
  };

end;
--------------------------------------------------------------------------------
function public.Setup ( platform, vendor )

  DbgTrace( "[ SIMULATION ] Setup for "..platform );
  
  private.simulation.platform = platform;
  private.simulation.vendor   = vendor;
    
  GetPlatform = function ()
    return private.simulation.platform;
  end;
  
  if ( platform == "android" ) then

    wiz.Android.GetPlatform = function ()
      return private.simulation.vendor;
    end;
   
    wiz.Android.GooglePlayIsConnected = function ()
      return private.google_play.connected;
    end;
      
    wiz.Android.GooglePlaySignIn = function ()
      private.google_play.connected = true;
      ne.msg.Send(
        "Event_GooglePlay_LoggedStateChanged",
        { logged = true }
      );
    end;
      
    wiz.Android.GooglePlaySignOut = function ()
      private.google_play.connected = false;
      ne.msg.Send(
        "Event_GooglePlay_LoggedStateChanged",
        { logged = false }
      );
    end;
    
    wiz.Android.GooglePlayGetPlayerName = function ()
      return private.google_play.username;
    end;
    
    ne.msg.Subscribe(
      "Event_Application_LostFocus",
      function ()
        ne.msg.Send( "Event_Android_OnPause" );
      end
    );

  end;
  
end;
--------------------------------------------------------------------------------