-- name=int_dialog_booster_buy
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Buy    = function () end,
  Close  = function () end,
  OnShow = function () end,
  OnHide = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.strings = {
    title = ne.strings.Get( "str_int_dialog_booster_buy_description" )
  };

  ui.button.Create(
    "btn_int_dialog_booster_buy_close",
    {
      design = "close"
    },
    function() _f.Close(); end
  );
  
  ui.button.Create(
    "btn_int_dialog_booster_buy_buy",
    {
      design = "price"
    },
    function() if ( _f.Buy() ) then _f.Close(); end; end
  );

  local window_area = { -268, -254, 536, 540 };

  local multiset = {};

  ui.obj.ToCenter( "obj_int_dialog_booster_buy", 0, 0, multiset );
  ui.window.SetArea( "obj_int_dialog_booster_buy", window_area, multiset );
  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( booster, booster_data )

  local booster_caption = ne.strings.Get(
    "str_item_"..booster.name.."_caption"
  );
  
  local booster_description = ne.strings.Get(
    "str_item_"..booster.name.."_description"
  );

  local booster_title = ne.strings.Get(
    "str_int_dialog_booster_buy_title", 
    booster_caption, 
    booster_data.count
  );

  local multiset = {};

  ui.obj.Set(
    "anm_int_dialog_booster_buy_window",
    { 
      title         = private.strings.title,
      booster_title = booster_title,
      booster_desc  = booster_description,
      booster_count = ne.strings.Get( "x"..booster_data.count ),
      rt_sale = tern( booster_data.sale )( "assets/content/items/icon_sale", "" ),
      tt_sale = tern( booster_data.sale )( "str_int_sale_label", "" )
    },
    multiset
  );

  ui.obj.SetTextTag(
    "anm_int_dialog_booster_buy_buy",
    "tt_title",
    tostring( booster_data.price ),
    multiset
  );

  local res_name = tern( booster.phase )( booster.phase, booster.name );
  
  ui.obj.Set(
    "spr_int_dialog_booster_buy_mid_icon_booster",
    {
      res = ui.obj.Res( "booster", res_name )
    },
    multiset
  );

  ui.obj.Multiset( multiset );
  
  ui.window.Open( "booster_buy", _f.OnShow );

end;
--------------------------------------------------------------------------------
function public.Hide ()

  ui.window.Close( "booster_buy", _f.OnHide );

end;
--------------------------------------------------------------------------------