-- name=int_dialog_carrier_confirm
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Accept = function () end,
  Close  = function () end,
  OnHide = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this = {
    dialog = "obj_int_dialog_carrier_confirm",
    window = "anm_int_dialog_carrier_confirm_window",
    button = {
      close  = "btn_int_dialog_carrier_confirm_close",
      accept = "btn_int_dialog_carrier_confirm_accept"     
    },
    resource = "spr_int_dialog_carrier_confirm_resource"
  };

  private.app_o = ui.screen.Orientation();

  private.window_area = {
    default = { -270, -160, 540, 460 }
  };

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( message_type, resource_name, resource_count )

  if ( private.active ) then return; end;

  private.active = true;

  local multiset = {};

  ui.obj.Set( private.this.resource, {
    animfunc = "sleep_"..resource_name
  }, multiset );

  ui.obj.Set( private.this.window, {
    tt_title     = "str_int_dialog_carrier_confirm_title_"..message_type,
    tt_desc      = "str_int_dialog_carrier_confirm_desc_"..message_type,
    tt_res_count = resource_count
  }, multiset );

  ui.obj.Multiset( multiset );

  ui.window.Open( "carrier_confirm" );

end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( not private.active ) then return; end;

  private.active = false;

  ui.window.Close( "carrier_confirm", function () _f.OnHide(); end );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()
  
  local multiset = {};

  ui.obj.ToCenter( private.this.dialog, 0, 0, multiset );

  ui.window.SetArea(
    private.this.dialog,
    private.window_area.default,
    multiset
  );

  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    private.this.button.close,
    {
      design = "close",
      sound  = "simply_click",
    },
    function () _f.Close(); end
  );

  ui.button.Create(
    private.this.button.accept,
    {
      title  = "str_int_dialog_carrier_confirm_accept",
      color  = "green",
      design = "medium"
    },
    function () 
      if ( _f.Accept() ) then 
        _f.Close();
      end;
    end
  );

end;
--------------------------------------------------------------------------------