-- name=int_dialog_carrier_upgrade
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Accept  = function () end,
  Close   = function () end,
  OnOpen  = function () end,
  OnClose = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.app_o = ui.screen.Orientation();
  
  private.this = {
    dialog = "obj_int_dialog_carrier_upgrade",
    window = "anm_int_dialog_carrier_upgrade_window",
    button = {
      close  = "btn_int_dialog_carrier_upgrade_close",
      accept = "btn_int_dialog_carrier_upgrade_accept"
    },
    carrier = {
      old = "anm_int_dialog_carrier_upgrade_carrier_old",
      new = "anm_int_dialog_carrier_upgrade_carrier_new"
    }
  };
  
  private.window_area = {
    portrait  = { -260, -350, 523, 790 },
    landscape = { -208, -280, 418, 633 }
  };

  private.strings = {
    title       = ne.strings.Get( "str_int_dialog_carrier_upgrade_title" ),
    description = ne.strings.Get( "str_int_dialog_carrier_upgrade_description" )
  };
  
  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show (
    old_state,
    new_state,
    old_capacity,
    new_capacity,
    upgrade_price
  )

  if ( private.active ) then return; end;

  private.active = true;

  private.SetDefault(
    old_state,
    new_state,
    old_capacity,
    new_capacity,
    upgrade_price
  );

  ui.window.Open( "carrier_upgrade", _f.OnOpen );

end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( not private.active ) then return; end;

  private.active = false;

  ui.window.Close( "carrier_upgrade", _f.OnClose );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Adapt ()

  local multiset = {};
  
  ui.obj.ToCenter( private.this.dialog, 0, 0, multiset );
  
  ui.window.SetArea(
    private.this.dialog,
    private.window_area[ private.app_o ],
    multiset
  );
  
  ui.obj.Set(
    private.this.window,
    {
      animfunc       = "upgrade_"..private.app_o,
      tt_title       = private.strings.title,
      tt_description = private.strings.description
    },
    multiset
  );
  
  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    private.this.button.close,
    {
      design = "close"
    },
    function() _f.Close(); end
  );

  ui.button.Create(
    private.this.button.accept,
    {
      title  = "str_int_dialog_carrier_upgrade_button_accept",
      design = "medium",
      color  = "green",
      price  = true
    },
    function() _f.Accept(); end
  );
  
end;
--------------------------------------------------------------------------------
function private.SetDefault (
    old_state,
    new_state,
    old_capacity,
    new_capacity,
    upgrade_price
  )
  
  local multiset = {};
  
  ui.obj.Set(
    private.this.window,
    {
      tt_count_from = tostring( old_capacity ),
      tt_count_to   = tostring( new_capacity )
    },
    multiset
  );
  
  ui.obj.Set(
    private.this.carrier.old,
    {
      animfunc = "state_"..old_state,
      frame    = 0,
      playing  = true
    },
    multiset
  );
  
  ui.obj.Set(
    private.this.carrier.new,
    {
      animfunc = "state_"..new_state,
      frame    = 0,
      playing  = true
    },
    multiset
  );
  
  ui.button.SetPrice(
    private.this.button.accept,
    upgrade_price
  );
  
  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------