-- name=int_dialog_deficient
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Accept = function () end,
  Reject = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.obj.ToCenter( "obj_int_dialog_deficient", 0, -240 );  

  ui.button.Create(
    "btn_int_dialog_deficient_goto",
    {
      design = "medium",
      color  = "green",
      sound  = "simply_click"
    },
    function() _f.Accept(); end
  );
  
  ui.button.Create(
    "btn_int_dialog_deficient_close",
    {
      design = "close",
      sound  = "simply_click",
    },
    function() _f.Reject(); end
  );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show (
    deficient_data,
    solution,
    skin_current
  )

  private.SetDefault( deficient_data, solution, skin_current );

  ui.window.Open( "deficient" );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_end )

  ui.window.Close( "deficient", function ()

    ui.skin.Detach( private.player_skin );

    func_end();
  
  end );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.SetDefault ( deficient_data, solution, skin_current )

  private.player_skin = ui.skin.Attach(
    "obj_int_dialog_deficient_character",
    skin_current
  );
  
  ui.anim.Play( "anm_int_dialog_deficient_message_resources", "res_"..#deficient_data );
  
  local objects = {};
  
  ui.obj.Set( "anm_int_dialog_deficient_message_resources", 
  {
    count_1 = ui.text.FormatNumber( deficient_data[ 1 ].count )
  }, objects );
  
  if( #deficient_data >= 2 ) then
    
    ui.obj.Set( "anm_int_dialog_deficient_message_resources", 
    {
      count_2 = ui.text.FormatNumber( deficient_data[ 2 ].count )
    }, objects );
    
  end;
  
  if( #deficient_data == 3 ) then
    
    ui.obj.Set( "anm_int_dialog_deficient_message_resources", 
    {
      count_3 = ui.text.FormatNumber( deficient_data[ 3 ].count )
    }, objects );
    
  end;

  for i = 1, 3 do

    ui.obj.Set( "obj_int_dialog_deficient_message_resource_"..i, 
    { 
      active = false, visible = false 
    }, objects );

  end;

  local currency = "resources";

  for i = 1, #deficient_data do

    local name  = deficient_data[ i ].name;
    local count = deficient_data[ i ].count;

    ui.obj.Set( "obj_int_dialog_deficient_message_resource_"..i, 
    { 
      active = true, visible = true 
    }, objects );

    if ( not name:find( "resource" ) ) then

      currency  = "item";

      ui.obj.Set( "spr_int_dialog_deficient_message_resource_"..i.."_icon",
      {
        res     = ui.obj.Res( "fragment", name ),
        scale_x = 0.65,
        scale_y = 0.65,
        pos_x   = -15
      }, objects );

    else

      ui.obj.Set( "spr_int_dialog_deficient_message_resource_"..i.."_icon",
      {
        res = "assets/content/items/icon_"..name,
        scale_x = 1.0,
        scale_y = 1.0,
        pos_x   = 0
      }, objects );

    end;

  end;

  ui.obj.Set( "obj_int_dialog_deficient_character", 
  { 
    active = true, visible = true 
  }, objects ); 
  ui.obj.Set( "btn_int_dialog_deficient_goto", 
  { 
    active = true, visible = true, input = true 
  }, objects ); 

  local caption = "str_int_dialog_deficient_caption";
  local title   = "str_int_dialog_deficient_message_title";

  if ( currency == "item" ) then

    local postfix = "_item";

    caption = caption .. postfix;
    title   = title   .. postfix;

    ui.obj.Set( "anm_int_dialog_deficient_window", 
    { 
      speak = "str_int_dialog_deficient_message_"..currency.."_"..solution
    }, objects ); 

  elseif ( currency == "resources" ) then

    ui.obj.Set( "anm_int_dialog_deficient_window", 
    { 
      speak = StringGet( "str_int_dialog_deficient_message_"..currency.."_"..solution, 
                           StringGet( "str_resource_name_"..currency ) ) 
    }, objects ); 

  end;

  ui.obj.Set( "anm_int_dialog_deficient_window", 
  { 
    title = caption, 
    desc = title 
  }, objects );

  ObjMultiSet( objects );
  
  ui.button.SetText(
    "btn_int_dialog_deficient_goto",
    "str_int_dialog_deficient_goto_"..currency.."_"..solution
  );

  private.Hero_PlayAnim();

end;
--------------------------------------------------------------------------------
function private.Hero_PlayAnim ()

  ui.anim.Play( private.player_skin, "static", private.Hero_PlayAnim );

end;
--------------------------------------------------------------------------------