-- name=int_dialog_friend
--************************************************************************************************************************
--************************************************************************************************************************
function public.Init ()

  ui.control.TapSet( "btn_int_dialog_friend_mid_exit",
  {
    anim = { type = "object_scale", value = 1.0 },
    func_true = function ()

      private.Hide();

    end,
    func_menter = function ()

      --[[FF]] SetCursor( CURSOR_HAND );

    end,
    func_mleave = function ()

      --[[FF]] SetCursor( CURSOR_DEFAULT );

    end
  } );

  ui.control.TapSet( "btn_int_dialog_friend_add",
  {
    func_true = function ()

      private.BtnFindClick();

    end,
    func_menter = function ()

      --[[FF]] SetCursor( CURSOR_HAND );

    end,
    func_mleave = function ()

      --[[FF]] SetCursor( CURSOR_DEFAULT );

    end
  } );

  private.friend_keyboard_token = {};

  private.waiting_obj   = cmn.GetObjParamsForSet( "obj_int_dialog_friend_default_waiting" );
  private.waiting_back  = cmn.GetObjParamsForSet( "spr_int_dialog_friend_default_waiting_back" );
  private.waiting_txt   = cmn.GetObjParamsForSet( "txt_int_dialog_friend_default_waiting" );

  ObjSet( "obj_int_dialog_friend_bot_list_found_players_scroll_pages_lft_arrow", { active = false, visible = false , input = false } );
  ObjSet( "obj_int_dialog_friend_bot_list_found_players_scroll_pages_rgt_arrow", { active = false, visible = false , input = false } );

  private.InitListFound();

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.DisableInputFor( time )

  private.can_search = false;

  ObjAnimate( "int_dialog_friend", "alp", 0, 0, function() private.can_search = true; end,
  {
    0,    0,  1.0,   
    time, 0,  1.0
  } );

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.GetOurId ()

  local userId = "3758745"; --tostring( AuthGetUserId() );

  return userId;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function public.Show ( func_contacts )

  private.can_search = true;
  private.find_user  = true;

  private.GetContacts = func_contacts;

  local our_id = private.GetOurId();

  if not ( our_id == "" ) then

    ObjSet( "txt_int_dialog_friend_ourid",    { param0 = tostring( our_id ) } );

  else

    ObjSet( "txt_int_dialog_friend_ourid",    { param0 = "No connection" } );

  end;

  ObjSet( "txt_int_dialog_friend_found",    { param0 = tostring( "" ) } );

  ObjSet( "obj_int_dialog_friend_mid_find", { alp = 1 } );

  private.AddKeyboardToken( "tdt_int_dialog_friend_mid_find", private.friend_keyboard_token );

  private.KeyboardShow();

  ObjSet( "tdt_int_dialog_friend_mid_find", { trg_enter = function()
 
      private.BtnFindClick();

  end;} );

  private.CheckLengthName( true );

  view.DialogShow( "int_dialog_friend", "", "interface_inside" );

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.CheckLengthName ( enable )

  local obj_tmr     = "tmr_int_dialog_friend_mid_find_check";
  local test_txt    = "txt_int_dialog_friend_mid_find_test";
  local obj_text    = "tdt_int_dialog_friend_mid_find"; 
  local max_length  = ObjGet( obj_text ).maxchars;
  local max_width   = 220;
  local pos_x       = ObjGet( obj_text ).pos_x;
  
  private.current_w  = ObjGet( obj_text ).draw_width;
  private.previous_w = ObjGet( obj_text ).draw_width;
  
  local function func_check()

    local text         = ObjGet( obj_text ).text;
    local width_text   = ObjGet( obj_text ).draw_width;
    local length_text  = string.len( text );

    local shift_value  = 0;

    private.current_w  = width_text;

    if ( ( private.current_w ~= private.previous_w ) and private.list_found_show ) then 

      private.LFHide();

    end;

    if ( ( width_text > max_width ) and ( length_text <= max_length ) ) then

      if ( private.current_w ~= private.previous_w ) then 
 
        ObjSet( test_txt, { text = last_letter } );

        shift_value = width_text - max_width;

        if ( shift_value <= 0 ) then
  
          shift_value = 0;

        end;

        ObjSet( obj_text, { pos_x = pos_x - shift_value } );

      end;

    else 

      ObjSet( obj_text, { pos_x = pos_x } );
  
    end;

    ObjSet( obj_tmr, { playing = true, active = true, time = 0.01, endtrig = func_check } );

    private.previous_w = private.current_w;

  end; 

  if ( enable ) then
     
    ObjSet( obj_tmr, { playing = true, active = true, time = 0.01, endtrig = func_check } );
  
  else 

    ObjSet( obj_tmr, { playing = false, active = false } );

  end;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.KeyboardShow ()

  if ( GetPlatform() == "ios" ) then

    ObjSet( "btn_int_dialog_friend_add", { active = false, visible = false } );

     --private.DeleteKeyboardToken( private.friend_keyboard_token );

  end;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.BtnFindClick()

  if ( private.can_search ) then

    local userId = ObjGet( "tdt_int_dialog_friend_mid_find" ).text;
    local ourId  = private.GetOurId() or 0;

    if ( ( userId == "" ) or ( tonumber( userId ) == 0 ) or ( tonumber( userId ) == tonumber( ourId ) ) ) then

      local params = {};

      params[ "trg_accept" ] = function () 

        int.DialogCommonHide( "information", "nofindfriend" );

        private.KeyboardShow();

      end; 

      --int.DialogCommonShow( "information", "nofindfriend", params );

      return false;

    else

      private.can_search = false;
    
      private.LFUpdate( userId );

    end;

  end;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.Hide ()

  local func_end = function()

    v_interface.window.Hide( "int_dialog_friend" );

    private.find_user = false;

    private.LFHide();

  end;

  view.DialogHide( "int_dialog_friend", --[[FF]]func_end, "interface_outside" );

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.LoadingShow ()

  local waiting_obj = "obj_int_dialog_friend_mid_waiting";
  local waiting_spr = "spr_int_dialog_friend_mid_waiting_back";
  local waiting_txt = "txt_int_dialog_friend_mid_waiting";

  local parent_hub  = "obj_int_dialog_friend";

  if ObjGet( waiting_obj ) then

    return false;

  end;

  ObjCreate( waiting_obj, "obj"  );
  ObjCreate( waiting_spr, "spr"  );
  ObjCreate( waiting_txt, "text" );

  ObjSet( "obj_int_dialog_friend", { input = 0 } );

  ObjSet( waiting_obj, private.waiting_obj  );
  ObjSet( waiting_obj, { pos_x = 0, pos_y = 140, alp = 0 }  );
  ObjSet( waiting_spr, private.waiting_back );
  ObjSet( waiting_txt, private.waiting_txt  );

  ObjAttach( waiting_obj, parent_hub  );
  ObjAttach( waiting_spr, waiting_obj );
  ObjAttach( waiting_txt, waiting_obj );

  local alp = ObjGet( waiting_obj ).alp;

  ObjAnimate( waiting_obj, "alp", 0, 0, "", 
  {
    0.0, 3, alp,
    0.2, 3, 1
  } );

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.LoadingHide ()

  local waiting_name = "obj_int_dialog_friend_mid_waiting";
  local waiting_txt  = "txt_int_dialog_friend_mid_waiting";

  local function end_func ()

    ObjSet( "obj_int_dialog_friend", { input = 1 } );

    ObjDelete( waiting_name );

    private.hide_waiting = false;

  end;

  if ObjGet( waiting_name ) and not( private.hide_waiting ) then

    local function start_func ()

      local waiting_alp = ObjGet( waiting_name ).alp;
      local txt_alp     = ObjGet( waiting_txt ).alp;

      ObjAnimate( waiting_name, "alp", 0, 0, end_func, 
      {
        0.0,  3, waiting_alp, 
        1,    3, 0
      } );

    end;

    private.hide_waiting = true;

    local tmr_waiting = "tmr_int_dialog_friend_mid_waiting_hide";

    ObjCreate( tmr_waiting, "timer" );
    ObjAttach( tmr_waiting, waiting_name );
    ObjSet(    tmr_waiting, { time = 0.5, endtrig = start_func, playing = true });    

  end;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.KeyboardCheckKey ( key )

  local keys = { "1","2","3","4","5","6","7","8","9","0" };

  for i = 1, #keys, 1 do

    if keys[i] == key then

      return true;

    end;

  end;

  return false;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.AddKeyboardToken ( text_field, token )

  for i = 1, #common.KeyboardKeypads() do

    local cur_keypad = common.KeyboardKeypads()[i]

    if ( cur_keypad == "Ok" ) then

      token[i] = mediator.Subscribe( "instant", "keyboard:tapped_Ok", function ()

          local text = ObjGet( text_field ).text;

          if ( tonumber( text ) ~= private.GetOurId() ) and ( tonumber( text ) ~= 0 ) then

            private.BtnFindClick();

          end;

      end );

    elseif ( cur_keypad == "Backspace" ) then

      token[i] = mediator.Subscribe( "instant", "keyboard:tapped_Backspace", function ()

        local out_text = ObjGet( text_field ).text; 

        local set_text = string.sub( out_text, 1, string.len ( out_text ) - 1 );  

        if ( set_text == "" ) then
  
          ObjSet( text_field, { text = " " } );
          ObjSet( text_field, { text = "" } );
      
        else

          ObjSet( text_field, { text = set_text } );

        end;

      end );

    else
     
      if ( private.KeyboardCheckKey( cur_keypad ) ) then

        token[i] = mediator.Subscribe( "instant", "keyboard:tapped_"..cur_keypad, function ()

          local text_in_field = ObjGet( text_field ).text;

          if ( string.len( text_in_field ) < 9 ) then

            ObjSet( text_field, { text = text_in_field..cur_keypad });

          end;

        end );

      else

        token[i] = mediator.Subscribe( "instant", "keyboard:tapped_"..cur_keypad, function ()

        end );

      end;

    end;

  end;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.DeleteKeyboardToken( token )

  for i = 1, #common.KeyboardKeypads() do

    mediator.Unsubscribe( "keyboard:tapped_"..common.KeyboardKeypads()[i], token[i] );

  end;

  token = {};

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.Close ()

  private.CheckLengthName( false );

  ObjSet( "tdt_int_dialog_friend_mid_find", { text = " " } );
  ObjSet( "tdt_int_dialog_friend_mid_find", { text = "" } );

  ObjSet( "obj_int_dialog_friend_mid_info", { active = false, visible = false, input = false } );
  ObjSet( "obj_int_dialog_friend_mid_find", { active = true,  visible = true, input = true } );

  if ( GetPlatform() == "ios" ) then

     private.DeleteKeyboardToken( private.friend_keyboard_token );    

  end; 

end;

--************************************************************************************************************************
--************************************************************************************************************************
--function -----list_found-----() end:
--********************************************************************************************************************
--********************************************************************************************************************
function private.InitListFound ( )

  private.table = {};
  private.current = { page = {} };
  private.list_found = {};
  private.list_found_pos = { show = { pos_x = 0, pos_y = 0 }, hide = { pos_x = 0, pos_y = -470 } };
  private.players_at_page = 5;


  ObjSet( "obj_int_dialog_friend_mid_list_found", { pos_x = 0, pos_y = 0 } );
  ObjSet( "obj_int_dialog_friend_mid_list_found_players", { pos_x = private.list_found_pos.hide.pos_x, pos_y = private.list_found_pos.hide.pos_y } );

  private.objects_empty_tab = {};

  private.def = {};
  private.def.player = {};
  private.def.player.hub              = cmn.GetObjParamsForSet( "obj_int_dialog_friend_default" );
  private.def.player.bg               = cmn.GetObjParamsForSet( "spr_int_dialog_friend_default_avatar_bg" );
  private.def.player.icon             = cmn.GetObjParamsForSet( "spr_int_dialog_friend_default_avatar_icon" );
  private.def.player.name             = cmn.GetObjParamsForSet( "txt_int_dialog_friend_default_player_name" );
  private.def.player.id               = cmn.GetObjParamsForSet( "txt_int_dialog_friend_default_player_id" );
  private.def.player.status           = cmn.GetObjParamsForSet( "txt_int_dialog_friend_default_player_status" );
  private.def.player.level_hub        = cmn.GetObjParamsForSet( "obj_int_dialog_friend_default_avatar_level" );
  private.def.player.level_bg         = cmn.GetObjParamsForSet( "spr_int_dialog_friend_default_avatar_level_bg" );
  private.def.player.level_count      = cmn.GetObjParamsForSet( "txt_int_dialog_friend_default_avatar_level_count" );
  private.def.player.btn_add          = cmn.GetObjParamsForSet( "btn_int_dialog_friend_default_add" );
  private.def.player.btn_add_bg       = cmn.GetObjParamsForSet( "spr_int_dialog_friend_default_add_bg" );

  private.container                   = cmn.GetObjParamsForSet( "scc_int_dialog_friend_default" );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- удаление scc
function private.LFContainerDelete()

  if ( private.table.found ) then

    if ( private.table.found.page_max ) then

      for page = 1, private.table.found.page_max do

        ObjDelete( "obj_int_dialog_friend_mid_list_found_players_page_"..page.."_container" );
        ObjDelete( "obj_int_dialog_friend_mid_list_found_players_page_"..page );

      end;

    end;

    if ( private.table.found.scc_name ) then

      local scc_name = private.table.found.scc_name;

      int.scc.ContainerDelete( scc_name );

    end;

    private.table.found = nil;

  end;

  ObjDelete( "txt_int_dialog_friend_mid_list_found_players_empty" );
  ObjDelete( "obj_int_dialog_friend_list_found_storage" );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- обновить список найденных
function private.LFUpdate ( id )

  local need_to_animate = true;

  if ( private.list_found_show ) then

    private.LFContainerDelete();

    need_to_animate = false;

  end;

  private.LFShow( id, need_to_animate );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- показать список найденных
function private.LFShow ( id, animation )

  private.DisableInputFor( 1.0 );

  local panel_name = "obj_int_dialog_friend_mid_list_found";
  local hub_name   = "obj_int_dialog_friend_bot";

  ObjAttach( panel_name, hub_name );

  private.list_found_show = true;

  private.LFCreate( id );

  local func_show = function ()

    private.LFAnim( "show" );

  end;

  local function func_animate()

    ObjAnimate( panel_name, "alp", 0, 0, func_show,
    {
      0,   0,  0.0,
      0.3, 0,  1.0
    } );

  end;

  if ( animation ) then

    func_animate();

  else

    func_show();
      
  end;

  ObjDelete( "txt_int_dialog_friend_mid_list_found_players_empty" );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- скрыть список найденных
function private.LFHide ()

  private.DisableInputFor( 0.7 );
  
  local panel_name  = "obj_int_dialog_friend_mid_list_found";

  private.list_found_show = false;

  local end_anm = function()

    private.LFContainerDelete();

    ObjDetach( panel_name );

  end;

  ObjSet( "txt_int_dialog_friend_found", { param0 = "0" } );

  private.LFAnim( "hide" );

  ObjAnimate( panel_name, "alp", 0, 0, end_anm,
    {
      0,   0,  1,
      0.2, 0,  1,
      0.4, 0,  0,
    }
  );
  
end;
--********************************************************************************************************************
--********************************************************************************************************************
-- создание содержимого списка
function private.LFCreate ( id )

  local frame = ObjGet( "grd_int_dialog_friend_mid_bg_2" ).frame;
  local width  = 516;
  local height = 452;
  local tex_height = height/64;
  local step = 40;
  local offset = -190;

  private.LFGetData( id );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- анимация сворачивания, разворачивания списка
function private.LFAnim ( param )

  local end_positions = private.list_found_pos;

  local panel_mid     = "obj_int_dialog_friend_mid_list_found_players";

  local start_pos = ObjGet( panel_mid ).pos_y;
  local end_pos   = end_positions[ param ].pos_y;

  local function set_input ()

    if ( param == "hide" ) then

      private.list_found_show = false;

      local frame_1 = ObjGet( "grd_int_dialog_friend_mid_bg_1" ).frame;

      GridSet( "grd_int_dialog_friend_mid_bg_1", frame,
      {
         0, { pos_y = 0 },    1, { pos_y = 0 },    2, { pos_y = 0 },    3, { pos_y = 0 },
         4, { pos_y = 136 },  5, { pos_y = 136 },  6, { pos_y = 136 },  7, { pos_y = 136 },
         8, { pos_y = 176 },  9, { pos_y = 176 }, 10, { pos_y = 176 }, 11, { pos_y = 176 },
        12, { pos_y = 304 }, 13, { pos_y = 304 }, 14, { pos_y = 304 }, 15, { pos_y = 304 }
      } );

      local frame_2 = ObjGet( "grd_int_dialog_friend_mid_bg_2" ).frame;

      GridSet( "grd_int_dialog_friend_mid_bg_2", frame,
      {
         0, { pos_y = 0 },    1, { pos_y = 0 },    2, { pos_y = 0 },    3, { pos_y = 0 },
         4, { pos_y = 124 },  5, { pos_y = 124 },  6, { pos_y = 124 },  7, { pos_y = 124 },
         8, { pos_y = 164 },  9, { pos_y = 164 }, 10, { pos_y = 164 }, 11, { pos_y = 164 },
        12, { pos_y = 278 }, 13, { pos_y = 278 }, 14, { pos_y = 278 }, 15, { pos_y = 278 }
      } );
    
    end;

  end;

  ObjAnimate( panel_mid, "pos_y", 0, 0, set_input,
  {
    0,   0,  start_pos,
    0.0, 0,  end_pos
  } );

  if ( private.list_found_show ) then

    local frame_1 = ObjGet( "grd_int_dialog_friend_mid_bg_1" ).frame;

    GridSet( "grd_int_dialog_friend_mid_bg_1", frame_1,
    {
       0, { pos_y = 0 },    1, { pos_y = 0 },    2, { pos_y = 0 },    3, { pos_y = 0 },
       4, { pos_y = 136 },  5, { pos_y = 136 },  6, { pos_y = 136 },  7, { pos_y = 136 },
       8, { pos_y = 596 },  9, { pos_y = 596 }, 10, { pos_y = 596 }, 11, { pos_y = 596 },
      12, { pos_y = 724 }, 13, { pos_y = 724 }, 14, { pos_y = 724 }, 15, { pos_y = 724 }
    } );

    local frame_2 = ObjGet( "grd_int_dialog_friend_mid_bg_2" ).frame;

    GridSet( "grd_int_dialog_friend_mid_bg_2", frame,
    {
       0, { pos_y = 0 },    1, { pos_y = 0 },    2, { pos_y = 0 },    3, { pos_y = 0 },
       4, { pos_y = 124 },  5, { pos_y = 124 },  6, { pos_y = 124 },  7, { pos_y = 124 },
       8, { pos_y = 584 },  9, { pos_y = 584 }, 10, { pos_y = 584 }, 11, { pos_y = 584 },
      12, { pos_y = 698 }, 13, { pos_y = 698 }, 14, { pos_y = 698 }, 15, { pos_y = 698 }
    } );

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- создание структуры постраничного вывода результата поиска 
function private.LFStructurePagesCreate ( answer, runtime )

  local page_count    = -1;
  local page_count    = 0;
  local page_object   = "";

  local row_count     = 0;
  local row_offset    = 0;
  local row_step      = 90;

  local pos_player = { pos_x = 0, pos_y = 0 };
  local table_obj = "int_dialog_friend_mid_list_found_players";
  local hub_table_obj = string.format( "obj_%s", table_obj );

  local params_def = 
  {
    scc_name      = "",
    page_previous = 1,
    page_current  = 1,
    page_max      = 1,
    pages         = {},
    list          = {},
  };

  private.table.found = params_def;
  private.list_found = {};

  ObjSet( "txt_int_dialog_friend_found", { param0 = tostring( #answer ) } );
  -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
  if ( #answer > 0 ) then

    local scc_obj = string.format( "%s_list", table_obj );
    private.table.found.scc_name = scc_obj;

    int.scc.ContainerCreate( scc_obj, private.container, false, nil );

    local storage_name = "obj_int_dialog_friend_list_found_storage";
    ObjCreate( storage_name, "obj" );
    ObjAttach( storage_name, "obj_int_dialog_friend_storage" ); 

    for i = 1, #answer do

      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
      -- проверяем "умещается" ли объект на странице, если НЕТ то переходим на следующую страницу
      if ( math.fmod( i, private.players_at_page ) == 1 ) then

        row_count = 0;
        page_count = page_count + 1;
        page_object = string.format( "obj_%s_page_%i", table_obj, page_count );

        ObjCreate( page_object, "obj" );
        ObjAttach( page_object, string.format( "scc_%s", scc_obj ) );
        private.table.found.pages[ "page_"..page_count ] = { created = false, players = {} };

        local page_container = string.format( "%s_container", page_object );  
        ObjCreate( page_container, "obj" );
        ObjAttach( page_container, storage_name );

      end;

      row_count = row_count + 1;
      pos_player.pos_y = ( ( row_count - 3 ) * row_step ) + row_offset;

      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

      local player = answer[ i ];

      private.list_found[ player.userId ]               = {};
      private.list_found[ player.userId ].data          = player;
      private.list_found[ player.userId ].page          = page_count;
      private.list_found[ player.userId ].cmn_name      = scc_obj;
      private.list_found[ player.userId ].table         = "found";
      private.list_found[ player.userId ].pos_player    = pos_player;

      table.insert( private.table.found.list, player.userId );
      table.insert( private.table.found.pages[ "page_"..page_count ].players, player.userId );

    end;

    local first_name = string.format( "obj_%s_page_%i", table_obj, 1 );

    int.scc.ContainerSet( scc_obj, { first = first_name, amount = page_count } );

    int.scc.SetUpdateHandler( scc_obj, function ( pos_cur, pos_max, arrow_dec_active, arrow_inc_active )

      private.LFPageActive( pos_cur );

      ObjSet( "txt_int_dialog_friend_bot_list_found_players_scroll_pages", { param0 = pos_cur, param1 = pos_max } );
      ObjSet( "obj_int_dialog_friend_bot_list_found_players_scroll_pages_lft_arrow", { active = arrow_dec_active, visible = arrow_dec_active, input = arrow_dec_active } );
      ObjSet( "obj_int_dialog_friend_bot_list_found_players_scroll_pages_rgt_arrow", { active = arrow_inc_active, visible = arrow_inc_active, input = arrow_inc_active } );

    end );

    private.table.found.page_max = page_count;

  else

    local object_txt_empty       = string.format( "txt_%s_empty", table_obj );
    ObjCreate( object_txt_empty, "text"   );
    ObjSet( object_txt_empty,    private.def.player.name ); 
    ObjSet( object_txt_empty,    { pos_y = 50, text = "str_int_dialog_friend_list_found_empty", align = 1, pos_x = 0 } );
    ObjAttach( object_txt_empty, hub_table_obj );      

    table.insert( private.objects_empty_tab, object_txt_empty );

    private.table.found.scc_name = nil;

    ObjSet( "txt_int_dialog_friend_bot_list_found_players_scroll_pages", { param0 = 1, param1 = 1 } );
    ObjSet( "obj_int_dialog_friend_bot_list_found_players_scroll_pages_lft_arrow", { active = false, visible = false , input = false } );
    ObjSet( "obj_int_dialog_friend_bot_list_found_players_scroll_pages_rgt_arrow", { active = false, visible = false , input = false } );
             

  end;

  private.GoPage(1);

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- получить результаты поиска
function private.LFGetData ( request )

  private.list_found = {};
  local list_found = {};

  if ( request ) then

    local list_friends = private.GetContacts( "all" );
  
    local command = "";
    local url_type = "";
    local data = {};

    local function func_process( list_found_players )

      if ( list_found_players ) then

        list_found_players = private.LFArrayProcess( list_found_players, list_friends );

      else

        list_found_players = {};

      end;

      private.LFStructurePagesCreate( list_found_players, false );

    end;

    local func_answer = nil;

    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
    if ( string.find( request, "%D" ) ) then

      -- -- -- В случае наличия чего-то кроме цифр в запросе, ищем по имени
      command = Event_Social_FoundUsersByName;
      url_type = "findUserByName";
      data = { nameToFind = request, userId = tostring( private.GetOurId() ) };

      func_answer = function( msg, pTable )

        common.MessageUnsubscribe( command, func_answer );

        if --[[TEMP]]( pTable.data ) and ( #pTable.data.result.userArray > 0 ) then

          list_found = pTable.data.result.userArray;
  
          func_process( list_found );

        else

          func_process();

        end;

      end;

    else

      -- -- -- В случае наличия только цифр в запросе, ищем по Id
      command = Event_Social_FoundUsersById;
      url_type = "findUserById";
      data = { userId = request };

      func_answer = function( msg, pTable )

        common.MessageUnsubscribe( command, func_answer );

        if --[[TEMP]]( pTable.data ) and ( pTable.data.result.user ) then

          list_found[ 1 ] = pTable.data.result.user;

          func_process( list_found );

        else

          func_process();

        end;

      end;

    end;

    -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
   --[[ TEMP local url = ConfigCreateActionUrl( "user", url_type );
    local request_info = { url = url, data = data }; ]]

    common.MessageSubscribe( command, func_answer );

    --[[ TEMP NetSendHttpRequest( request_info, command ); ]]

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- показать страницу с игроками
function private.LFPageShow ( page )

  if not ( private.table.found ) then

    return;

  end;

  if not ( private.table.found.pages[ "page_"..page ] ) then
  
    return;

  end;

  local players         = private.table.found.pages[ "page_"..page ].players;
  local page_created    = private.table.found.pages[ "page_"..page ].created;
  local table_obj       = "int_dialog_friend_mid_list_found_players";
  local page_object     = string.format( "obj_%s_page_%i", table_obj, page );
  local page_container  = string.format( "%s_container", page_object ); 

  ObjAttach( page_container, page_object ); 

  if not ( page_created ) then

    local row_count     = 0;
    local row_offset    = 0;
    local row_step      = 76;

    local pos_player  = { pos_x = 0, pos_y = 0 };

    --ObjAttach( item_hub_object, page_object );

    local dummy_amount = math.abs( math.fmod( #players, private.players_at_page ) - private.players_at_page );

    for i = 1, #players + dummy_amount do

      row_count = row_count + 1;
      pos_player.pos_y = ( ( row_count - 3 ) * row_step ) + row_offset;

      if ( players[ i ] ) then

        local player      = players[ i ];
        local data_player = private.list_found[ player ];

        private.LFContentCreate( data_player, pos_player );

--      elseif ( i <= 5 ) then
--
--        private.LFDummyCreate( page, i, pos_player );

      end;

    end; 

    private.table.found.pages[ "page_"..page ].created = true; 

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- скрыть страницу с игроками
function private.LFPageHide ( page )

  if not ( private.table.found ) then

    return;

  end;

  if not ( private.table.found.pages[ "page_"..page ] ) then

    return;

  end;

  local players         = private.table.found.pages[ "page_"..page ].players;
  local page_created    = private.table.found.pages[ "page_"..page ].created;

  local table_obj       = "int_dialog_friend_mid_list_found_players";
  local page_object     = string.format( "obj_%s_page_%i", table_obj, page );
  local page_container  = string.format( "%s_container", page_object ); 
  local storage_name    = "obj_int_dialog_friend_storage";

  ObjAttach( page_container, storage_name );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- создать найденного "игрока" для отображения в списке
function private.LFContentCreate ( data_player, pos )

  local page_count    = data_player.page;

  local table_obj     = "int_dialog_friend_mid_list_found_players";
  local hub_table_obj = string.format( "obj_%s", table_obj );
  local scc_obj       = data_player.cmn_name;
  local pos_player    = pos;
  local page_object   = string.format( "obj_%s_page_%i", table_obj, page_count );


  local player                  = data_player.data;
  local player_obj_name         = string.format( "%s_%s",                   scc_obj, player.userId );
  local player_hub              = string.format( "obj_%s",                  player_obj_name );
  local player_avatar_bg        = string.format( "spr_%s_avatar_bg",        player_obj_name );
  local player_avatar_icon      = string.format( "spr_%s_avatar_icon",      player_obj_name );
  local player_name             = string.format( "tad_%s_player_name",      player_obj_name );
  local player_id               = string.format( "txt_%s_player_id",        player_obj_name );
  local player_status           = string.format( "txt_%s_player_status",    player_obj_name );
  local player_level_hub        = string.format( "obj_%s_avatar_level",     player_obj_name );
  local player_level_bg         = string.format( "spr_%s_level_bg",         player_obj_name );
  local player_level_count      = string.format( "txt_%s_level_count",      player_obj_name );
  local player_btn_add          = string.format( "btn_%s_add",              player_obj_name );
  local player_btn_add_bg       = string.format( "spr_%s_add_bg",           player_obj_name );


  ObjCreate( player_hub,              "obj"   );
  ObjCreate( player_avatar_bg,        "anim"  );
  ObjCreate( player_avatar_icon,      "spr"   );
  ObjCreate( player_name,             "text" );
  ObjCreate( player_id,               "text"  );
  ObjCreate( player_status,           "text"  );
  ObjCreate( player_level_hub,        "obj"   );
  ObjCreate( player_level_bg,         "anim"  );
  ObjCreate( player_level_count,      "text"  );
  ObjCreate( player_btn_add,          "obj"   );
  ObjCreate( player_btn_add_bg,       "anim"  );


  ObjSet( player_hub,              private.def.player.hub           );
  ObjSet( player_avatar_bg,        private.def.player.bg            );
  ObjSet( player_avatar_icon,      private.def.player.icon          );
  ObjSet( player_name,             private.def.player.name          );
  ObjSet( player_id,               private.def.player.id            );
  ObjSet( player_status,           private.def.player.status        );
  ObjSet( player_level_hub,        private.def.player.level_hub     );
  ObjSet( player_level_bg,         private.def.player.level_bg      );
  ObjSet( player_level_count,      private.def.player.level_count   );
  ObjSet( player_btn_add,          private.def.player.btn_add       );
  ObjSet( player_btn_add_bg,       private.def.player.btn_add_bg    );

  if ( not player.photo ) or ( tostring( player.photo ) == "" ) then

    player.photo = "nobody";

  end;

  ObjSet( player_hub,          pos_player );
  ObjSet( player_avatar_icon,  { res = string.format( "assets/shared/avatars/%s_icon", player.photo ) } );
  ObjSet( player_name,         { text = player.name } );
  ObjSet( player_id,           { text = "ID "..common.NumberForm( player.userId ) } );
  ObjSet( player_level_count,  { text = common.NumberForm( player.level + 1 ) } );


  if ( player.inList ) then

    ObjSet( player_btn_add, { active = false, input = false, visible = false; } );
    ObjSet( player_status,  { visible = true, text = player.inList } );

  else

    ui.control.TapSet( player_btn_add,
    {
      func_true = function ()

        ObjSet( player_btn_add, { active = false, input = false, visible = false; } );
        ObjSet( player_status,  { visible = true, text = "invited" } );

        common.MessageSend( Request_Social_TrySendFriendRequest, { userId = tonumber( player.userId ) } );

        --ObjSet( player_btn_add, { active = false, input = false, visible = false; } );
        --ObjSet( player_btn_add_bg, { animfunc = "quest_mark_completed", playing = true } );

      end
    } );

  end;

  ObjAttach( player_avatar_bg,         player_hub );
  ObjAttach( player_avatar_icon,       player_avatar_bg );
  ObjAttach( player_name,              player_hub );
  ObjAttach( player_id,                player_hub );
  ObjAttach( player_status,            player_hub );
  ObjAttach( player_level_hub,         player_hub );
  ObjAttach( player_level_bg,          player_level_hub );
  ObjAttach( player_level_count,       player_level_hub );
  ObjAttach( player_btn_add,           player_hub );
  ObjAttach( player_btn_add_bg,        player_btn_add );

  local page_container = string.format( "%s_container", page_object );  
  ObjAttach( player_hub, page_container );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- создать заглушку для заполнения странички, если все игроки уже отображены
function private.LFDummyCreate ( page, number, pos )

  local table_obj     = "int_dialog_friend_mid_list_found_players";
  local pos_player    = pos;
  local page_object   = string.format( "obj_%s_page_%i", table_obj, page );

  local obj_dummy = table_obj.."_dummy_"..number;

  ObjCreate( obj_dummy, "obj" );
  ObjSet(    obj_dummy, cmn.GetObjParamsForSet( "obj_int_dialog_friend_default" ) );
  ObjSet(    obj_dummy, pos_player );
  ObjAttach( obj_dummy, string.format( "%s_container", page_object ) );

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- отображение содержимого необходимых страниц
function private.LFPageActive ( page )

  local page_min        = 1;
  local page_max        = private.table.found.page_max;
  local page_cur        = page;
  local page_previous   = private.table.found.page_previous;

  local pages_show = {};
  local pages_hide = {};

  for i = 1, page_max do

    if ( ( page_min < page_cur ) and ( i == ( page_cur - 1 ) ) ) or
        ( i == page_cur ) or 
        ( ( page_max > page_cur ) and ( i == ( page_cur + 1 ) ) ) then

      private.LFPageShow( i );

    elseif ( ( i == page_previous - 1 ) ) then

        private.LFPageHide( i );

    elseif ( ( i == page_previous + 1 ) ) then

        private.LFPageHide( i );

    end;

  end

  private.table.found.page_previous = page_cur;

end;
--********************************************************************************************************************
--********************************************************************************************************************
-- переход к странице 
function private.GoPage ( to_page )

  if ( private.table.found.scc_name ) then

    local scc_name        = private.table.found.scc_name;
    local scc_objname     = string.format( "scc_%s", scc_name );
    local page            = to_page or private.current.page or private.table.found.page_current;

    private.table.found.page_current = page;

    ObjSet( scc_objname, { scrollpos = page - 1 } );

    int.scc.SetCustomArrows( scc_name, "obj_int_dialog_friend_bot_list_found_players_scroll_pages_lft_arrow", "obj_int_dialog_friend_bot_list_found_players_scroll_pages_rgt_arrow" );
    int.scc.ContainerUpdate( scc_name ); 

  end;

end;
--************************************************************************************************************************
--************************************************************************************************************************
function private.LFArrayProcess ( array_found, array_friends )

  local list_found = array_found;
  local list_friends = array_friends;
  local our_id = tostring( private.GetOurId() );
  local player_in_list = nil;

  if ( ( list_found ) and ( list_friends ) ) then

    if ( #list_found == 0 ) then

      -- Ничего не найдено

    else

      for i = 1, #list_found do

        local userId = tostring( list_found[i].userId );

        if ( userId == our_id ) then

          player_in_list = i;

        end;

        for j = 1, #list_friends do

          if ( userId == tostring( list_friends[j].userId ) ) then

            list_found[i].inList = list_friends[j].state;

          end;

        end;

      end;

    end;

  else

    -- Какой-то из листов пришел как nil

  end;

  if ( player_in_list ) then

    table.remove( list_found, player_in_list );

  end;

  return list_found;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.IsFindUser ()

  return private.find_user;

end;
--************************************************************************************************************************
--************************************************************************************************************************