-- name=int_dialog_help
--------------------------------------------------------------------------------
function  public.__InitObjects ()

  private.this = "obj_int_dialog_help";

  private.window_area = {
    default = { -272, -370, 544, 740 }
  };

  int_window.SetArea( private.this, private.window_area.default );

  ui.button.Create(
    "btn_int_dialog_help_close",
    {
      design = "close",
      sound  = "simply_click",
      pos_x  = 235,
      pos_y  = 20
    },
    function()
      
      private.Reject();
      
    end
  );

  if ( IsPC() ) then
  
    ui.button.Create(
      "btn_int_dialog_help_pagination_prev",
      {
        design = "arrow_left"
      },
      function ()

        private.Pagination_Prev();

      end 
    );
    
    ui.button.Create(
      "btn_int_dialog_help_pagination_next",
      {
        design = "arrow_right"
      },
      function ()

        private.Pagination_Next();

      end 
    );
  
  else
    
    ui.buttons.Disable(
    {
      "btn_int_dialog_help_pagination_prev",
      "btn_int_dialog_help_pagination_next" } );
    
  end;

  ui.obj.ToCenter( "obj_int_dialog_help" );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function  public.Show ( func_reject )

  private.Reject = func_reject;
  private.active = true;
  
  private.SetDefault();

  ui.window.Open( "help" );

end;
--------------------------------------------------------------------------------
function  public.Hide ( func_end )

  if not ( private.active ) then return; end;
  
  private.active = false;
  
  ui.window.Close( "help", func_end );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.SetDefault ()

  private.current_page = 1;

  ObjSet( "scc_int_dialog_help_slots",
  {
    enddragtrig = function ()
    
      private.Pagination_Set(
        ObjGet( "scc_int_dialog_help_slots" ).scrollpos + 1
      );

    end } );
    
  -- JK: no facebook block on PC
  if ( IsPC() ) then
    
    ObjSet( "obj_int_dialog_help_slot9_btm",
    {
      active  = false,
      visible = false } );
    
  end;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Pagination_Set ( page )

  if not ( private.current_page == page ) then

    ObjMultiSet( {
      { "spr_int_dialog_help_pagination_p"..page,
      {
        alp = 1.0 } },
        
      { "spr_int_dialog_help_pagination_p"..private.current_page,
      {
        alp = 0.5 } }
    } );

    private.current_page = page;

  end;

end;
--------------------------------------------------------------------------------
function private.Pagination_Prev ()
  
  local scrollpos = ui.scroller.Prev(
    "scc_int_dialog_help_slots",
    9,
    true
  );
  
  private.Pagination_Set( scrollpos + 1 );
  
end;
--------------------------------------------------------------------------------
function private.Pagination_Next ()
  
  local scrollpos = ui.scroller.Next(
    "scc_int_dialog_help_slots",
    9,
    true
  );
  
  private.Pagination_Set( scrollpos + 1 );
  
end;
--------------------------------------------------------------------------------