-- name=int_dialog_language
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Select = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.orientation = ui.screen.Orientation();

  private.scc_size =
  {
    portrait  = { w = 550, h = 600 }, 
    landscape = { w = 550, h = 600 } 
  };

  private.window_area =
  {
    portrait  = { -230, -320, 460, 640 },
    landscape = { -230, -320, 460, 640 }
  };

  local multiset = {};
  
  ui.obj.ToCenter( "obj_int_dialog_language", 0, 0, multiset );

  ui.window.SetArea(
    "obj_int_dialog_language",
    private.window_area[ private.orientation ],
    multiset
  );

  ui.button.Create( "btn_int_dialog_language_close",
    {
      design = "close"
    },
    function () private.Hide(); end
  );

  local size = private.scc_size[ private.orientation ];

  ui.obj.Set(
    "scc_int_dialog_language",
    {
      inputrect_init = true,
      inputrect_x   = - size.w / 2,
      inputrect_y   = - size.h / 2,
      inputrect_w   =   size.w,
      inputrect_h   =   size.h,

      croprect_init = true,
      croprect_x    = - size.w / 2,
      croprect_y    = - size.h / 2,
      croprect_w    =   size.w,
      croprect_h    =   size.h
    },
    multiset
  );

  ui.obj.Set(
    "anm_int_dialog_language_window",
    {
      animfunc = "static_"..private.orientation,
      title    = "str_int_dialog_language_title",
      tt_desc  = "str_int_dialog_language_desc"
    },
    multiset
  );

  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( language, list )

  private.SetDefaults( language, list );

  ui.window.Open( "language" );

end;
--------------------------------------------------------------------------------
function private.Hide ( func_after )

  func_after = func_after or function () end;

  ui.window.Close( "language", function ()

    ui.window.Hide( "int_dialog_language", func_after );

  end );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.SetDefaults ( language, list )

  local objects = {};
  
  local slot_name = "int_dialog_language_slot";
  local anm_name  = "anm_"..slot_name;
  local spr_name  = "spr_"..slot_name; 
  
  for l = 1, #list do
    
    local postfix = "_"..list[ l ];
    
    if not ( private.created ) then
      ui.obj.Clone( anm_name, 
                    "scc_int_dialog_language", 
                    postfix, true );      
    end;
                 
    local animfunc = tern( language == list[ l ] )( "language_active", "language" );
    ui.obj.Set( anm_name..postfix, {
      tt_language = "str_int_dialog_language"..postfix,
      animfunc    = animfunc
    }, objects );
    ui.obj.Set( spr_name.."_flag"..postfix, {
      res = "assets/content/interface/int_dialog_options/"..list[ l ]
    }, objects );

    ui.control.EventsSet( anm_name..postfix, 
    { 
      func_on_click = function () _f.Select( list[ l ] ); end 
    } );    
    
  end;
  
  ui.obj.Multiset( objects );
  
  private.created = true;

end;
--------------------------------------------------------------------------------