-- name=int_dialog_map_build_gift
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Open  = function () end,
  Close = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.Adapt();
  private.CreateButtons();

  private.strings = {
    title_booster = ne.strings.Get( "str_int_dialog_map_build_gift_caption_booster" ),
    title_gold    = ne.strings.Get( "str_int_dialog_map_build_gift_caption_gold" )
  };

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( build_name, gift )

  if ( private.active ) then
    return;
  end;

  private.active = true;

  private.SetDefault( gift );

  ui.window.Open( "map_build_gift", _f.Open );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_preclose, func_close )

  if ( not private.active ) then
    return;
  end;

  private.active = false;

  if ( func_preclose ) then
    func_preclose();
  end;

  ui.window.Close( "map_build_gift", function()
    if ( func_close ) then
      func_close();
    end;
  end );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  private.this = "obj_int_dialog_map_build_gift";

  ui.obj.ToCenter( private.this );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()

  ui.button.Create(
    "btn_int_dialog_map_build_gift_accept",
    {
      title  = "str_int_dialog_map_build_gift_accept",
      design = "medium",
      color  = "green",
      sound  = "simply_click"
    },
    function() _f.Close(); end
  );

  ui.control.EventsSet(
    "obj_int_dialog_map_build_gift_content",
    {
      func_on_click = function() _f.Close(); end
    }
  );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( gift )

  local multiset = {};

  if ( gift.type == "booster" ) then
    
    local booster_res_name = tern( gift.phase )( gift.phase, gift.name );
    
    ui.obj.Set(
      "spr_int_dialog_map_build_gift_content_icon",
      {
        res = ui.obj.Res( "booster", booster_res_name );
      },
      multiset
    );
    
    ui.obj.Set(
      "anm_int_dialog_map_build_gift_window",
      {
        title         = private.strings.title_booster,
        reward_title  = StringGet( "str_int_dialog_map_build_gift_title_booster",
                        StringGet( "str_item_"..gift.name.."_caption" ),
                        gift.count ),
        reward_count  = "x"..gift.count,
        reward_desc   = StringGet( "str_item_"..gift.name.."_description" )
      },
      multiset
    );

  end;

  if ( gift.type == "gold" ) then

    ui.obj.Set(
      "anm_int_dialog_map_build_gift_window",
      {
        title        = private.strings.title_gold,
        reward_title = StringGet( "str_item_gold_caption" ),
        reward_count = "x"..gift.count,
        reward_desc  = StringGet( "str_item_gold_description" )
      },
      multiset
    );

  end;

  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------