-- name=int_dialog_map_build_market
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Accept       = function () end,
  Close        = function () end,
  ShowTopPanel = function () end,
  HideTopPanel = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.orientation = ui.screen.Orientation();  

  private.window_area = {
    [ "portrait"  ] = { -275, -350, 550, 600 },
    [ "landscape" ] = { -275, -300, 550, 600 }
  };

  local area = private.window_area[ private.orientation ];
  ui.window.SetArea( "obj_int_dialog_map_build_market", area );
  
  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( gold_count )

  if ( private.active ) then

    return;

  end;

  private.active = true;

  ui.window.Open( "map_build_market", _f.ShowTopPanel );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_execute )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  _f.HideTopPanel();

  ui.window.Close( "map_build_market", func_execute );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  ui.obj.ToCenter( "obj_int_dialog_map_build_market" );

  ObjSet( "anm_int_dialog_map_build_market_window",
    {
      animfunc    = "static_" .. private.orientation,
      title       = StringGet( "str_int_dialog_map_build_market_caption" ),
      description = StringGet( "str_int_dialog_map_build_market_description" )
    }
  );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()

  ui.button.Create(
    "btn_int_dialog_map_build_market_close",
    {
      design = "close",
    },
    function () _f.Close(); end
  );
  
  ui.button.Create(
  "btn_int_dialog_map_build_market_accept",
    {
      title  = "str_int_dialog_map_build_market_accept",
      color  = "green",
      design = "medium",
    },
    function()
      
      _f.Accept();
      _f.Close();
      
    end
  );  

end;
--------------------------------------------------------------------------------
