-- name=int_dialog_map_chest
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Open  = function () end,
  Close = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.Adapt();
  private.CreateButtons();

  private.strings = {
    title_booster = ne.strings.Get( "str_int_dialog_map_chest_caption_booster" ),
    title_gold    = ne.strings.Get( "str_int_dialog_map_chest_caption_gold" )
  };

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( chest_name, chest_content )

  if ( private.active ) then

    return;

  end;

  private.active = true;

  private.SetDefault( chest_content );

  ui.window.Open( "map_chest", _f.Open );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_preclose, func_close )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  if ( func_preclose ) then

    func_preclose();

  end;

  ui.window.Close( "map_chest", function()

    if ( func_close ) then

      func_close();

    end;

  end );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  private.this = "obj_int_dialog_map_chest";

  ui.obj.ToCenter( private.this );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()

  ui.button.Create(
    "btn_int_dialog_map_chest_accept",
    {
      title  = "str_int_dialog_map_chest_accept",
      design = "medium",
      color  = "green",
      sound  = "simply_click"
    },
    function() _f.Close(); end
  );

  ui.control.EventsSet(
    "obj_int_dialog_map_chest_content",
    {
      func_on_click = function() _f.Close(); end
    }
  );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( chest_content )

  local multiset = {};

  if ( chest_content.type == "booster" ) then
    
    local booster_res_name = tern( chest_content.phase )( chest_content.phase, chest_content.name );
    
    ui.obj.Set(
      "spr_int_dialog_map_chest_content_icon",
      {
        res = ui.obj.Res( "booster", booster_res_name );
      },
      multiset
    );
    
    ui.obj.Set(
      "anm_int_dialog_map_chest_window",
      {
        title         = private.strings.title_booster,
        reward_title  = StringGet( "str_int_dialog_map_chest_title_booster",
                        StringGet( "str_item_"..chest_content.name.."_caption" ),
                        chest_content.count ),
        reward_count  = "x"..chest_content.count,
        reward_desc   = StringGet( "str_item_"..chest_content.name.."_description" )
      },
      multiset
    );

  end;

  if ( chest_content.type == "gold" ) then

    ui.obj.Set(
      "anm_int_dialog_map_chest_window",
      {
        title        = private.strings.title_gold,
        reward_title = StringGet( "str_item_gold_caption" ),
        reward_count = "x"..chest_content.count,
        reward_desc  = StringGet( "str_item_gold_description" )
      },
      multiset
    );

  end;

  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------