-- name=int_dialog_minievent_crown_continue
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Accept = function () end,
  Reject = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_dialog_minievent_crown_continue" );

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  local app_w = ui.screen.Width();
  local app_h = ui.screen.Height();

  private.app_o = ui.screen.Orientation();
  private.this = "obj_int_dialog_minievent_crown_continue";

  private.window_area = {
    default  = { -272, -300, 544, 600 }
  };

  local multiset = {};

  ui.window.SetArea( private.this, private.window_area.default, multiset );
  ui.obj.ToCenter( private.this, 0, 0, multiset );

  ui.obj.Set(
    "spr_int_dialog_minievent_crown_continue_bg_black",
    {
      scale_x = app_w / 64,
      scale_y = app_h / 64,
    },
    multiset
  );

  ui.obj.Multiset( multiset );
  private.strings = {
    description = ne.strings.Get( "str_int_dialog_minievent_crown_continue_description" ),
    accept      = ne.strings.Get( "str_int_dialog_minievent_crown_continue_accept" ),
  };

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()

  ui.button.Create(
    "btn_int_dialog_minievent_crown_continue_close",
    {
      design = "close"
    },
    function () _f.Reject(); end
  );
  
  ui.button.Create(
    "btn_int_dialog_minievent_crown_continue_accept",
    {
      title  = private.strings.accept,
      color  = "green",
      design = "medium",
      sound  = "button_click"
    },
    function () _f.Accept(); end
  );  
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( crowns_value )

  ui.hub.AttachContent( "int_dialog_minievent_crown_continue" );
  
  private.active = true;
  local animfunc    = private.app_o.."_"..crowns_value;
  
  ui.obj.Set( "anm_int_dialog_minievent_crown_continue", 
  {
    tt_description = private.strings.description
  } );
  
  ui.anim.Play( "anm_int_dialog_minievent_crown_continue", animfunc );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_end )
    
  ui.hub.DetachContent( "int_dialog_minievent_crown_continue" );
  
  private.active = false;

  if ( func_end ) then
    func_end();
  end;

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.IsActive ()

  return private.active;

end;
--------------------------------------------------------------------------------