-- name=int_dialog_minievent_share
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Close   = function () end,
  OnClose = function () end,
  Share   = function () end
};

local _this = {};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  _this = {
    int      = "int_dialog_minievent_share",
    dialog   = "obj_int_dialog_minievent_share",
    window   = "anm_int_dialog_minievent_share_window",
    button = {
      close = "btn_int_dialog_minievent_share_close",
      share = "btn_int_dialog_minievent_share_click"
    }
  };

  private.app_o = ui.screen.Orientation();
  private.app_h = ui.screen.Height();
  private.app_w = ui.screen.Width();
  private.window_area = {
    landscape = { -220, -240, 440, 450 },
    portrait = { -250, -250, 500, 500 };
  };

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ()
  
  ui.window.Open( "minievent_share", function ()
    
    ui.anim.Play(
      _this.window,
      "appear_"..private.app_o,
      nil,
      "static_"..private.app_o
    );
    
  end );
  
end;
--------------------------------------------------------------------------------
function public.Hide ()
  
  ui.anim.Play(
    _this.window,
    "disappear_"..private.app_o,
    function ()
      
      ui.window.Close( "minievent_share", _f.OnClose );
      
    end
  );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()
  
  local multiset = {};
  
  ui.obj.ToCenter( _this.dialog, 0, 0, multiset );
  ui.window.SetArea( _this.dialog, private.window_area[ private.app_o ], multiset );
  
  ui.obj.Set( 
    _this.window, 
    {
      tt_title = ne.strings.Get( "str_int_dialog_minievent_share_title" ),
      tt_desc  = ne.strings.Get( "str_int_dialog_minievent_share_description" ),
      rt_icon  = "assets/content/items/icon_minievent_complete",
      rt_back  = "assets/content/interface/int_dialog_minievent_complete/bg_fb_share"
    },
    multiset
  );
  
  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    _this.button.close,
    {
      design = "close"
    },
    function() _f.Close(); end
  );

  ui.button.Create(
  _this.button.share,
    {
      title  = "str_int_dialog_minievent_share_click",
      design = "facebook",
      sound  = "simply_click"
    },
    function() _f.Share(); end
  );
  
end;
--------------------------------------------------------------------------------