-- name=int_dialog_notifications
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Accept = function () end,
  Close  = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  ui.hub.Create( "int_dialog_notifications" );
 
  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  local app_w = ui.screen.Width();
  local app_h = ui.screen.Height();
  
  ObjMultiSet( {
    { "obj_int_dialog_notifications", {
      pos_x = app_w / 2,
      pos_y = app_h / 2
    } },
    { "spr_int_dialog_notifications_bg_black", {
      scale_x = app_w / 64,
      scale_y = app_h / 64,
    } },
    { "anm_int_dialog_notifications", {
      title       = ne.strings.Get( "str_int_dialog_notifications_title" ),
      reward_desc = ne.strings.Get( "str_int_dialog_notifications_desc" )
    } },
    { "anm_int_dialog_notifications_popup_message", {
      tt_message = ne.strings.Get( "str_int_dialog_notifications_popup" )
    } }
  } );

  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    "btn_int_dialog_notifications_close",
    {
      design = "close"
    },
    function() _f.Close(); end
  );
  
  ui.button.Create(
    "btn_int_dialog_notifications_ok",
    {
      design = "medium",
      color  = "green",
      title  = "str_int_dialog_notifications_ok"
    },
    function() if ( _f.Accept() ) then _f.Close(); end;  end
  );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( reward )
  
  ui.hub.AttachContent( "int_dialog_notifications" );
  
  ObjSet( "obj_int_dialog_notifications", { input = true, visible = true } ); 
  
  ObjSet( "anm_int_dialog_notifications",
          { reward_count = ui.text.FormatNumber( reward ) } );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_after )
  
  ui.hub.DetachContent( "int_dialog_notifications" );
  
  ObjSet( "obj_int_dialog_notifications", { input = false, visible = false } );

end;
--------------------------------------------------------------------------------