-- name=int_dialog_player_code_info
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Hide = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.anim = "anm_int_dialog_player_code_info_window";

  private.app_w = ui.screen.Width();
  private.app_h = ui.screen.Height();
  private.app_o = ui.screen.Orientation();

  private.CreateButtons();
  private.Adapt();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()
  
  private.this_obj = "obj_int_dialog_player_code_info";

  private.window_area = {
    portrait  = { -279, -388, 540, 788 },
    landscape = { -225, -150, 450, 500 }
  };

  local multiset = {};

  ui.obj.ToCenter( private.this_obj, 0, 0, multiset );
  
  ui.window.SetArea(
    private.this_obj,
    private.window_area[ private.app_o ],
    multiset
  );

  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    "btn_int_dialog_player_code_info_close",
    {
      design = "close"
    },
    function() _f.Hide(); end
  );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( info, skin_name )
  
  if ( private.active ) then return; end;
  
  private.active = true;

  private.SetDefault( info, skin_name );

  ui.anim.Play(
    private.anim,
    "appear_"..private.app_o,
    nil,
    "static_"..private.app_o
  );
  
  ui.window.Open( "player_code_info" );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_end )

  if ( not private.active ) then return; end;

  private.active = false;
  
  ui.anim.Play( private.anim, "disappear_"..private.app_o );
  
  ui.window.Close(
    "player_code_info",
    function ()
     
      ui.skin.Detach( private.hero_anm_name );
      if ( func_end ) then func_end() end;
      
    end
  );

end;
--------------------------------------------------------------------------------
function public.UpdateInviteCode ( invite_code )

  ui.obj.SetTextTag( private.anim, "tt_code", invite_code );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.SetDefault ( info, skin_name )

  private.hero_anm_name = ui.skin.Attach(
    "obj_int_dialog_player_code_info_hero",
    skin_name
  );
  
  local multiset = {};
  
  local tt_code;
  
  if ( info.code ) then
    
    tt_code = info.code;
    
  else
    
    tt_code = ne.strings.Get( "str_int_dialog_player_code_info_code_unavailable" );
    
  end;

  ui.obj.Set(
    private.anim,
    {
      title          = ne.strings.Get( "str_int_dialog_player_code_info_title" ),
      tt_description = ne.strings.Get( "str_int_dialog_player_code_info_description" ),
      tt_codetitle   = ne.strings.Get( "str_int_dialog_player_code_info_codetitle" ),
      tt_code        = tt_code
    },
    multiset
  );
  
  ui.obj.Set(
    private.hero_anm_name,
    {
      animfunc = "dialog",
      playing  = true
    },
    multiset
  );
  
  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------