-- name=int_dialog_player_skin
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Claim = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.af =
  {
    exchange = "exchange",
    static   = "static"
  };

  if ( ui.screen.IsLandscape() ) then

    private.af.exchange = private.af.exchange.."_landscape";
    private.af.static   = private.af.static  .."_landscape";

  end;

  private.window = "anm_int_dialog_player_skin_window";

  private.skin_objs =
  {
    old = "obj_int_dialog_player_skin_skins_old",
    new = "obj_int_dialog_player_skin_skins_new",
    eff = "obj_int_dialog_player_skin_skins_eff"
  };

  local str = "str_int_dialog_map_changeskin_";

  local multiset = {};

  ui.obj.ToCenter( "obj_int_dialog_player_skin", 0, 0, multiset );

  ui.obj.SetTextTag(
    private.window,
    "description",
    ne.strings.Get( str.."description" ),
    multiset
  );
  
  ui.obj.Multiset( multiset );

  ui.button.Create(
    "btn_int_dialog_player_skin_accept",
    {
      color  = "green",
      design = "medium",
      title  = str.."button"
    },
    function () _f.Claim(); end
  );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show (
    old_skin,
    new_skin,
    new_skin_info
  )

  private.active = true;

  local anm_old = ui.skin.Attach( private.skin_objs.old, old_skin, "fight" );
  local anm_new = ui.skin.Attach( private.skin_objs.new, new_skin, "fight" );
  local anm_eff = ui.skin.Attach( private.skin_objs.eff, new_skin, "fight" );
  
  private.skin_anims =
  {
    old = anm_old,
    new = anm_new,
    eff = anm_eff
  };

  local title = StringGet( "str_skins_"..new_skin_info.name );

  ObjMultiSet( 
  {
    { private.window, { title = title } },
    { anm_old, { animfunc = "disappear", frame = 0, playing = false } },
    { anm_new, { animfunc = "appear",    frame = 0, playing = false } },
    { anm_eff, { animfunc = "appear_fx", frame = 0, playing = false } }
  } );

  ui.window.Open( "player_skin", private.Animate );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_close )

  if ( not private.active ) then return; end;

  private.active = false;

  ui.window.Close( "player_skin", function ()

    ui.skin.Detach( private.skin_anims.old );
    ui.skin.Detach( private.skin_anims.new );
    ui.skin.Detach( private.skin_anims.eff );
    private.skin_anims = nil;

    if ( func_close ) then func_close(); end;

  end );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Animate ()

  local anm = private.skin_anims;
  local af  = private.af;

  ui.screen.Lock( false ); -- HACK: unlock after v_map Reward_Show

  common.sound.Play( "get_new_skin" );
  
  ui.anim.Play(
    "anm_int_dialog_player_skin_dummy",
    "dummy",
    function ()

      ui.anim.Play( anm.old, "disappear" );
      ui.anim.Play( anm.new, "appear", nil, "static" );
      ui.anim.Play( anm.eff, "appear_fx" );
      ui.anim.Stop( "anm_int_dialog_player_skin_dummy" );

    end
  );

  ui.anim.Play( private.window, af.exchange, nil, af.static );

end;
--------------------------------------------------------------------------------