-- name=int_dialog_reward
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Close  = function () end,
  OnHide = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this_obj = "obj_int_dialog_reward";
  private.this_anm = "anm_int_dialog_reward";

  private.Adapt();
    
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( reward )

  if ( private.active ) then return; end;

  private.active = true;

  private.SetDefault( reward );

  ui.anim.Play(
    private.this_anm,
    "appear",
    function ()

      ui.anim.Play(
        private.this_anm,
        "click",
        function () _f.Close(); end
      );

    end
  );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_exec )

  if not ( private.active ) then return; end;
  
  private.active = false;

  _f.OnHide();
 
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  local w, h = ui.screen.Width(), ui.screen.Height();

  local multiset = {};

  ui.obj.Set( private.this_obj,
    {
      input          = false,
      inputrect_init = true,
      inputrect_x    = -0.5 * w,
      inputrect_y    = -0.5 * h,
      inputrect_w    = w,
      inputrect_h    = h
    },
    multiset
  );
  
  ui.obj.ToCenter( private.this_obj, 0, 0, multiset );
  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( reward )
  
  local res_name = tern( reward.phase )( reward.phase, reward.name );
  
  ui.obj.Set( private.this_anm,
    {
      icon  = ui.obj.Res( reward.type, res_name ),
      count = tostring( reward.count )
    }
  );
  
end;
--------------------------------------------------------------------------------