-- name=int_dialog_saveconflict
--------------------------------------------------------------------------------
local _f = {
  OnHide = function () end,
  OnFuncLocal = function () end,
  OnFuncServer = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this = {
    int = "int_dialog_saveconflict",
    anm = "anm_int_dialog_saveconflict",
    orientation = ui.screen.Orientation(),
    anm_local = "anm_int_dialog_saveconflict_local",
    anm_server = "anm_int_dialog_saveconflict_server",
    btn_local = "btn_int_dialog_saveconflict_local_accept",
    btn_server = "btn_int_dialog_saveconflict_server_accept"
  };

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
function private.Adapt ()
  
  ui.obj.ToCenter( "obj_int_dialog_saveconflict" );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
  private.this.btn_local,
    {
      color  = "green",
      design = "medium",
      timer  = "up",
      title  = "str_dialog_info_button_conflictstorage1"
    },
    function () 
      private.Hide( _f.OnFuncLocal );
    end
  );
  
  ui.button.Create(
    private.this.btn_server,
    {
      color  = "green",
      design = "medium",
      timer  = "up",
      title  = "str_dialog_info_button_conflictstorage2"
    },
    function () 
      private.Hide( _f.OnFuncServer );
    end
  );
  
  ObjSet( private.this.anm, { 
    title = ne.strings.Get( "str_dialog_info_message_conflictstorage_title" ),
    tt_desc = ne.strings.Get( "str_dialog_info_message_conflictstorage" )
  } );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( data_local, data_server )

  ui.obj.Show( "int_dialog_saveconflict" );
  
  ui.anim.Play( private.this.anm, private.this.orientation );
  
  ui.window.Show( private.this.int );
  
  ui.button.SetTime( private.this.btn_local, data_local.clientTimeFormatted );
  ui.button.SetTime( private.this.btn_server, data_server.serverTimeFormatted );
  
  ObjSet( private.this.anm_local, { 
    animfunc = "island_save",
    playing = true,
    rt_back = "assets/content/worlds/"..data_local.clientInfoData.section,
    tt_gold = tostring( data_local.clientInfoData.gold ),
    island = ne.strings.Get( "str_int_dialog_worldmap_"..data_local.clientInfoData.section ),
    rt_red = data_local.clientInfoData.data_section.color.red,
    rt_green = data_local.clientInfoData.data_section.color.green,
    rt_blue = data_local.clientInfoData.data_section.color.blue
  } );
  ObjSet( private.this.anm_server, { 
    animfunc = "island_save",
    playing = true,
    rt_back = "assets/content/worlds/"..data_server.serverInfoData.section,
    tt_gold = tostring( data_server.serverInfoData.gold ),
    island = ne.strings.Get( "str_int_dialog_worldmap_"..data_server.serverInfoData.section ),
    rt_red = data_server.serverInfoData.data_section.color.red,
    rt_green = data_server.serverInfoData.data_section.color.green,
    rt_blue = data_server.serverInfoData.data_section.color.blue
  } );
  
  ObjSet( private.this.anm_local.."_stage_label", {
    animfunc = tern( data_local.clientInfoData.stage_last == "bonus" )( "label_bonus", "label_number" ),
    playing = true,
    number = tostring( data_local.clientInfoData.stage_last )
  } );
  ObjSet( private.this.anm_server.."_stage_label", {
    animfunc = tern( data_server.serverInfoData.stage_last == "bonus" )( "label_bonus", "label_number" ),
    playing = true,
    number = tostring( data_server.serverInfoData.stage_last )
  } );
  
  ObjSet( private.this.anm_local.."_stage_state", { visible = data_local.clientInfoData.stage_last ~= "bonus" } );
  ObjSet( private.this.anm_server.."_stage_state", { visible = data_server.serverInfoData.stage_last ~= "bonus" } );
  
end;
--------------------------------------------------------------------------------
function private.Hide ( func )

  ui.window.Hide( private.this.int );
  if ( func ) then func(); end;
  _f.OnHide();

end;
--------------------------------------------------------------------------------
function private.SetDefault ()
  
end;
--------------------------------------------------------------------------------