-- name=int_dialog_social_friendlist
--********************************************************************************************************************
--********************************************************************************************************************
function public.Init ()

  --[[FF ???]]--ObjAttach( "int_dialog_social_friendlist", "ng_application" );
  --ObjAttach( "int_dialog_social_friendlist", "ng_rooms_hub" );

  private.current_friend = 0;

  private.categories = {};

  for i = 1, 4, 1 do

    private.categories[i] = {};
    private.categories[i].name  = nil;
    private.categories[i].value = nil;
    private.categories[i].open  = true;

  end;

  private.categories[1].name = "new";
  private.categories[2].name = "friend";
  private.categories[3].name = "invited";
  private.categories[4].name = "declined";

  -- для генерации категорий "контакты"

  private.categories.obj              = cmn.GetObjParamsForSet( "obj_int_dialog_social_friendlist_default_contacts_category"             );
  private.categories.grd_back         = cmn.GetObjParamsForSet( "grd_int_dialog_social_friendlist_default_contacts_category_back"        );
  private.categories.txt_name         = cmn.GetObjParamsForSet( "txt_int_dialog_social_friendlist_default_contacts_category_name"        );
  private.categories.txt_amount       = cmn.GetObjParamsForSet( "txt_int_dialog_social_friendlist_default_contacts_category_amount"      );
  private.categories.btn_resize       = cmn.GetObjParamsForSet( "btn_int_dialog_social_friendlist_default_contacts_category_resize"      );
  private.categories.spr_resize       = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_contacts_category_resize"      );
  private.categories.spr_resize_back  = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_contacts_category_resize_back" );
  private.categories.spr_light        = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_contacts_category_light"       );

  -- для генерации вкладки "контакты"

  private.friend = {};

  private.friend.hub             = cmn.GetObjParamsForSet( "obj_int_dialog_social_friendlist_default_friend_item"      );
  private.friend.back            = cmn.GetObjParamsForSet( "grd_int_dialog_social_friendlist_default_friend_item_back" );
  private.friend.avatar_back     = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_avatar_back"      ); 
  private.friend.avatar_flare    = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_avatar_flare"     ); 
  private.friend.avatar_icon     = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_avatar_icon"      ); 
  private.friend.avatar_time     = cmn.GetObjParamsForSet( "txt_int_dialog_social_friendlist_default_avatar_time"      ); 
  private.friend.name            = cmn.GetObjParamsForSet( "txt_int_dialog_social_friendlist_default_friend_name"      );
  private.friend.id              = cmn.GetObjParamsForSet( "txt_int_dialog_social_friendlist_default_friend_id"        );
  private.friend.level_hub       = cmn.GetObjParamsForSet( "obj_int_dialog_social_friendlist_default_avatar_level"     );
  private.friend.level_back      = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_avatar_level"     );
  private.friend.level_txt       = cmn.GetObjParamsForSet( "txt_int_dialog_social_friendlist_default_avatar_level"     );
  private.friend.btn_add_stage   = cmn.GetObjParamsForSet( "btn_int_dialog_social_friendlist_default_add_stage"        );
  private.friend.spr_add_stage   = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_add_stage"        );

  private.friend.scc             = cmn.GetObjParamsForSet( "scc_int_dialog_social_friendlist_default_list" );

  -- для генерации кнопок Y/N в новых предложениях о дружбе

  private.buttons = {};

  private.buttons.obj           = cmn.GetObjParamsForSet( "obj_int_dialog_social_friendlist_default_confirm"        );
  private.buttons.btn_acc       = cmn.GetObjParamsForSet( "btn_int_dialog_social_friendlist_default_confirm_ok"     );
  private.buttons.spr_acc_back  = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_confirm_ok"     );
  private.buttons.btn_dec       = cmn.GetObjParamsForSet( "btn_int_dialog_social_friendlist_default_confirm_cancel" );
  private.buttons.spr_dec_back  = cmn.GetObjParamsForSet( "spr_int_dialog_social_friendlist_default_confirm_cancel" );

  -- для бота

  private.john_id = 1;

  -- для добавления друзей

  ui.control.TapSet( "btn_int_dialog_social_friendlist_contacts_add",
  {
    anim = { type = "object_scale", value = 1.0 },
    func_true = function ()

      v_social.ShowDialogFriend();

    end,
    func_menter = function ()

      --[[FF]] SetCursor( CURSOR_HAND );

    end,
    func_mleave = function ()

      --[[FF]] SetCursor( CURSOR_DEFAULT );

    end
  } );

  private.tabs = {};

  --common.MessageSubscribe( Event_Social_FriendsChanged, private.TableContactsUpdate );

  cmn.SetButtonWidth( "grd_int_dialog_social_friendlist_contacts_add_back", 250, {} );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Show ( --[[FF]]dialog_parent, func_cooldown, func_state, func_contacts, func_select, can_add_stage )

  if ( private.active ) then

    return;

  end;

  private.active = true;

  private.SetState = func_state;

  private.GetContacts = func_contacts;

  private.Select = func_select;

  private.GetCooldown = func_cooldown;

  private.can_add_stage = can_add_stage;

  private.FrameContactsCreate();

  local pos_z = ObjGet( dialog_parent ).pos_z - 1;

  view.DialogShowHorisont( "int_dialog_social_friendlist", --[[FF]]dialog_parent, pos_z );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Hide ( dialog_parent )

  if ( not private.active ) then

    return;

  end;

  local func_end = function ()

    common.MessageUnsubscribe( Event_Social_FriendsChanged, private.TableContactsUpdate );
    
    int.scc.ContainerDelete( "int_dialog_social_friendlist_contacts_list" );

  end;

  private.active = false;

  local pos_z = ObjGet( dialog_parent ).pos_z - 1;

  view.DialogHideHorisont( "int_dialog_social_friendlist", func_end, pos_z );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.UpdateCooldown ()

  if ( not private.can_add_stage ) then

    return;

  end;

  local object_name = "int_dialog_social_friendlist_contacts";

  local friends_list = private.GetCooldown();

  for i = 1, #friends_list do
  
    local user_id = friends_list[ i ].userId;

    local time = friends_list[ i ].time;

    if ( time > 0 ) then

      local timer = "tme_int_popup_cooldown_timer_"..i;

      if ( not ObjGet( timer ) ) then

        ObjCreate( timer, "timer" );
        ObjAttach( timer, "ng_interface" );

      end;

      local token = string.format( "mte_friend_cooldown_%i", user_id ); 

      ObjSet( timer, 
      { 
        time = 0.08, 
        playing = true, 
        endtrig = function() 

          local remaining_time = TimeGetEventRemainingTime( token );
          local time_table = cmn.GetTimeFromSec( remaining_time );  

          if ( remaining_time > 0 ) then

            ObjSet( "txt_"..object_name.."_"..user_id.."_avatar_time", { text = string.format( "%s:%s:%s", time_table.h, time_table.m, time_table.s ) } );         
            ObjSet( timer, { playing = true } );

          else

            ObjSet( "txt_"..object_name.."_"..user_id.."_avatar_time", { visible = false } );
            ObjSet( "btn_"..object_name.."_"..user_id.."_add_stage",   { input = true, color_r = 1, color_g = 1, color_b = 1 } );
            ObjDelete( timer );

          end;

        end;
      } );

      ObjSet( "txt_"..object_name.."_"..user_id.."_avatar_time", { visible = true } );
      ObjSet( "btn_"..object_name.."_"..user_id.."_add_stage",   { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5 } );

    else

      ObjSet( "txt_"..object_name.."_"..user_id.."_avatar_time", { visible = false } );
      ObjSet( "btn_"..object_name.."_"..user_id.."_add_stage",   { input = true, color_r = 1, color_g = 1, color_b = 1 } );

    end;

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.FrameContactsCreate( reopen ) 

  --[[
  Суть:
  Формируем список друзей (scc). Категория занимает 1 ячейку,
  Друг 2 - сам в 1й, а во 2й dummy.

  Аргументы:
  reopen - числ.: номер категории, которую мы свернули\развернули

  По переменным:
  array_dummy - || логический массив элементов SCC, в котором true = dummy. 
  необходим для авторокрутки, если мы попали на dummy
  ]]

  local array_dummy = {};

  local count_contacts = 0;

  for i = 1, #private.categories, 1 do
    
    private.categories[i].value = private.GetContacts( private.categories[i].name );

    if ( #private.categories[i].value == 0 ) then

      private.categories[i].open = false;

    end;

    if ( private.categories[i].open ) then

      count_contacts = count_contacts + #private.categories[i].value;

    end;

  end;

  local main          = "int_dialog_social_friendlist_contacts";
  local main_hub      = "obj_"..main;
  local obj_arrow     = "obj_"..main.."_scroll_pages_";
  local obj_scc       = "int_dialog_social_friendlist_contacts_list";
  local category_main = "int_dialog_social_friendlist_contacts_category";

  int.scc.ContainerCreate( obj_scc , private.friend.scc, false, nil );

  ObjAttach( "scc_"..obj_scc, main_hub );

  for i = 1, #private.categories, 1 do

    -- Создание шильдика категории
    array_dummy[ #array_dummy + 1 ] = false;

    private.FrameContactsCreateCategory( reopen, category_main, obj_scc, private.categories, i );

    if ( private.categories[i].open ) then

      for j = 1, #private.categories[i].value, 1 do

        -- Добавляем сразу обе ячейки
        array_dummy[ #array_dummy + 1 ] = false;
        array_dummy[ #array_dummy + 1 ] = true;

        private.FrameContactsCreateFriend( reopen, obj_scc, private.categories, i, j );

      end;
   
    end;

  end;

  local scc_items_count = count_contacts * 2 + #private.categories;

  int.scc.ContainerSet( obj_scc, { first = first_name, amount = scc_items_count } );
  
  int.scc.SetUpdateHandler( obj_scc, function ( pos_cur, pos_max, arrow_dec_active, arrow_inc_active )

    ObjSet( obj_arrow.."up_arrow",   { active = arrow_dec_active, visible = arrow_dec_active, input = arrow_dec_active } );
    ObjSet( obj_arrow.."down_arrow", { active = arrow_inc_active, visible = arrow_inc_active, input = arrow_inc_active } );

  end );

  ObjSet( "scc_"..obj_scc, 
  {
    begindragtrig = "int.scc.ContainerDrag( ne_params.sender );",
    enddragtrig   = "int.scc.ContainerDrop( ne_params.sender );"
  } );

  int.scc.SetCustomArrows( obj_scc, obj_arrow.."up_arrow", obj_arrow.."down_arrow", 10 );

  -- Добавляем dummy-ячейки, если в списке мало ячеек
  if ( scc_items_count < 8 ) then

    for i = 1, 8 - scc_items_count, 1 do

      local obj_dummy = "obj_"..main.."_dummy_"..i;

      ObjCreate( obj_dummy, "obj"              );
      ObjSet(    obj_dummy, private.friend.hub );
      ObjAttach( obj_dummy, "scc_"..obj_scc    );

    end;

  end;

  ObjSet( "scc_"..obj_scc, { scrollpos = private.current_friend } );

  int.scc.ContainerUpdate( obj_scc );

  private.UpdateCooldown();

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.FrameContactsCreateCategory( reopen, category_main, obj_scc, categories, i )

  local obj_category =             "obj_"..category_main.."_"..categories[i].name;
  local grd_category_back =        "grd_"..category_main.."_"..categories[i].name.."_back";
  local txt_category =             "txt_"..category_main.."_"..categories[i].name;
  local txt_category_amount =      "txt_"..category_main.."_"..categories[i].name.."_amount";
  local btn_category_resize =      "btn_"..category_main.."_"..categories[i].name.."_resize";
  local spr_category_resize =      "spr_"..category_main.."_"..categories[i].name.."_resize";
  local spr_category_resize_back = "spr_"..category_main.."_"..categories[i].name.."_resize_back";
  local spr_category_light =       "spr_"..category_main.."_"..categories[i].name.."_light";

  ObjCreate( obj_category,             "obj"  );
  ObjCreate( grd_category_back,        "grid" );
  ObjCreate( txt_category,             "text" );
  ObjCreate( txt_category_amount,      "text" );
  ObjCreate( btn_category_resize,      "obj"  );
  ObjCreate( spr_category_resize,      "anim" );
  ObjCreate( spr_category_resize_back, "anim" );
  
  local multiset = {};

  table.insert( multiset, { obj_category,             private.categories.obj             } );
  table.insert( multiset, { grd_category_back,        private.categories.grd_back        } );
  table.insert( multiset, { txt_category,             private.categories.txt_name        } );
  table.insert( multiset, { txt_category_amount,      private.categories.txt_amount      } );
  table.insert( multiset, { btn_category_resize,      private.categories.btn_resize      } );
  table.insert( multiset, { spr_category_resize,      private.categories.spr_resize      } );
  table.insert( multiset, { spr_category_resize_back, private.categories.spr_resize_back } );

  if ( ( categories[i].name == "new" ) and ( #categories[i].value ~= 0 ) ) then

    ObjCreate( spr_category_light.."_1", "anim" );
    ObjCreate( spr_category_light.."_2", "anim" );

    table.insert( multiset, { spr_category_light.."_1",  private.categories.spr_light } );
    table.insert( multiset, { spr_category_light.."_2",  private.categories.spr_light } );
    table.insert( multiset, { spr_category_light.."_2",  { pos_z = 3 } } );

  end;

  table.insert( multiset, { txt_category, 
  { 
    text = tostring( "str_int_dialog_social_friendlist_contacts_"..categories[i].name.."_header" ) 
  } } );

  table.insert( multiset, { txt_category_amount, 
  { 
    text = tostring( #categories[i].value )
  } } );

  if not ( categories[i].open ) then

    table.insert( multiset, { spr_category_resize, { ang = 1.5707 } } );

  end;

  if ( #categories[i].value > 0 ) then

    local function category_resize ()

      if ( categories[i].open == true ) then 

        categories[i].open = false;

      else

        categories[i].open = true;

      end;

      private.FrameContactsUpdate( i );

    end;

    ui.control.TapClear( obj_category );

    ui.control.TapSet( obj_category,
    {
      func_true = function ()

        category_resize();

      end,
      func_menter = function ()

        --[[FF]] SetCursor( CURSOR_HAND );

      end,
      func_mleave = function ()

        --[[FF]] SetCursor( CURSOR_DEFAULT );

      end
    } );

    ui.control.TapClear( btn_category_resize );

    ui.control.TapSet( btn_category_resize,
    {
      func_true = function ()

        category_resize();

      end,
      func_menter = function ()

        --[[FF]] SetCursor( CURSOR_HAND );

      end,
      func_mleave = function ()

        --[[FF]] SetCursor( CURSOR_DEFAULT );

      end
    } );

  else

    table.insert( multiset, { obj_category, { input = false } } );

  end;

  ObjMultiSet( multiset );

  ObjAttach( obj_category,             "scc_"..obj_scc     );
  ObjAttach( grd_category_back,        obj_category        );
  ObjAttach( txt_category,             obj_category        );
  ObjAttach( txt_category_amount,      obj_category        );
  ObjAttach( btn_category_resize,      obj_category        );
  ObjAttach( spr_category_resize,      btn_category_resize );
  ObjAttach( spr_category_resize_back, btn_category_resize );

  if ( ( categories[i].name == "new" ) and ( categories[i].value ~= 0 ) ) then

    ObjAttach( spr_category_light.."_1", obj_category );
    ObjAttach( spr_category_light.."_2", obj_category );

  end;

  if ( reopen ) then

    if ( reopen == i ) then

      if not ( categories[ reopen ].open ) then

        ObjAnimate( spr_category_resize, "ang", 0, 0, "", 
        {
          0.0, 0, 0, 
          0.2, 0, 1.5707
        } );

      else

        ObjAnimate( spr_category_resize, "ang", 0, 0, "", 
        {
          0.0, 0, 1.5707, 
          0.2, 0, 0
        } );

      end;

    elseif ( i > reopen ) then 

      local direction = 1;

      if ( categories[ reopen ].open ) then
  
        direction = -1;

      end;

      ObjAnimate( obj_category, "pos_y", 0, 1, "", 
      {
        0.0, 3, 100 * direction,
        0.3, 3,               0
      } );

      ObjAnimate( obj_category, "alp", 0, 1, "", 
      {
        0.0, 1, 0.0,
        0.5, 1, 1.0
      } );

    end;

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.FrameContactsCreateFriend( reopen, obj_scc, categories, i, j )

  local item = categories[i].value[j];

  local obj_friend_hub       = string.format( "obj_int_dialog_social_friendlist_contacts_%s_%s_friend_item",      categories[i].name, item.userId );
  local grd_friend_back      = string.format( "grd_int_dialog_social_friendlist_contacts_%s_%s_friend_item_back", categories[i].name, item.userId );
  local spr_avatar_back      = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_avatar_back",      categories[i].name, item.userId );
  local spr_avatar_flare     = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_avatar_flare",     categories[i].name, item.userId );
  local spr_avatar_icon      = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_avatar_icon",      categories[i].name, item.userId );
  local txt_friend_name      = string.format( "txt_int_dialog_social_friendlist_contacts_%s_%s_friend_name",      categories[i].name, item.userId );
  local txt_friend_id        = string.format( "txt_int_dialog_social_friendlist_contacts_%s_%s_friend_id",        categories[i].name, item.userId );
  local obj_friend_level     = string.format( "obj_int_dialog_social_friendlist_contacts_%s_%s_avatar_level",     categories[i].name, item.userId );
  local spr_friend_level     = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_avatar_level",     categories[i].name, item.userId );
  local txt_friend_level     = string.format( "txt_int_dialog_social_friendlist_contacts_%s_%s_avatar_level",     categories[i].name, item.userId );
  local spr_friend_stage     = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_add_stage",        categories[i].name, item.userId );
  local btn_friend_stage     = string.format( "btn_int_dialog_social_friendlist_contacts_%s_add_stage",                               item.userId );
  local txt_avatar_time      = string.format( "txt_int_dialog_social_friendlist_contacts_%s_avatar_time",                             item.userId );


  ObjCreate( obj_friend_hub,   "obj"  );
  ObjCreate( grd_friend_back,  "grid" );
  ObjCreate( spr_avatar_back,  "anim" );
  ObjCreate( spr_avatar_flare, "anim" );
  ObjCreate( spr_avatar_icon,  "anim" );
  ObjCreate( txt_avatar_time,  "text" );
  ObjCreate( txt_friend_name,  "text" );
  ObjCreate( txt_friend_id,    "text" );
  ObjCreate( obj_friend_level, "obj"  );
  ObjCreate( spr_friend_level, "anim" );
  ObjCreate( txt_friend_level, "text" );
  ObjCreate( btn_friend_stage, "obj" );
  ObjCreate( spr_friend_stage, "anim" );

  multiset = {};

  table.insert( multiset, { obj_friend_hub,   private.friend.hub           } );
  table.insert( multiset, { grd_friend_back,  private.friend.back          } );
  table.insert( multiset, { spr_avatar_back,  private.friend.avatar_back   } );
  table.insert( multiset, { spr_avatar_flare, private.friend.avatar_flare  } );
  table.insert( multiset, { spr_avatar_icon,  private.friend.avatar_icon   } );
  table.insert( multiset, { txt_avatar_time,  private.friend.avatar_time   } );
  table.insert( multiset, { txt_friend_name,  private.friend.name          } );
  table.insert( multiset, { txt_friend_id,    private.friend.id            } );
  table.insert( multiset, { obj_friend_hub,   { pos_y = 27 }               } );
  table.insert( multiset, { obj_friend_level, private.friend.level_hub     } );
  table.insert( multiset, { spr_friend_level, private.friend.level_back    } );
  table.insert( multiset, { txt_friend_level, private.friend.level_txt     } );
  table.insert( multiset, { btn_friend_stage, private.friend.btn_add_stage } );
  table.insert( multiset, { spr_friend_stage, private.friend.spr_add_stage } );

  if ( not private.can_add_stage ) then

    table.insert( multiset, { btn_friend_stage, { input = false, visible = false } } );
    table.insert( multiset, { txt_avatar_time,  { visible = false } } );

  end;

  if not ( tostring( item.userId ) == tostring( private.john_id ) ) then

    table.insert( multiset, { txt_friend_id, { text = string.format( "ID %s", common.NumberForm( item.userId ) ) } } );

  else

    table.insert( multiset, { txt_friend_id, { text = "str_int_dialog_social_friendlist_contacts_john_tip", param0 = item.name } } );

  end;

  table.insert( multiset, { txt_friend_name,  { text = item.name }      } );
  table.insert( multiset, { txt_friend_level, { text = common.NumberForm( item.level + 1 ) } } );

  ObjMultiSet( multiset );

  ui.control.TapClear( btn_friend_stage );

  ui.control.TapSet( btn_friend_stage,
  {
    func_true = function ()

      private.Select( item.userId );

    end,
    func_menter = function ()

      --[[FF]] SetCursor( CURSOR_HAND );

    end,
    func_mleave = function ()

      --[[FF]] SetCursor( CURSOR_DEFAULT );

    end
  } );

  ObjAttach( obj_friend_hub,   "scc_"..obj_scc  );
  ObjAttach( grd_friend_back,  obj_friend_hub   );
  ObjAttach( spr_avatar_back,  grd_friend_back  );
  ObjAttach( spr_avatar_icon,  spr_avatar_back  );
  ObjAttach( txt_avatar_time,  spr_avatar_back  );
  ObjAttach( spr_avatar_flare, spr_avatar_back  );
  ObjAttach( txt_friend_name,  grd_friend_back  );
  ObjAttach( txt_friend_id,    grd_friend_back  );
  ObjAttach( obj_friend_level, grd_friend_back  );
  ObjAttach( spr_friend_level, obj_friend_level );
  ObjAttach( txt_friend_level, obj_friend_level );
  ObjAttach( btn_friend_stage, grd_friend_back );
  ObjAttach( spr_friend_stage, btn_friend_stage );

  -- Делаем кнопки принять и отклонить для отдельных категорий
  private.FrameContactsCreateDecideButtons( categories[i].name, item.userId, obj_friend_hub, grd_friend_back );

  -- Анимации для контактов
  if ( reopen ) then

    local shift = ( j - 1 ) / 15;

    local direction = 1;

    local function animate( direction )

      ObjAnimate( obj_friend_hub, "alp", 0, 0, "", 
      {
        0.0,         0, 0.0, 
        0.2 + shift, 0, 0.0, 
        0.5 + shift, 0, 1.0
      } );

      ObjAnimate( obj_friend_hub, "pos_y", 0, 1, "", 
      {
        0.0,         2, -120 * direction,
        0.0 + shift, 2, -120 * direction,
        0.4 + shift, 2,                0
      } );

    end;

    if ( i == reopen ) then

      animate( direction );

    elseif ( i > reopen ) then

      if not ( categories[ reopen ].open ) then

        direction = -1;

      end;

      animate( direction );

    end;

  end;

  -- Добавляем dummy-ячейку
  local obj_dummy = obj_friend_hub.."_dummy";

  ObjCreate( obj_dummy, "obj"              );
  ObjSet(    obj_dummy, private.friend.hub );
  ObjSet(    obj_dummy, { input = false }  );
  ObjAttach( obj_dummy, "scc_"..obj_scc    );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.FrameContactsCreateDecideButtons( category_name, userId, friend_hub, button_hub )

  local function user_decide( command, Id )

    ObjAnimate( friend_hub, "alp", 0, 0, function() 

      common.MessageSend( command, { userId = Id } ); 

    end,
    {
      0.0, 0, 1.0,
      0.4, 0, 0.0
    } );

  end;

  if ( category_name == "new" or category_name == "declined" ) then
  
    local obj           = string.format( "obj_int_dialog_social_friendlist_contacts_%s_%s",    category_name, userId );
    local btn_acc       = string.format( "btn_int_dialog_social_friendlist_contacts_%s_%s_ok", category_name, userId );
    local spr_acc_back  = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_ok", category_name, userId );

    ObjCreate( obj,          "obj"  );
    ObjCreate( btn_acc,      "obj"  );
    ObjCreate( spr_acc_back, "anim" );

    multiset = {};

    table.insert( multiset, { obj,          private.buttons.obj          } );
    table.insert( multiset, { btn_acc,      private.buttons.btn_acc      } );
    table.insert( multiset, { spr_acc_back, private.buttons.spr_acc_back } );
    table.insert( multiset, { btn_acc,      { pos_y = 75 }               } );

    ObjMultiSet( multiset );

    ObjAttach( obj,          button_hub );
    ObjAttach( btn_acc,      button_hub );
    ObjAttach( spr_acc_back, btn_acc    );

    if ( category_name == "new" ) and not ( tostring( userId ) == tostring( private.john_id ) ) then

      local btn_dec      = string.format( "btn_int_dialog_social_friendlist_contacts_%s_%s_cancel", category_name, userId );
      local spr_dec_back = string.format( "spr_int_dialog_social_friendlist_contacts_%s_%s_cancel", category_name, userId );

      ObjCreate( btn_dec,      "obj"  );
      ObjCreate( spr_dec_back, "anim" );

      multiset = {};

      table.insert( multiset, { btn_dec,      private.buttons.btn_dec      } );
      table.insert( multiset, { spr_dec_back, private.buttons.spr_dec_back } );
      table.insert( multiset, { btn_dec,      { pos_y = 22 }               } );

      ObjMultiSet( multiset );  

      ObjAttach( btn_dec,      button_hub );
      ObjAttach( spr_dec_back, btn_dec    );

      ui.control.TapSet( btn_dec,
      {
        anim = { type = "object_scale", value = 1.0 },
        func_true = function ()

          user_decide( Request_Social_TryDeclineFriendRequest, userId );

          private.SetContactState( userId, "declined" );

        end,
        func_menter = function ()

          --[[FF]] SetCursor( CURSOR_HAND );

        end,
        func_mleave = function ()

          --[[FF]] SetCursor( CURSOR_DEFAULT );

        end
      } );

    end;

    ui.control.TapSet( btn_acc,
    {
      anim = { type = "object_scale", value = 1.0 },
      func_true = function ()

        user_decide( Request_Social_TryAcceptFriendRequest, userId );

        private.SetContactState( userId, "friend" );

      end,
      func_menter = function ()

        --[[FF]] SetCursor( CURSOR_HAND );

      end,
      func_mleave = function ()

        --[[FF]] SetCursor( CURSOR_DEFAULT );

      end
    } );

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.TableContactsUpdate ()

  private.FrameContactsUpdate();

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.SetContactState ( userId, state )

  private.SetState( userId, state );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.FrameContactsUpdate ( reopen )

  local scc_contacts = "int_dialog_social_friendlist_contacts_list";

  local scc = ObjGet( "scc_"..scc_contacts );

  if ( scc ) then

    private.current_friend = scc.scrollpos;

    int.scc.ContainerDelete( scc_contacts );

  end;

  private.FrameContactsCreate( reopen );

end;
--********************************************************************************************************************
--********************************************************************************************************************