-- name=int_dialog_social_friends_hearts_send
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Send  = function () end, 
  Close = function () end,
  OnClose = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.int_w = ui.screen.Height();
  private.int_h = ui.screen.Width();
  private.int_o = ui.screen.Orientation();
  
  private.this = {
    dialog   = "obj_int_dialog_social_friends_hearts_send",
    window   = "anm_int_dialog_social_friends_hearts_send_window",
    scroller = "scc_int_dialog_social_friends_hearts_send",
    button   = {
      send  = "btn_int_dialog_social_friends_hearts_send_button_send",
      close = "btn_int_dialog_social_friends_hearts_send_close"
    }
  };

  private.CreateButtons();
  private.Adapt();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( friend_list, choose_max, func_send, func_close )

  if ( private.active ) then return; end;

  private.active = true;

  private.friend_list    = friend_list;
  private.choose_max     = choose_max;
  private.friends_chosen = {};
  
  private.SetDefault( friend_list );

  local multiset = {};

  ui.button.Disable( private.this.button.send, false, multiset );

  local desc = ne.strings.Get(
    "str_int_dialog_social_friends_hearts_send_description",
    choose_max
  );

  ui.obj.Set(
    private.this.window,
    {
      animfunc = "open_"..private.int_o,
      playing  = false,
      frame    = 0,
      tt_desc  = desc
    },
    multiset
  );

  ui.obj.Multiset( multiset );

  ui.window.Open( "social_friends_hearts_send", function ()

    ui.anim.Play(
      private.this.window,
      "open_"..private.int_o,
      nil,
      "static_no_btn_"..private.int_o
    );

  end );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_OnHide )

  if ( not private.active ) then return; end;

  private.active = false;

  local func_hide = function ()

    ui.anim.Play(
      private.this.window,
      "close_"..private.int_o,
      function()

        ui.window.Close( "social_friends_hearts_send", function ()

          private.friends_chosen = nil;
          private.btn_shown      = nil;

          ui.obj.Delete( private.this.scroller );

          _f.OnClose();
          
          if ( func_OnHide ) then func_OnHide(); end;

        end );

      end
    );

  end;

  if ( private.btn_shown ) then

    ui.anim.Play(
      private.this.window,
      "static_btn_hide_"..private.int_o,
      func_hide
    );

    return;

  end;

  func_hide();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    private.this.button.close,
    {
      design = "close"
    },
    function() _f.Close(); end
  );

  ui.button.Create(
    private.this.button.send,
    {
      title  = "str_int_dialog_social_friends_hearts_send_button_send",
      color  = "blue",
      design = "medium"
    },
    function()
      
      _f.Close();
      _f.Send( private.friends_chosen );
      
    end
  );

end;
--------------------------------------------------------------------------------
function private.Adapt ()
  
  private.this.window_area = {
    portrait  = { -230, -365, 460, 825 },
    landscape = { -230, -365, 460, 825 }
  };

  local multiset = {};

  ui.obj.ToCenter( private.this.dialog, 0, 0, multiset );

  ui.window.SetArea(
    private.this.dialog,
    private.this.window_area[ private.int_o ],
    multiset
  );

  ui.obj.SetTextTag(
    private.this.window,
    "tt_title",
    ne.strings.Get( "str_int_dialog_social_friends_hearts_send_title" ),
    multiset
  );

  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( friend_list )

  -- JK: for debug
  --[[friend_list = {
    { userId = "1", name = "John", url = "" },
    { userId = "2", name = "Mark", url = "" }
  };]]
  
  ObjClone(
    "scc_int_dialog_social_friends_hearts_send_default",
    "_rename",
    0,
    private.this.window
  );

  ObjSet(
    "scc_int_dialog_social_friends_hearts_send_default_rename",
    {
      name = private.this.scroller
    }
  );

  local multiset = {};

  for f, friend in ipairs( friend_list ) do

    ObjClone( "anm_int_dialog_social_friends_hearts_send_friend", "_"..friend.userId, true, private.this.scroller );

    ui.control.TapClear( "anm_int_dialog_social_friends_hearts_send_friend_"..friend.userId );
    ui.control.TapSet( "anm_int_dialog_social_friends_hearts_send_friend_"..friend.userId, 
    {
      func_true = function ()
        private.Check( friend.userId, friend_list );
      end
    } );

    if ( friend.url == '' ) then
      friend.url = nil;
    end;

    table.insert( multiset, { "anm_int_dialog_social_friends_hearts_send_friend_"..friend.userId, { tt_name = friend.name } } );
    table.insert( multiset, { "spr_int_dialog_social_friends_hearts_send_friend_"..friend.userId, { 
      url = friend.url,
      res = "assets/content/interface/int_dialog_stage_friends/default_0",
      default_res = "assets/content/interface/int_dialog_stage_friends/default_0",
      trg_resloaded = function ()
        ui.obj.SpriteAdjust( "spr_int_dialog_social_friends_hearts_send_friend_"..friend.userId, 90 ); 
      end } } );

  end;

  ui.obj.Multiset( multiset );

  for f, friend in ipairs( friend_list ) do
    ui.obj.SpriteAdjust( "spr_int_dialog_social_friends_hearts_send_friend_"..friend.userId, 90 );
  end;

  -- -- Dummy -- -- --
  local friends_visible = 6;
  if ( #friend_list < friends_visible ) then
    for f = ( #friend_list + 1 ), friends_visible do
      ObjCreate( "obj_int_dialog_social_friends_hearts_send_friend_"..f, "obj" );
      ObjAttach( "obj_int_dialog_social_friends_hearts_send_friend_"..f, private.this.scroller );
    end;
  end;

end;
--------------------------------------------------------------------------------
function private.Check ( userId, friend_list )

  local target_animfunc;
  local multiset         = {};
  local set_all_disabled = nil;
  local friend_num       = common.IsEntityInList( private.friends_chosen, userId );

  if ( #private.friends_chosen >= private.choose_max ) and
     ( not friend_num                                ) then

    return;

  end;

  if ( not friend_num ) then

    table.insert( private.friends_chosen, userId );
    target_animfunc = "checked";

    if ( #private.friends_chosen == private.choose_max ) then
      set_all_disabled = true;
    end;

  else

    table.remove( private.friends_chosen, friend_num );
    target_animfunc = "unchecked";

    if ( #private.friends_chosen == private.choose_max - 1 ) then
      set_all_disabled = false;
    end;

  end;

  table.insert( multiset, { 
    "anm_int_dialog_social_friends_hearts_send_friend_"..userId, { 
      animfunc = target_animfunc, playing = true, frame = 0 } } );

  if ( set_all_disabled ~= nil ) then

    local other_animfunc = tern( set_all_disabled )( "inactive", "unchecked" );

    for f, friend in ipairs( friend_list ) do

      if ( not common.IsEntityInList( private.friends_chosen, friend.userId )) then
        table.insert( multiset, { 
          "anm_int_dialog_social_friends_hearts_send_friend_"..friend.userId, { 
            animfunc = other_animfunc, playing = true, frame = 0 } } );
      end;

    end;

  end;

  if ( #private.friends_chosen > 0 ) then

    if ( not private.btn_shown ) then

      private.btn_shown = true;

      ui.button.Enable( private.this.button.send );
      ui.anim.Play( private.this.window, "static_btn_show_"..private.int_o );

    end;       

  else

    private.btn_shown = nil;
    
    ui.anim.Play(
      private.this.window,
      "static_btn_hide_"..private.int_o,
      function ()

        ui.button.Disable( private.this.button.send );

      end
    ); 

  end;

  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------