-- name=int_dialog_social_friends_not_attempts
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Close   = function () end,
  OnClose = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this = {
    dialog = "obj_int_dialog_social_friends_not_attempts",
    window = "anm_int_dialog_social_friends_not_attempts_window",
    button = {
      close  = "btn_int_dialog_social_friends_not_attempts_close" 
    }
  };

  private.app_o = ui.screen.Orientation();

  private.strings = {
    title = {
      ask = ne.strings.Get( "str_int_dialog_social_friends_not_attempts_title_ask" ),
      send = ne.strings.Get( "str_int_dialog_social_friends_not_attempts_title_send" )
    },
    description = {
      ask = ne.strings.Get( "str_int_dialog_social_friends_not_attempts_description_ask" ),
      send = ne.strings.Get( "str_int_dialog_social_friends_not_attempts_description_send" )
    }
  };

  private.window_area = {
    default = { -270, -220, 540, 460 }
  };

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( attempt_type )

  if ( private.active ) then return; end;

  private.active = true;
  
  ui.obj.Set(
    private.this.window,
    {
      title = private.strings.title[ attempt_type ],
      tt_desc  = private.strings.description[ attempt_type ],
      animfunc = private.app_o.."_nobutton"
    }
  );

  ui.window.Open( "social_friends_not_attempts" );

end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( not private.active ) then return; end;

  private.active = false;

  ui.window.Close( "social_friends_not_attempts", function () _f.OnClose(); end );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()
  
  local multiset = {};

  ui.obj.ToCenter( private.this.dialog, 0, 0, multiset );

  ui.window.SetArea(
    private.this.dialog,
    private.window_area.default,
    multiset
  );

  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    private.this.button.close,
    {
      design = "close",
      sound  = "simply_click",
    },
    function() _f.Close(); end
  );

end;
--------------------------------------------------------------------------------