-- name=int_dialog_social_login
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Action = function () end, 
  Close  = function () end,
  OnClose = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this =
  {
    dialog_name = "social_login",
    obj_dialog  = "obj_int_dialog_social_login",
    anm_window  = "anm_int_dialog_social_login_window",
    btn_close   = "btn_int_dialog_social_login_close",
    btn_action  = "btn_int_dialog_social_login_action"
  };
  
  private.window_area = { -292, -250, 568, 500 };

  local multiset = {};

  ui.obj.ToCenter( private.this.obj_dialog, 0, 0, multiset );
  
  ui.window.SetArea( private.this.obj_dialog, private.window_area, multiset );

  ui.obj.Set(
    private.this.anm_window,
    {
      title          = "str_int_dialog_social_login_title",
      tt_description = "str_int_dialog_social_login_description",
      label          = "str_int_dialog_social_login_extramoves"
    },
    multiset
  );

  ui.obj.Multiset( multiset );
  
  ui.button.Create(
    private.this.btn_close,
    {
      design = "close"
    },
    function () _f.Close(); end 
  );
  
  ui.button.Create(
    private.this.btn_action,
    {
      title  = "str_int_dialog_social_login_action",
      color  = "blue",
      design = "large"
    },
    function () _f.Action(); end 
  );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( reward_name, reward_count )

  local is_heart = ( reward_name == "heart" );

  local params = {
    playing      = true,
    animfunc     = tern( is_heart )( "static_hearts", "static_moves" ),
    hearts_count = tern( is_heart )( "+"..ui.text.FormatNumber( reward_count ), "" ),
    count        = tern( is_heart )( "", "x"..ui.text.FormatNumber( reward_count ) )
  };

  ui.obj.Set( private.this.anm_window, params );
  ui.window.Open( private.this.dialog_name );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_after )

  local close = function ()
    if (func_after) then
      func_after(_f.OnClose);
    else
      _f.OnClose();
    end;
  end;
  
  ui.window.Close( private.this.dialog_name, close );

end;
--------------------------------------------------------------------------------