-- name=int_dialog_social_wishlist
--********************************************************************************************************************
--********************************************************************************************************************
function public.Init ()

  private.wishlist_data = nil;
  private.func_select = nil;
  private.func_remove = nil;
  
  private.wishes = {}; -- Таблица [ индекс ] = имя_предмета; желания игрока.
  private.choose = {}; -- Таблица [ имя_предмета ] = индекс; список доступных желаний.
  private.selected_index = nil;

  ui.control.TapSet( "btn_int_dialog_social_wishlist_top_btn_cross",
  {
    anim = { type = "object_scale", value = 1.0 },
    func_true = function ()

      private.Close();
      private.ChooseHide();
      private.Hide();

    end
  } );

  ui.control.TapSet( "spr_int_dialog_social_wishlist_mid_wishlist_choose_arrow_left",
  {
    func_true = function ()

      private.Scroll( "left" );

    end
  } );

  ui.control.TapSet( "spr_int_dialog_social_wishlist_mid_wishlist_choose_arrow_right",
  {
    func_true = function ()

      private.Scroll( "right" );

    end
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.SetDefault ()

  private.scrollpos = 0;
  private.scrollpos_max = 0;

  local multiset_table = {};

  ObjSet( "obj_int_dialog_social_wishlist_mid_wishlist_choose", { input = false, visible = false } );

  local item_default = "obj_int_dialog_social_wishlist_player_item";

  local scc_params = ObjGet( "scc_int_dialog_social_wishlist_default" );

  scc_params.name = "scc_int_dialog_social_wishlist_mid_wishlist";

  ObjCreate( scc_params.name, "scrollcontainer" );

  ObjSet( scc_params.name, scc_params );

  ObjAttach( scc_params.name, "obj_int_dialog_social_wishlist_mid_wishlist" );

  local amount = private.player_wishlist.amount;
  local available = private.player_wishlist.available;

  for i = 1, available do

    ObjClone( item_default, "_"..i, 1, "scc_int_dialog_social_wishlist_mid_wishlist" );

    ObjSet( "btn_int_dialog_social_wishlist_player_item_remove_"..i, { active = false, visible = false, input = false } );   
    ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,     { active = true,  visible = true,  input = true } );
    ObjSet( "btn_int_dialog_social_wishlist_player_item_buy_"..i,    { active = false, visible = false, input = false } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_"..i,   { active = false, visible = false, input = false } );
    ObjSet( "txt_int_dialog_social_wishlist_player_item_count_"..i,  { active = false, visible = false, input = false } );

    ui.control.TapSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,
    {
      func_true = function ()

        private.ChooseShow( i, private.wishlist_data );

      end
    } );

    ui.control.TapSet( "btn_int_dialog_social_wishlist_player_item_remove_"..i,
    {
      func_true = function ()

        private.Remove( i, private.func_remove );

      end
    } );

  end;

  for i = available + 1, amount do

    ObjClone( item_default, "_"..i, 1, "scc_int_dialog_social_wishlist_mid_wishlist" );

    ObjSet( "btn_int_dialog_social_wishlist_player_item_remove_"..i, { active = false, visible = false, input = false } );  
    ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,     { active = false, visible = true,  input = false } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_plus_"..i,   { active = false, visible = false, input = false } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_"..i,   { active = false, visible = false, input = false } );
    ObjSet( "txt_int_dialog_social_wishlist_player_item_count_"..i,  { active = false, visible = false, input = false } );

    ui.control.TapSet( "btn_int_dialog_social_wishlist_player_item_buy_"..i,
    {
      func_true = function ()

        local cursor_pos = GetGameCursorPos();

        private.Unlock( i, private.func_unlock );

      end
    } );

    ui.control.TapSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,
    {
      func_true = function ()

        private.ChooseShow( i, private.wishlist_data );

      end
    } );

    ui.control.TapSet( "btn_int_dialog_social_wishlist_player_item_remove_"..i,
    {
      func_true = function ()

        private.Remove( i, private.func_remove );

      end
    } );

    local text = common.NumberForm( private.player_wishlist.price[ i ] );

    ObjSet( "txt_int_dialog_social_wishlist_player_item_buy_price_"..i, { text = text } ); 

    if ( i == available + 1 ) then

      ObjSet( "btn_int_dialog_social_wishlist_player_item_buy_"..i,   { active = true, visible = true, input = true } );
      ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,    { alp = 0.6 } );
      ObjSet( "spr_int_dialog_social_wishlist_player_item_flare_"..i, { alp = 0.6 } );
  
    else

      ObjSet( "btn_int_dialog_social_wishlist_player_item_buy_"..i,   { active = false, visible = false, input = false } );
      ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,    { alp = 0.2 } );
      ObjSet( "spr_int_dialog_social_wishlist_player_item_flare_"..i, { alp = 0.2 } );

    end;

  end;

  local page = 1;

  local col = 0;
  local row = 0;

  local scc_choose_params = ObjGet( "scc_int_dialog_social_wishlist_choose_default" );

  scc_choose_params.name = "scc_int_dialog_social_wishlist_mid_wishlist_choose";

  ObjCreate( scc_choose_params.name, "scrollcontainer" );

  ObjSet( scc_choose_params.name, scc_choose_params );

  ObjAttach( scc_choose_params.name, "obj_int_dialog_social_wishlist_mid_wishlist_choose" );

  ObjCreate( "obj_int_dialog_social_wishlist_mid_wishlist_choose_page_"..page, "obj" );
  ObjAttach( "obj_int_dialog_social_wishlist_mid_wishlist_choose_page_"..page, "scc_int_dialog_social_wishlist_mid_wishlist_choose" );

  ObjSet( "obj_int_dialog_social_wishlist_mid_wishlist_choose_transparent", { event_mdown = function () private.ChooseHide(); end } );

  local idx = 1;

  for i = 1, #private.wishlist_data do

    local wish = private.wishlist_data[ i ];

    for j = 1, #wish.count do

      local wish_name = wish.name;
      local wish_type = wish.type;

      if ( #wish.count > 1 ) then

        wish_name = wish.name.."_"..j

      end;

      local item_default = "obj_int_dialog_social_wishlist_player_item";

      ObjClone( item_default, "_choose_"..idx, 1, "ne_storage" );

      ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_choose_"..idx,     { input = true } );
      ObjSet( "btn_int_dialog_social_wishlist_player_item_remove_choose_"..idx, { active = false, visible = false, input = false } );
      ObjSet( "spr_int_dialog_social_wishlist_player_item_plus_choose_"..idx,   { active = false, visible = false, input = false } );
      ObjSet( "btn_int_dialog_social_wishlist_player_item_buy_choose_"..idx,    { active = false, visible = false, input = false } );
      ObjSet( "txt_int_dialog_social_wishlist_player_item_count_choose_"..idx,  { active = false, visible = false, input = false } );

--      if not ( string.find( wish_name, "energy" ) or wish_type == "craft" ) then
--
--        ObjSet( "txt_int_dialog_social_wishlist_player_item_count_choose_"..idx,  { active = true, visible = true, text = common.NumberForm( wish.count[ j ] ) } );
--
--      end;

      private.choose[ wish_name ] = idx;

      ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_choose_"..idx,   { res = private.GetResource( wish_name, wish_type ) } );
 
      ui.control.TapSet( "spr_int_dialog_social_wishlist_player_item_bg_choose_"..idx,
      {
        func_true = function ()
                    
          private.Select( wish_name, wish_type, wish.count[ j ], private.func_select );

        end
      } );

      ObjAttach( "obj_int_dialog_social_wishlist_player_item_choose_"..idx, "obj_int_dialog_social_wishlist_mid_wishlist_choose_page_"..page );
      ObjSet( "obj_int_dialog_social_wishlist_player_item_choose_"..idx, { pos_x = 125 * col - 190, pos_y = - 115 + 115 * row } );

      col = col + 1;

      if ( math.fmod( idx, 4 ) == 0 ) then

        row = row + 1;
        col = 0;

      end;

      if ( math.fmod( idx, 12 ) == 0 ) then

        row = 0;
        page = page + 1;

        ObjCreate( "obj_int_dialog_social_wishlist_mid_wishlist_choose_page_"..page, "obj" );
        ObjAttach( "obj_int_dialog_social_wishlist_mid_wishlist_choose_page_"..page, "scc_int_dialog_social_wishlist_mid_wishlist_choose" )

      end;

      idx = idx + 1;

    end;

  end;

  local wishes = private.player_wishlist.wishes;

  for i = 1, #wishes do

    local wish_name = wishes[ i ].name;
    local wish_type = wishes[ i ].type;
    local wish_count = wishes[ i ].count;

    private.wishes[ i ] = wish_name;

    --DbgTrace( "restored = "..wish_name );

    ObjSet( "obj_int_dialog_social_wishlist_player_item_choose_"..private.choose[ wish_name ], 
    { 
      input = false, 
      alp = 0.6,
      color_r = 0.6,
      color_g = 0.6,
      color_b = 0.6
     } );

    ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..i,     { input = false } );
    ObjSet( "btn_int_dialog_social_wishlist_player_item_remove_"..i, { active = true, visible = true, input = true } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_"..i,   { active = true, visible = true, res = private.GetResource( wish_name, wish_type ) } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_plus_"..i,   { active = false, visible = false } );

--    if not ( string.find( wish_name, "energy" ) or wish_type == "craft" ) then
--
--      ObjSet( "txt_int_dialog_social_wishlist_player_item_count_"..i,  { active = true, visible = true, text = common.NumberForm( wish_count ) } );
--
--    end;

  end;

  private.scrollpos_max = page - 1;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.GetResource ( wish_name, wish_type )

  --local res = "assets/resources/items/"..wish_type.."_icon_"..wish_name;
  local res = "assets/resources/items/"..wish_name;

  return res;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Show ( player_wishlist, wishlist_data, func_select, func_remove, func_unlock, func_close )

  private.player_wishlist = player_wishlist;
  private.wishlist_data = wishlist_data;
  private.func_select = func_select;
  private.func_remove = func_remove;
  private.func_unlock = func_unlock;

  private.Close = func_close;

  private.SetDefault();

  view.DialogShow( "int_dialog_social_wishlist", "", "interface_inside" );

  private.active = true;

  public.Update();

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Hide ( func_execute )

  private.active = false;

  local flag_execute = nil;
  
  if ( func_execute ) then

    flag_execute = true;

  end;

  local func_end = function()

    v_interface.window.Hide( "int_dialog_social_wishlist" );

    local idx = 1;

    for i = 1, #private.wishlist_data do

      for j = 1, #private.wishlist_data[ i ].count do

        ui.control.TapClear( "spr_int_dialog_social_wishlist_player_item_bg_"..idx );
        ui.control.TapClear( "btn_int_dialog_social_wishlist_player_item_remove_"..idx );
        ui.control.TapClear( "btn_int_dialog_social_wishlist_player_item_buy_"..idx );
        ui.control.TapClear( "spr_int_dialog_social_wishlist_player_item_bg_choose_"..idx );

        idx = idx + 1;

      end;

    end;

    ObjDelete( "scc_int_dialog_social_wishlist_mid_wishlist" );
    ObjDelete( "scc_int_dialog_social_wishlist_mid_wishlist_choose" );

    if ( func_execute ) then

      func_execute();

    end;

  end;

  view.DialogHide( "int_dialog_social_wishlist", func_end, "interface_outside", flag_execute );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.ChooseShow ( index, wishlist_data )

  ObjSet( "obj_int_dialog_social_wishlist_mid_wishlist_choose", { input = true, visible = true } );
  ObjSet( "scc_int_dialog_social_wishlist_mid_wishlist",        { input = false } );

  ObjSet( "spr_int_dialog_social_wishlist_mid_wishlist_choose_arrow", { pos_x = 120 * index } );

  private.selected_index = index;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.ChooseHide ()

  ObjSet( "obj_int_dialog_social_wishlist_mid_wishlist_choose", { input = false, visible = false } );
  ObjSet( "scc_int_dialog_social_wishlist_mid_wishlist",        { input = true } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Select ( wish_name, wish_type, wish_count, func_select )

  local index = private.selected_index;

  private.wishes[ index ] = wish_name;

  private.ChooseHide();

  ObjSet( "obj_int_dialog_social_wishlist_player_item_choose_"..private.choose[ wish_name ], 
  { 
    input = false, 
    alp = 0.6,
    color_r = 0.6,
    color_g = 0.6,
    color_b = 0.6
   } );

  ObjSet( "btn_int_dialog_social_wishlist_player_item_remove_"..index, { active = true, visible = true, input = true } ); 
  ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..index,     { input = false } );
  ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_"..index,   { visible = true, res = private.GetResource( wish_name, wish_type ) } );
  ObjSet( "spr_int_dialog_social_wishlist_player_item_plus_"..index,   { active = false, visible = false } );

--  if not ( string.find( wish_name, "energy" ) or wish_type == "craft" ) then
--
--    ObjSet( "txt_int_dialog_social_wishlist_player_item_count_"..index,  { active = true, visible = true, text = common.NumberForm( wish_count ) } );
--
--  end;

  if ( func_select ) then

    func_select( wish_name );

    --DbgTrace( "selected = "..wish_name );    

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Remove ( index, func_remove )
  
  local wish_name = private.wishes[ index ]; 

  ObjSet( "obj_int_dialog_social_wishlist_player_item_choose_"..private.choose[ wish_name ], 
  { 
    input = true, 
    alp = 1,
    color_r = 1,
    color_g = 1,
    color_b = 1
  } );

  ObjSet( "btn_int_dialog_social_wishlist_player_item_remove_"..index, { active = false, visible = false, input = false } ); 
  ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..index,     { active = true,  visible = true,  input = true } );
  ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_"..index,   { visible = false } ); 
  ObjSet( "spr_int_dialog_social_wishlist_player_item_plus_"..index,   { active = true, visible = true } );
  ObjSet( "txt_int_dialog_social_wishlist_player_item_count_"..index,  { active = false, visible = false } );

  if ( func_remove ) then

    func_remove( wish_name );

    --DbgTrace( "removed = "..wish_name );    

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Unlock ( index, func_unlock )

  local can_unlock = false;

  if ( func_unlock ) then

    can_unlock = func_unlock( index );

  end;

  if ( can_unlock ) then

    --DbgTrace( "unlocked = "..index );

    ObjSet( "btn_int_dialog_social_wishlist_player_item_buy_"..index,    { active = false, visible = false, input = false } ); 
    ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..index,     { alp = 1, active = true, visible = true, input = true } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_flare_"..index,  { alp = 1 } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_icon_"..index,   { active = true, visible = false } ); 
    ObjSet( "spr_int_dialog_social_wishlist_player_item_plus_"..index,   { active = true, visible = true } );

    ObjSet( "btn_int_dialog_social_wishlist_player_item_buy_"..( index + 1 ),   { active = true, visible = true, input = true } );

    ObjSet( "spr_int_dialog_social_wishlist_player_item_bg_"..( index + 1 ),    { alp = 0.6 } );
    ObjSet( "spr_int_dialog_social_wishlist_player_item_flare_"..( index + 1 ), { alp = 0.6 } );

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Scroll ( direction )

  if ( direction == "left" ) then

    private.scrollpos = private.scrollpos - 1;

  elseif ( direction == "right" ) then

    private.scrollpos = private.scrollpos + 1;

  end;

  if ( private.scrollpos < 0 ) then

    private.scrollpos = 0;

  elseif ( private.scrollpos > private.scrollpos_max ) then

    private.scrollpos = private.scrollpos_max;

  end;

  ObjSet( "scc_int_dialog_social_wishlist_mid_wishlist_choose", { scrollpos = private.scrollpos } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Update ( player_wishlist )

  if ( not private.active ) then

    return;

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************