-- name=int_dialog_stage_shuffle
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Effect = function () end
};

local _this = {};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_dialog_stage_shuffle" );

  private.SetPanelForm();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( x, y, func_effect )

  if ( _this.is_active ) then return; end;

  _this.is_active = true;

  ui.hub.AttachContent( "int_dialog_stage_shuffle" );
  
  ui.obj.Set( "obj_int_dialog_stage_shuffle", {
    pos_x = x,
    pos_y = y
  } );    
  
  ui.anim.Play( "anm_int_dialog_stage_shuffle", "appear_portrait", function ()
  
    if ( func_effect ) then

      func_effect();

    end;
    
    common.Defer ( "shuffle_defer", 0.3, function ()
     
      ui.anim.Play( "anm_int_dialog_stage_shuffle", "disappear_portrait", public.Hide );     
      common.sound.Play( "stripemenu_outside" );      
      
    end );
    
  end, "static_portrait" );

  common.sound.Play( "stripemenu_inside" );

end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( not _this.is_active ) then return; end;

  _this.is_active = nil;
  
  ui.anim.Stop( "anm_int_dialog_stage_shuffle" );
  ui.hub.DetachContent( "int_dialog_stage_shuffle" );

end;
--------------------------------------------------------------------------------
function public.IsActive ()

  return _this.is_active;

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.SetPanelForm ()
  
  local multiset = {};

  local screen_w = ui.screen.Width();
  local screen_h = ui.screen.Height();

  ui.obj.Set( "obj_int_dialog_stage_shuffle", {
    pos_x = 0.5 * screen_w,
    pos_y = - 0.5 * screen_h
  }, multiset );  
  
  ui.obj.Set( "anm_int_dialog_stage_shuffle", {
    tt_description = "str_dialog_stage_shuffle_message"
  }, multiset );
  
  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------