-- name=int_dialog_stage_targets
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Close = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.SetPanelForm();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( state, targets, enemy_name, section, func_close )

  if ( private.active ) then

    return;

  end;

  private.Close       = func_close;
  private.active      = true;
  private.targets_num = #targets;
  
  if ( private.targets_num < 1 ) then private.targets_num = 1; end;
  
  private.SetDefault( state, targets, enemy_name, section );

  ObjSet( "obj_int_dialog_stage_targets", { active = true, input = false, visible = true } );

  local func_end = function ()

    ObjSet( "obj_int_dialog_stage_targets", { input = true } );

    ObjAnimate( "obj_int_dialog_stage_targets", "alp", 0, 0, 
    function () 
      
      local func_tap = ui.control.TapGet( "obj_int_dialog_stage_targets" ).func_true;

      if ( func_tap ) then

        func_tap();

      end;

    end, 
    { 
      0.0, 0, 1, 
      2.0, 0, 1 
    } );

  end;

  ui.anim.Play(
    "anm_int_dialog_stage_targets",
    "show_"..private.targets_num,
    func_end
  );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Hide ( func_execute )

  if not ( private.active ) then

    return;

  end;

  private.active = false;

  ui.input.Off( "obj_int_dialog_stage_targets" );

  local func_end = function ()

    ObjSet( "obj_int_dialog_stage_targets", { active = false, visible = false } );

    if ( func_execute ) then

      func_execute();  

    end;

  end

  ui.anim.Play(
    "anm_int_dialog_stage_targets",
    "hide_"..private.targets_num,
    func_end
  );

end;
--------------------------------------------------------------------------------
function private.SetPanelForm ()

  local screen_w = GetAppWidth();
  local screen_h = GetAppHeight();

  ObjSet( "obj_int_dialog_stage_targets",
  {
    pos_x = 0.5 * screen_w,
    pos_y = 0.5 * screen_h,
    inputrect_w = screen_w,
    inputrect_h = screen_h,
    inputrect_x = - 0.5 * screen_w,
    inputrect_y = - 0.5 * screen_h
  } );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( state, targets, enemy_name, section )

  ObjStopAnimate( "obj_int_dialog_stage_targets", "alp" );

  AnimStop( "anm_int_dialog_stage_targets" );

  ui.control.TapSet( "obj_int_dialog_stage_targets",
  {
    func_true = function ()

      private.Hide( private.Close );

       common.sound.Play( "button_click" );

    end
  } );

  local multiset_table = {};

  for i = 1, 3 do

    table.insert( multiset_table,
    {
      "obj_int_dialog_stage_targets_"..i,
      {
        active  = false,
        visible = false 
      }
    } );
    table.insert( multiset_table, { "spr_int_dialog_stage_targets_"..i.."_icon", 
    { 
      visible = false
    } } );

  end;

  if ( enemy_name ) then

    table.insert( multiset_table,
    { "obj_int_dialog_stage_targets_1", { active = true, visible = true } } );
    
    table.insert( multiset_table,
    { "txt_int_dialog_stage_targets_1_message",
      {
        text = "str_int_dialog_stage_targets_killenemy",
        param0 = StringGet( "str_enemy_name_gender_"..enemy_name )
      }
    } );

    table.insert( multiset_table,
    { "anm_int_dialog_stage_targets",
      {
        state    = StringGet( "str_int_dialog_stage_targets_defeat_enemy" ),
        multiply = ""
      }
    } );

    ObjMultiSet( multiset_table );

    return;

  end;

  for i = 1, #targets do

    table.insert( multiset_table, { "obj_int_dialog_stage_targets_"..i, 
    { 
      active  = true,
      visible = true
    } } );

    local text  = "str_int_dialog_stage_targets_"..string.lower( targets[ i ].type );
    local pos_x = - 164;

    if ( targets[ i ].type ~= "GainScore" ) then
      
      pos_x = - 113;

      if ( targets[ i ].type ~= "CollectResource" ) then
        text = "str_int_dialog_stage_targets_"..
               string.lower( targets[ i ].type ).."_"..
               string.lower( targets[ i ].name );
      end;
 
      local resource = "assets/content/items/icon_"..string.lower( targets[ i ].name );
      
      if (     targets[ i ].type == "DropItem" and
           not targets[ i ].name:match( "chest" ) ) then
        local section_number = string.match( section, "minievent_(.*)" ) or string.match( section, "%d+" );
        resource = "assets/content/"..section.."/icon_key_"..section_number;
      end;

      table.insert( multiset_table, { "spr_int_dialog_stage_targets_"..i.."_icon", 
      { 
        visible = true,
        res = resource
      } } );
      
    end;
  
    table.insert( multiset_table, { "txt_int_dialog_stage_targets_"..i.."_message", 
    { 
      pos_x  = pos_x,
      text   = text, 
      param0 = ui.text.FormatNumber( targets[ i ].count, true )
    } } );

  end;

  ObjMultiSet( multiset_table );

  multiset_table = {};

  for i = 1, #targets do

    local scale = ObjGet( "txt_int_dialog_stage_targets_"..i.."_message" ).scale_x;

    table.insert( multiset_table, { "txt_int_dialog_stage_targets_"..i.."_message", { scale_y = scale } } );

  end;

  local str_multiply = "";
  if ( state > 1 ) then
    str_multiply = StringGet( "str_int_dialog_stage_targets_multiply_"..state );
  end;

  table.insert( multiset_table,
  { "anm_int_dialog_stage_targets",
    {
      state    = StringGet( "str_int_dialog_stage_targets_state", state ),
      multiply = str_multiply
    }
  } );

  ObjMultiSet( multiset_table );

end;
--------------------------------------------------------------------------------