-- name=int_dialog_story
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Close = function () end
};

local _this = {
  obj   = "obj_int_dialog_story",
  anm   = "anm_int_dialog_story",
  movie = "anm_int_dialog_story_movie"
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.Adapt();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  private.app_w = ui.screen.Width();
  private.app_h = ui.screen.Height();

  ui.obj.ToCenter( _this.obj );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( story_data )

  if ( private.active ) then

    return;

  end;

  private.active = true;

  local multiset = {};

  ui.obj.Set(
    _this.obj,
    {
      active  = true,
      visible = true,
      input   = false
    },
    multiset
  );
    
  ui.obj.Set(
    _this.movie,
    {
      res = story_data.res
    },
    multiset
  );

  ui.obj.Multiset( multiset );

  local orientation = ui.screen.Orientation();
  local movie_func  = "action_"..orientation;
  
  local func_end_anim = function ()

    ui.input.On( _this.obj );
    ui.anim.Play( _this.anm, "static_medium" );
    ui.anim.Play( _this.movie, movie_func, function ()

      common.sound.Stop( story_data.aud );

      _f.Close();

    end );
    common.sound.Play( story_data.aud );
  
  end;

  ui.anim.Play( _this.anm, "open_medium", func_end_anim );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_OnHide, is_instant )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  ui.input.Off( _this.obj );

  local func_end_anim = function ()

    ui.obj.Disable( _this.obj, true );

    if ( func_OnHide ) then func_OnHide(); end;

  end;
  
  if ( is_instant ) then
    
    func_end_anim();
    
  else

    ui.anim.Play( _this.anm, "close_medium", func_end_anim );
  
  end;

end;
--------------------------------------------------------------------------------