-- name=int_dialog_tutorial_animation
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Close = function () end
};

local _this = {};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  _this = {
    int      = "int_dialog_tutorial_animation",
    dialog   = "obj_int_dialog_tutorial_animation",
    window   = "anm_int_dialog_tutorial_animation_window",
    button = {
      close = "btn_int_dialog_tutorial_animation_close"
    },
    type    = "anm_int_dialog_tutorial_animation_type"
  };

  private.app_o = ui.screen.Orientation();
  private.app_h = ui.screen.Height();
  private.app_w = ui.screen.Width();
  private.window_area = {
    landscape = { -230, -230, 460, 510 },
    portrait = { -290, -290, 580, 610 };
  };

  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( stage_data )
  
  private.SetDefault( stage_data );
  
  ui.window.Open( "tutorial_animation", function ()
    
    ui.anim.Play(
      _this.window,
      "appear_"..private.app_o,
      nil,
      "static_"..private.app_o
    );
    
  end );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_OnHide )
  
  ui.anim.Play(
    _this.window,
    "disappear_"..private.app_o,
    function ()
      
      ui.window.Close( "tutorial_animation", func_OnHide );
      
    end
  );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()
  
  local multiset = {};
  
  ui.obj.ToCenter( _this.dialog, 0, 0, multiset );
  ui.window.SetArea( _this.dialog, private.window_area[ private.app_o ], multiset );
  ui.obj.Multiset( multiset );
  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  ui.button.Create(
    _this.button.close,
    {
      design = "close"
    },
    function() _f.Close(); end
  );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.SetDefault ( stage_data )
  
  ui.obj.Set( _this.window, 
  { 
    tt_description = "str_int_dialog_tutorial_animation_"..stage_data.tutorial
  } );
  
  ui.obj.Set( _this.type, 
  { 
    animfunc = stage_data.tutorial,
    playing = true
  } );
  
end;
--------------------------------------------------------------------------------