-- name=int_dialog_update
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  OnHide = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this = {
    dialog = "int_dialog_update",
    window = "anm_int_dialog_update",
    button = "btn_int_dialog_update_get"
  };
  
  private.strings = {
    reward = "str_dialog_update_reward_message",
    replay = "str_dialog_update_replay_message"
  };

  ui.obj.ToCenter( "obj_int_dialog_update" );

  ui.button.Create(
    private.this.button,
    {
      color  = "green",
      design = "medium",
      sound  = "ok_info"
    },
    function()
      
      private.Hide();
     
    end
  );

  ui.obj.Set(
    "anm_int_dialog_update",
    {
      title = ne.strings.Get( "str_dialog_update_caption" )
    }
  );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show (
    dialog_type,
    message,
    skin_current
  )

  local multiset = {};
  
  private.skin_current = skin_current;

  local animfunc = {
    reward = "static",
    replay = "static_replay"
  };

  ui.obj.Set(
    private.this.window,
    {
      animfunc       = animfunc[ dialog_type ],
      playing        = true,
      tt_description = private.strings [ dialog_type ],
    },
    multiset
  );
  
  ui.button.SetText(
    private.this.button,
    "str_dialog_update_"..dialog_type.."_button",
    multiset
  );
    
  ui.obj.Multiset( multiset );
  
  if ( private.skin_current ) then
  
    private.skin = ui.skin.Attach(
      "obj_int_dialog_update_character",
      private.skin_current
    );
    
    ui.anim.Play(
      private.skin,
      "skinview_fun1", -- FIXME: need animfunc?
      nil,
      "dialog"
    );
    
  end;

  common.sound.Play( "app_info" );

end;
--------------------------------------------------------------------------------
function private.Hide ()

  ui.window.Hide( private.this.dialog );
  
  if ( private.skin_current ) then
  
    ui.skin.Detach( private.skin );
  
  end;

  _f.OnHide();

end;
--------------------------------------------------------------------------------