-- name=int_game_start
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.this =
  {
    interface  = "obj_int_game_start",
    anm_play   = "anm_int_game_start_play",
    btn_play   = "btn_int_game_start_play_action",
    anm_exit   = "anm_int_game_start_exit",
    btn_exit   = "btn_int_game_start_exit_action",
    anm_social = "anm_int_game_start_social",
    btn_social = "btn_int_game_start_social_action",
    obj_google = "obj_int_game_start_google",
    anm_google = "anm_int_game_start_google"
  };

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

end;
--------------------------------------------------------------------------------
function public.Attach ( obj_splash )

  ui.obj.Attach( private.this.interface, obj_splash )

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.BtnPlay_Show ( func_action )

  ui.obj.Attach( private.this.anm_play, private.this.interface );

  ui.button.Create(
    private.this.btn_play,
    {
      design = "medium",
      color  = "green",
      title  = private.String( "play" )
    },
    func_action
  );
  
  ui.anim.Play(
    private.this.anm_play,
    "btn_play_appear",
    function () end,
    "btn_play_static"
  );

end;
--------------------------------------------------------------------------------
function public.BtnExit_Show ( func_action )

  ui.obj.Attach( private.this.anm_exit, private.this.interface );
  ui.obj.Set(
    private.this.anm_exit,
    {
      pos_x =  ui.screen.Width()  / 2,
      pos_y = -ui.screen.Height() / 2
    }
  );
  
  ui.button.Create(
    private.this.btn_exit,
    {
      design = "close"
    },
    func_action
  );

end;
--------------------------------------------------------------------------------
function public.Social_Show ()

  ui.obj.Attach( private.this.anm_social, private.this.interface );
  
  ui.button.Create(
    private.this.btn_social,
    {
      design = "facebook"
    },
    function () end
  );

end;
--------------------------------------------------------------------------------
function public.Social_SetFormLogin ( reward, func_action )

  if ( reward.name == "heart" ) then
  
    ui.obj.Set(
      private.this.anm_social,
      {
        playing        = true,
        animfunc       = "portrait_fb_connect_hearts",
        tt_title       = private.String( "social_hearts_title" ),
        tt_description = private.String( "social_hearts_description" ),
        tt_heart_count = "+"..reward.count
      }
    );
  
  else
  
    ui.obj.Set(
      private.this.anm_social,
      {
        playing        = true,
        animfunc       = "portrait_fb_connect_moves",
        tt_title       = private.String( "social_boosters_title" ),
        tt_description = private.String( "social_boosters_description" ),
        tt_moves_count = "x"..reward.count,
        tt_moves       = private.String( "social_boosters_moves" ),
      }
    );
  
  end;

  ui.button.SetText(
    private.this.btn_social,
    private.String( "social_login" )
  );
  ui.button.EventSet( private.this.btn_social, func_action ); 

end;
--------------------------------------------------------------------------------
function public.Social_SetFormLogout ( func_action )

  ui.obj.Set(
    private.this.anm_social,
    {
      playing  = true,
      animfunc = "portrait_fb_connect"
    }
  );

  ui.button.SetText(
    private.this.btn_social,
    private.String( "social_logout" )
  );
  ui.button.EventSet( private.this.btn_social, func_action ); 

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.GooglePlay_Show ()

  ui.obj.Attach( private.this.obj_google, private.this.interface );
  ui.obj.Set(
    private.this.obj_google,
    {
      pos_x =  ui.screen.Width()  / 2,
      pos_y = -ui.screen.Height() / 2
    }
  );
  
end;
--------------------------------------------------------------------------------
function public.GooglePlay_SetFormLogin ( func_action )

  ui.obj.Set(
    private.this.anm_google,
    {
      playing  = true,
      animfunc = "btn_google_login"
    }
  );

  ui.control.EventsSet(
    private.this.obj_google,
    {
      func_on_click = func_action
    }
  );


end;
--------------------------------------------------------------------------------
function public.GooglePlay_SetFormLogout ( nickname, func_action )

  ui.obj.Set(
    private.this.anm_google,
    {
      playing  = true,
      animfunc = "btn_google_logout",
      tt_desc  = nickname
    }
  );

  ui.control.EventsSet(
    private.this.obj_google,
    {
      func_on_click = func_action
    }
  );


end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.String ( id )

  return "str_int_game_start_"..id;

end;
--------------------------------------------------------------------------------