-- name=int_panel_darkhole
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_panel_darkhole" );

  ObjMultiSet( { 
    { "spr_int_panel_darkhole_dark_left",   { event_mup = public.Hide } },
    { "spr_int_panel_darkhole_dark_top",    { event_mup = public.Hide } },
    { "spr_int_panel_darkhole_dark_right",  { event_mup = public.Hide } },
    { "spr_int_panel_darkhole_dark_bottom", { event_mup = public.Hide } },
    { "trp_int_panel_darkhole_hole",        { 
      event_mup = function () 
    
        ui.obj.Set( "trp_int_panel_darkhole_hole", { input = false } );
        public.Hide();
        if ( private.FuncTap ) then
          private.FuncTap();
        end;

      end
    } }
  } );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( obj, func_tap, scale )
  
  ui.obj.Enable( "int_panel_darkhole" );
  
  local scale_anim = (scale or 1.0) * 1.8;
  private.FuncTap = func_tap;
  
  local obj_pos;
  local obj_name;
  
  if ( type( obj ) == "string" ) then
    
    obj_pos  = GetObjPosByObj( obj );
    obj_name = obj;
    
  else
    
    obj_pos  = { obj.pos_x, obj.pos_y };
    obj_name = obj.name;
    
  end;
  
  ui.obj.Set( "trp_int_panel_darkhole_hole", { input = true } );
  
  local hole_pos_x = math.floor( obj_pos[ 1 ] );
  local hole_pos_y = math.floor( obj_pos[ 2 ] );
  
  if ( private.active ) then
    
    local hole = ObjGet( "anm_int_panel_darkhole_hole" );
    
    ObjAnimate( "anm_int_panel_darkhole_hole", "pos_xy", 0, 0, "",
    {
      0.0, 0, hole.pos_x, hole.pos_y,
      0.3, 0, hole_pos_x, hole_pos_y
    } );
    
    if ( hole.scale_x ~= scale_anim ) then
      
      ObjAnimate( "anm_int_panel_darkhole_hole", "scale_xy", 0, 0, "",
      {
        0.0, 0, hole.scale_x, hole.scale_y,
        0.3, 0, scale_anim,   scale_anim
      } );
      
    end;
    
    private.Draw( hole_pos_x, hole_pos_y, true );
    
  else
  
    ui.hub.AttachContent( "int_panel_darkhole" );
    
    ObjSet( "anm_int_panel_darkhole_hole",
    {
      pos_x   = hole_pos_x,
      pos_y   = hole_pos_y,
      scale_x = scale_anim,
      scale_y = scale_anim
    } );
    
    ObjSet( "trp_int_panel_darkhole_hole",
    {
      pos_x   = hole_pos_x,
      pos_y   = hole_pos_y
    } );
    
    ui.anim.Play( 
      "anm_int_panel_darkhole_hole",
      "open",
      function ()
        
        ui.anim.Play( "anm_int_panel_darkhole_hole", "static" );
      
      end
    );
  
    private.Draw( hole_pos_x, hole_pos_y );
    
    private.active = true;
    
  end;
  
end;
--------------------------------------------------------------------------------
function public.Hide ()
  
  if ( not private.active ) then
 
    return;

  end;
  
  private.active = false;
  
  ui.obj.Disable( "int_panel_darkhole" );
    
  --ui.anim.Play( 
  --  "anm_int_panel_darkhole_hole",
  --  "close",
  --  function ()
  --    ui.hub.DetachContent( "int_panel_darkhole" );
  --  end
  --);

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Draw ( x, y, animate )

  local size   = 60;
  local spr_x  = math.floor( x );
  local spr_y  = math.floor( y );
  
  local func_set_sides = function ()
  
    local object = ui.obj.Get( "anm_int_panel_darkhole_hole" );
    local spr_w  = ( size ) * object.scale_x;
    local spr_h  = ( size ) * object.scale_y;
  
    local objects = {};
  
    table.insert( objects, { "spr_int_panel_darkhole_dark_left", {
      pos_x   = - spr_w / 2, 
      pos_y   =   spr_h / 2 
    } } );

    table.insert( objects, { "spr_int_panel_darkhole_dark_top", {
      pos_x   = - spr_w / 2, 
      pos_y   = - spr_h / 2
    } } );

    table.insert( objects, { "spr_int_panel_darkhole_dark_right", {
      pos_x   =   spr_w / 2, 
      pos_y   = - spr_h / 2
    } } );

    table.insert( objects, { "spr_int_panel_darkhole_dark_bottom", {
      pos_x   = spr_w / 2, 
      pos_y   = spr_h / 2
    } } );
    
    table.insert( objects, { "trp_int_panel_darkhole_hole", {
      inputrect_x = - spr_w / 2,
      inputrect_y = - spr_h / 2,
      inputrect_w = spr_w,
      inputrect_h = spr_h
    } } );
    
    ObjMultiSet( objects );
  
  end;
  
  if ( animate ) then
    
    local obj = ObjGet( "obj_int_panel_darkhole_dark" );
    
    ObjAnimate( "obj_int_panel_darkhole_dark", "pos_xy", 0, 0, func_set_sides,
    {
      0.0, 0, obj.pos_x, obj.pos_y,
      0.3, 0, spr_x,     spr_y
    } );
    
  else
    
    func_set_sides();
    ObjSet( "obj_int_panel_darkhole_dark", {
      pos_x = spr_x,
      pos_y = spr_y 
    } );
    
  end;
  
end;
--------------------------------------------------------------------------------