-- name=int_panel_hearts_offers
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Obtain = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this = {
    int = "int_panel_hearts_offers",
    anm = "anm_int_panel_hearts_offers"
  };

  ui.hub.Create( private.this.int );
  
  local app_h = ui.screen.Height();
  local app_w = ui.screen.Width();
  local app_o = ui.screen.Orientation();
  
  private.app_o = app_o;
  
  private.animfunc =
  {
    show   = "appear_"..app_o,
    static = "static_"..app_o,
    hide   = "disappear_"..app_o
  };

  ui.obj.Set(
    "obj_int_panel_hearts_offers",
    {
      pos_x = 0.5 * app_w,
      pos_y = app_h
    }
  );
  
  private.window_area = {
    portrait = {
      { -125, -230, 250, 210 },
      { -210, -230, 420, 210 },
      { -290, -230, 580, 210 }
    },
    landscape = {
      { -100, -200, 200, 190 },
      { -180, -200, 360, 190 },
      { -180, -200, 360, 190 }
    }
  };
  
  private.strings = {
    description = ne.strings.Get( "str_int_panel_hearts_offers_description" )
  };
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( offers_data )

  if ( private.active ) then return end;
  private.active = true;

  ui.obj.Show( "int_panel_hearts_offers" );

  ui.hub.AttachContent( private.this.int );
  
  private.SetButtons( offers_data );
  
  ui.input.Off( private.this.int );
  
  ui.anim.Play(
    private.this.anm,
    private.animfunc.show,
    function()
   
      ui.anim.Play( private.this.anm, private.animfunc.static );    
      ui.input.On( private.this.int );
    
    end
  );

end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( not private.active ) then return end;
  private.active = false;
  
  ui.input.Off( private.this.int );

  ui.anim.Play(
    private.this.anm,
    private.animfunc.hide,
    function()
   
      ui.hub.DetachContent( private.this.int );
    
    end
  );
  
end;
--------------------------------------------------------------------------------
function public.Update ( offers_data )
  
  private.SetButtons( offers_data );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.SetButtons ( offers_data )
  
  for i = 1, 3 do
    ObjDetach( "btn_int_panel_hearts_offers_"..i );  
    ui.control.EventsClear( "btn_int_panel_hearts_offers_"..i );
  end;
  
  local postfix = tern( IsPC() and #offers_data == 2 )( "_pc", "" );
  
  ObjSet( "anm_int_panel_hearts_offers_btns", 
  { 
    animfunc = #offers_data.."btn", 
    playing = true,
    tt_description = private.strings.description.."_"..#offers_data..postfix
  } );
  
  for i = 1, #offers_data do
    
    local offer = offers_data[ i ];
    
    local object_name = "int_panel_hearts_offers_"..i;

    ObjSet( "btn_"..object_name, { anim_tag = "btn_"..i } );
    ObjAttach( "btn_"..object_name, "anm_int_panel_hearts_offers_btns" );
    ObjSet( "anm_"..object_name, 
    { 
      animfunc = tern( offer.name:find( "facebook" ) )( "heart_fb", "heart_donate" );
      tt_hearts = "+"..offer.currency_count, 
      tt_title  = tern( offer.price == "" )( "str_dialog_shop_gold_buy", offer.price )
    } );

    ui.control.EventsSet(
      "btn_"..object_name,
      {
        func_on_click = function () _f.Obtain( offer.name ); end
      }
    );
    
  end;
  
  if ( #offers_data ~= 0 ) then
    ui.window.SetArea(
      "obj_int_panel_hearts_offers",
      private.window_area[ private.app_o ][ #offers_data ]
    );
  end;
  
end;
--------------------------------------------------------------------------------