-- name=int_panel_interface_top
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetCount = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()
  
  private.int_w = ui.screen.Width();
  private.int_h = ui.screen.Height() - ui.screen.TopSafeArea();
  private.int_topSafeArea = ui.screen.TopSafeArea();
  private.int_o = ui.screen.Orientation();

  private.this = {
    int = "int_panel_interface_top",
    obj = {
      panel     = "obj_int_panel_interface_top",
      gold      = "obj_int_panel_interface_top_gold",
      resource1 = "obj_int_panel_interface_top_resource1",
      resource2 = "obj_int_panel_interface_top_resource2",
      resource3 = "obj_int_panel_interface_top_resource3",
      resource4 = "obj_int_panel_interface_top_resource4"
    },
    anm = {
      panel        = "anm_int_panel_interface_top",
      notification = {
        panel = "anm_int_panel_interface_top_notification",
        body  = "anm_int_panel_interface_top_notification_body",
        icon  = "anm_int_panel_interface_top_notification_icon"
      },
      gold      = "anm_int_panel_interface_top_gold",
      resource1 = "anm_int_panel_interface_top_resource1",
      resource2 = "anm_int_panel_interface_top_resource2",
      resource3 = "anm_int_panel_interface_top_resource3",
      resource4 = "anm_int_panel_interface_top_resource4"
    },
    dcr = {
      obj = "anm_int_panel_interface_top_decoration",
      res = "anm_decoration_top"
    }
  };

  private.animfunc = {
    panel = {
      show   = private.int_o.."_appear",
      static = private.int_o.."_static",
      hide   = private.int_o.."_disappear"
    },
    highlight = {
      gold = {
        show   = "gold_appear",
        static = "gold_static",
        hide   = "gold_disappear"
      },
      resource4 = {
        show   = "res_4_appear",
        static = "res_4_static",
        hide   = "res_4_disappear"
      }
    },
    notification = {
      show = "notification_show",
      hide = "notification_hide"
    }
  };

  private.animfunc_static = {
    panel = {
      gold      = "res_gold",
      resource1 = "res_1",
      resource2 = "res_2",
      resource3 = "res_3"
    },
    highlight = {
      gold      = "res_gold_highlight",
      resource1 = "res_1_highlight",
      resource2 = "res_2_highlight",
      resource3 = "res_3_highlight",
      resource4 = "res_4_highlight"
    }
  };

  private.animfunc_count_increase = {
    panel = {
      gold      = "res_gold_count_i",
      resource1 = "res_1_count_i",
      resource2 = "res_2_count_i",
      resource3 = "res_3_count_i"
    },
    highlight = {
      gold      = "res_gold_count_i_highlight",
      resource1 = "res_1_count_i_highlight",
      resource2 = "res_2_count_i_highlight",
      resource3 = "res_3_count_i_highlight",
      resource4 = "res_4_count_i_highlight"
    }
  };
  
  private.animfunc_count_decrease = {
    panel = {
      gold      = "res_gold_count_d",
      resource1 = "res_1_count_d",
      resource2 = "res_2_count_d",
      resource3 = "res_3_count_d"
    },
    highlight = {
      gold      = "res_gold_count_d_highlight",
      resource1 = "res_1_count_d_highlight",
      resource2 = "res_2_count_d_highlight",
      resource3 = "res_3_count_d_highlight",
      resource4 = "res_4_count_d_highlight"
    }
  };

  private.hidden_frame = 30;

  private.target_queue = {
    gold      = {},
    resource1 = {},
    resource2 = {},
    resource3 = {},
    resource4 = {}
  };

  private.is_counting = {
    gold      = false,
    resource1 = false,
    resource2 = false,
    resource3 = false,
    resource4 = false
  };

  private.active             = {};
  private.counter_stop       = {}
  private.func_show_popup    = {};
  private.func_hide_popup    = {};
  private.func_check_popup   = {};
  private.notification_queue = {};

  private.locked  = false;
  private.view    = "panel";
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( private.this.int );

  local multiset = {};
  
  ui.obj.Set(
    private.this.obj.panel,
    {
      pos_x = 0.5 * private.int_w,
      pos_y = private.int_topSafeArea
    },
    multiset
  );

  ui.control.EventsSet(
    private.this.obj.gold,
    {
      func_on_click = function()

        private.Counter_ShowPopup( "gold" );

      end
    },
    multiset
  );

  for r = 1, 4 do

    ui.control.EventsSet(
      private.this.obj[ "resource"..r ],
      {
        func_on_click = function()

          private.Counter_ShowPopup( "resource"..r );

        end
      },
      multiset
    );

  end;
  
  local decoration = private.this.dcr.obj;
  ui.obj.Set( decoration, { alp = 0 }, multiset );

  ui.obj.Multiset( multiset );

  ui.hub.AttachContent( private.this.int );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.IsVisible ()

  local animfunc =
    ( ui.obj.Get( private.this.anm.panel ) or {} ).animfunc or "";

  return ( animfunc:find( "_static" ) ) or
         ( animfunc:find( "_appear" ) );

end;
--------------------------------------------------------------------------------
function public.IsLocked ()

  return private.locked;

end;
--------------------------------------------------------------------------------
function public.IsHighlighted ()

  return ( private.highlighted ~= nil );

end;
--------------------------------------------------------------------------------
function public.IsActive ( resource_type )

  return private.active[ resource_type ] or false;

end;
--------------------------------------------------------------------------------
function private.GetAnimFunc ( visible, highlighted )
  
  if ( highlighted ) then
    return private.animfunc[ visible ][ highlighted ];
  end;
  
  return private.animfunc[ visible ];
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ()
  
  if ( public.IsVisible() ) then return; end;

  private.off = false;
  
  if ( private.highlighted ) then
  
    ui.obj.Set(
      private.this.anm[ private.highlighted ],
      {
        animfunc = private.animfunc_static[ private.view ][ private.highlighted ]
      }
    );
  
  end;

  local animfuncs = private.GetAnimFunc( private.view, private.highlighted );
  
  local is_enabled = true;
  if ( private.view_type == "none" ) and
     ( not private.highlighted     ) then
    is_enabled = false;
  end;
  
  ui.obj.Set(
    private.this.anm.panel,
    {
      visible = is_enabled,
      input   = is_enabled
    }
  );
  
  ui.anim.Play(
    private.this.anm.panel,
    animfuncs.show,
    function ()
      if ( is_enabled ) then
        ui.input.On( private.this.obj.panel );
      else
        ui.input.Off( private.this.obj.panel );
      end;
    end,
    animfuncs.static
  );

  private.Decoration_Update( true );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_OnHide )
  
  if ( public.IsLocked() ) then
    if ( func_OnHide ) then func_OnHide(); end;
    return;
  end;
  
  if ( not public.IsVisible() ) then
    if ( func_OnHide ) then func_OnHide(); end;
    return;
  end;

  ui.input.Off( private.this.obj.panel );
  ui.anim.Stop( private.this.anm.panel );

  private.Decoration_Update( false );
  
  local animfuncs = private.GetAnimFunc( private.view, private.highlighted );
  
  ui.anim.Play(
    private.this.anm.panel,
    animfuncs.hide,
    function ()
      private.Restore();
      if ( func_OnHide ) then func_OnHide(); end;
      private.off = true;
    end
  );

  for resource_type, func_check_popup in pairs( private.func_check_popup ) do
    local is_popup_open = func_check_popup();
    if ( is_popup_open ) then
      private.Counter_HidePopup( resource_type, true );
    end;
  end;
  
end;
--------------------------------------------------------------------------------
function public.Off ()

  if ( private.off ) then return; end;

  AnimStop(
    private.this.anm.panel,
    ui.obj.Get( private.this.anm.panel ).animfunc
  );

  ui.obj.Set(
    private.this.anm.panel,
    {
      animfunc = private.animfunc.panel.hide,
      playing  = false,
      frame    = private.hidden_frame,
      endtrig  = function () end
    }
  );

  ui.input.Off( private.this.obj.panel );
  private.Restore();

  private.off = true;

end;
--------------------------------------------------------------------------------
function public.Input_On ()
  
  ui.input.On( private.this.obj.panel );
  
end;
--------------------------------------------------------------------------------
function public.Input_Off ()
  
  ui.input.Off( private.this.obj.panel );
  
end;
--------------------------------------------------------------------------------
function public.Lock ( state )

  private.locked = state;

end;
--------------------------------------------------------------------------------
function public.Highlight ( res_name )

  if ( not res_name ) then
    private.highlighted = nil;
    private.view = "panel";
    return;
  end;
  
  if ( private.highlighted ) then return; end;

  private.highlighted = res_name;
  private.view = "highlight";

end;
--------------------------------------------------------------------------------
function public.ShowPopup ( resource_type, text_string )

  private.Counter_ShowPopup( resource_type, text_string );

end;
--------------------------------------------------------------------------------
function public.ShowNotification ( text, icon, style )

  -- JK: style can be:
  -- - success
  -- - fail
  -- - info
  
  -- JK: icon can be:
  -- - gold / resource1, 2, 3
  -- - online / offline
  
  -- Defaults
  icon  = icon  or "default";
  style = style or "info";
  
  table.insert(
    private.notification_queue,
    {
      text  = text,
      icon  = icon,
      style = style
    }
  );

  private.Notification_TryShowFromQueue();

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.View_Set ( view_type )

  private.view_type = view_type;

  if ( view_type == "default" ) then
    for i = 1, 3 do
      local resource_name  = "resource"..i;
      local resource_count = _f.GetCount( resource_name );
      private.Counter_Show( resource_name, resource_count );
    end;
  end;
  
  if ( view_type == "gold_only" ) then
    for i = 1, 3 do
      private.Counter_Hide( "resource"..i );
    end;
  end;

end;
--------------------------------------------------------------------------------
function public.View_Reset ( view_type )

  private.view_type = "default";

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Gold_Show ( gold_count )

  local func_show_popup = function( text_string )

    text_string = text_string or "str_int_panel_map_gold_popup_text";

    ui.popup.Flat_Show(
      "str_int_panel_map_gold_popup_caption",
      text_string,
      private.this.obj.gold,
      { 0, -130 },
      true,
      true
    );

  end;
  
  local func_hide_popup = function( instant )
    ui.popup.Flat_Hide( instant );
  end;
  
  local func_check_popup = function ()
    return ( ui.popup.Flat_AttachedTo() == private.this.obj.gold );
  end;
  
  private.func_show_popup[ "gold" ]  = func_show_popup;
  private.func_hide_popup[ "gold" ]  = func_hide_popup;
  private.func_check_popup[ "gold" ] = func_check_popup;
  
  private.Counter_Show( "gold", gold_count );

end;
--------------------------------------------------------------------------------
function public.Gold_Hide ()

  private.Counter_Hide( "gold" );

end;
--------------------------------------------------------------------------------
function public.Gold_Update ( start_count, stop_count )

  if ( not private.active.gold  ) then

    return;

  end;

  private.counter_stop.gold = stop_count;

  if ( private.is_counting.gold ) then

    return;

  end;
  
  if ( not public.IsVisible()                                ) or
     ( private.highlighted and private.highlighted ~= "gold" ) then
    
    ui.obj.Set( private.this.anm.gold,
      {
        count = ui.text.FormatNumber( stop_count )
      }
    );
    
    return;
    
  end;

  private.is_counting.gold = true;

  private.Counter_Count( "gold", start_count, 1 );

  -- JK: play sound on gold increased  
  if ( start_count < stop_count ) then

     common.sound.Play( "gold" );

  end;

  -- JK: play sound on gold decreased  
  if ( start_count > stop_count ) then

    -- common.sound.Play( "gold" );

  end;

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Resource_Show ( resource_type, resource_count )

  local func_show_popup = function( text_string )

    text_string = text_string or "str_int_panel_map_"..resource_type.."_popup_text";

    ui.popup.Flat_Show(
      "str_int_panel_map_"..resource_type.."_popup_caption",
      text_string,
      private.this.obj[ resource_type ],
      { 0, -130 },
      true,
      true
    );

  end;
  
  local func_hide_popup = function( instant )
    ui.popup.Flat_Hide( instant );
  end;
  
  local func_check_popup = function ()
    return ( ui.popup.Flat_AttachedTo() == private.this.obj[ resource_type ] );
  end;
  
  private.func_show_popup[ resource_type ]  = func_show_popup;
  private.func_hide_popup[ resource_type ]  = func_hide_popup;
  private.func_check_popup[ resource_type ] = func_check_popup;

  private.Counter_Show( resource_type, resource_count );

end;
--------------------------------------------------------------------------------
function public.Resource_Hide ( resource_type )

  private.Counter_Hide( resource_type );

end;
--------------------------------------------------------------------------------
function public.Resource_Update (
    resource_type,
    start_count,
    stop_count,
    func_end,
    skip_animation
  )

  if ( not private.active[ resource_type ] ) then

    return;

  end;
  
  if ( skip_animation                                               ) or
     ( not public.IsVisible()                                       ) or
     ( private.highlighted and private.highlighted ~= resource_type ) or
     ( ( not private.highlighted ) and resource_type == "resource4" ) then
    
    ui.obj.Set( private.this.anm[ resource_type ],
      {
        count = ui.text.FormatNumber( stop_count )
      }
    );
    
    return;
    
  end;

  private.counter_stop[ resource_type ] = stop_count;

  if ( private.is_counting[ resource_type ] ) then

    return;

  end;

  private.is_counting[ resource_type ] = true;

  public.Resource_GrayOut( resource_type );
  
  local func_OnCountEnd = function ()      

    private.is_counting[ resource_type ] = false;

    if ( func_end ) then

      func_end();

    end;      

  end;

  private.Counter_Count( resource_type, start_count, 1, func_OnCountEnd );

end;
--------------------------------------------------------------------------------
function public.Resource_GrayIn ( resource_type )

  if ( not private.is_counting[ resource_type ] ) then

    ui.obj.Set(
      private.this.anm[ resource_type ],
      {
        color_r = 0.7,
        color_g = 0.7,
        color_b = 0.7
      }
    );

  end;

end;
--------------------------------------------------------------------------------
function public.Resource_GrayOut ( resource_type )

  ui.obj.Set(
    private.this.anm[ resource_type ],
    {
      color_r = 1.0,
      color_g = 1.0,
      color_b = 1.0
    }
  );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Decoration_Enable ( entity_name )

  private.Decoration_Enable( entity_name );

end;
--------------------------------------------------------------------------------
function public.Decoration_Disable ()

  private.Decoration_Disable();

end;
--------------------------------------------------------------------------------
function private.Decoration_Enable ( entity_name )

  local decoration = private.this.dcr.obj;
  local resource   = private.this.dcr.res;
  
  private.this.dcr.enbl = true;
  
  local animfuncs = private.GetAnimFunc( private.view, private.highlighted );
  
  ui.obj.Set( decoration, {
    playing = true,
    res = "assets/content/"..entity_name.."/"..resource,
    animfunc = private.int_o.."_static"
  } );
  
  ui.obj.Enable( decoration, true );

end;
--------------------------------------------------------------------------------
function private.Decoration_Update ( visible )
  
  local decoration = private.this.dcr.obj;
  local alp_start = ( visible ) and 0 or 1;
  local alp_stop  = ( visible ) and 1 or 0;

  ObjAnimate( decoration, "alp", 0, 0, "", { 0, 0, alp_start, 0.3, 0, alp_stop } );

end;
--------------------------------------------------------------------------------
function private.Decoration_Disable ()

  local decoration = private.this.dcr.obj;
  
  private.this.dcr.enbl = nil;
  
  ui.obj.Set( decoration, {
    playing = false,
    animfunc = ""
  } );

  ui.obj.Disable( decoration );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Restore ()

  if ( not private.highlighted ) then return; end;
  
  ui.obj.Set(
    private.this.anm[ private.highlighted ],
    {
      animfunc = private.animfunc_static.panel[ private.highlighted ]
    }
  );

  private.highlighted = nil;
  private.view = "panel";
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Notification_TryShowFromQueue ()

  if ( #private.notification_queue < 1 ) or
     (  private.active.notification    ) then

    return;

  end;

  private.active.notification = true;

  local multiset     = {};
  local notification = table.remove( private.notification_queue, 1 );

  if ( notification.text:find( "str_" ) ) then

    notification.text = ne.strings.Get( notification.text );

  end;

  ui.obj.Set(
    private.this.anm.notification.body,
    {
      animfunc = notification.style.."_notification",
      tt_title = notification.text
    },
    multiset
  );

  ui.obj.Set(
    private.this.anm.notification.icon,
    {
      animfunc = notification.icon.."_icon"
    },
    multiset
  ); 

  ui.obj.Multiset( multiset );

  ui.anim.Play(
    private.this.anm.notification.panel,
    private.animfunc.notification.show,
    function ()

      private.Notification_Hide(
        function()

          private.Notification_TryShowFromQueue();

        end
      );

    end
  );

end;
--------------------------------------------------------------------------------
function private.Notification_Hide ( func_end )

  private.active.notification = nil;

  ui.anim.Play(
    private.this.anm.notification.panel,
    private.animfunc.notification.hide,
    func_end
  );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Counter_Show ( resource_type, resource_count )

  local multiset = {};
  local visible  = ( resource_count >= 0 );
  
  ui.obj.Set(
    private.this.obj[ resource_type ],
    {
      input = visible
    },
    multiset
  );
    
  ui.obj.Set(
    private.this.anm[ resource_type ],
    {
      visible = visible,
      count   = ui.text.FormatNumber( resource_count ),
    },
    multiset
  );
  
  ui.obj.Multiset( multiset );

  if ( not visible ) then return; end;

  private.active[ resource_type ] = true;

end;
--------------------------------------------------------------------------------
function private.Counter_Hide ( resource_type )

  private.active[ resource_type ] = false;
  
  local multiset = {};
  
  ui.input.Off( private.this.obj[ resource_type ], multiset );
  ui.obj.Hide( private.this.anm[ resource_type ], multiset );
  
  ui.obj.Multiset( multiset );

end;
--------------------------------------------------------------------------------
function private.Counter_Count ( resource_type, start_count, step, func_end )
  
  if ( not public.IsVisible() ) then
    
    private.is_counting[ resource_type ] = false;
    
    ui.obj.Set(
      private.this.anm[ resource_type ],
      {
        count = ui.text.FormatNumber( private.counter_stop[ resource_type ] )
      }
    );
    
    if ( func_end ) then

      func_end();

    end;
    
    return;
    
  end;
  
  local anim_type  = private.view;
  local stop_count = private.counter_stop[ resource_type ];
  local new_step   = step;

  local diff = stop_count - start_count;
  local mod  = 1;

  if ( start_count > stop_count ) then

    diff = start_count - stop_count;
    mod  = - 1;

  end;

  if ( diff > 5 ) then

    new_step = math.floor( diff / 2 );

  else

    new_step = 1;

  end;

  if ( start_count == stop_count ) then

    private.is_counting[ resource_type ] = false;

    ui.anim.Play(
      private.this.anm[ resource_type ],
      private.animfunc_static[ anim_type ][ resource_type ]
    );

    if ( func_end ) then

      func_end();

    end;

    return;

  end;
  
  local func_OnAnimationEnd = function ()

    local new_count = start_count + mod * new_step;

    ui.obj.Set( private.this.anm[ resource_type ],
      {
        count = ui.text.FormatNumber( new_count )
      }
    );

    ui.anim.Play(
      private.this.anm[ resource_type ],
      private.animfunc_count_decrease[ anim_type ][ resource_type ],
      function ()

        private.Counter_Count(
          resource_type,
          new_count,
          new_step,
          func_end
        );

      end
    );

  end;
  
  ui.anim.Play(
    private.this.anm[ resource_type ],
    private.animfunc_count_increase[ anim_type ][ resource_type ],
    func_OnAnimationEnd
  );     

end;
--------------------------------------------------------------------------------
function private.Counter_ShowPopup ( resource_type, text_string )

  private.func_show_popup[ resource_type ]( text_string );

end;
--------------------------------------------------------------------------------
function private.Counter_HidePopup ( resource_type, instant )

  private.func_hide_popup[ resource_type ]( instant );

end;
--------------------------------------------------------------------------------
