-- name=int_panel_stage_score
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function public.__InitModule ()
  
  private.pos_x = 0;
  private.pos_y = 0;
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_panel_stage_score" );
  
  ObjSet( "int_panel_stage_score",
  {
    pos_x = 0,
    pos_y = 0
  } );

end;
--------------------------------------------------------------------------------
function public.Show ( color )

  ui.hub.AttachContent( "int_panel_stage_score" );
  
  local multiset_table = {};
  
  table.insert( multiset_table, 
  {
  "obj_int_panel_stage_score", { pos_x = private.pos_x, pos_y = private.pos_y }
  } );
  
  table.insert( multiset_table, 
  {
    "spr_int_panel_stage_score_bg", 
    { 
      color_r = color.r, 
      color_g = color.g, 
      color_b = color.b
    }
  } );

  table.insert( multiset_table, 
  {
    "txt_int_panel_stage_score_count", { text = 0 }
  } );
  
  table.insert( multiset_table, 
  {
    "int_panel_stage_score", { input = true, active = true, visible = true }
  } );

  ObjMultiSet( multiset_table );

  private.active = true;

end;
--------------------------------------------------------------------------------
function public.Hide ()

  private.active = false;

  ObjSet( "int_panel_stage_score", { input = false, active = false, visible = false } );
  ui.hub.DetachContent( "int_panel_stage_score" );
  

end;
--------------------------------------------------------------------------------
function public.Update ( score )

  if ( not private.active ) then  

    return;

  end;

  ObjSet( "txt_int_panel_stage_score_count", { text = ui.text.FormatNumber( score, true ) } );

  local tme = 0.05;

  ObjAnimate( "obj_int_panel_stage_score_count", "scale_xy", 0, 0, "",
  {
    tme *  0, 3, 1.0,  1.0,
    tme *  1, 3, 1.2,  1.2,
    tme *  3, 3, 0.8,  0.8,

    tme *  5, 3, 1.15, 1.15,
    tme *  7, 3, 0.85, 0.85,

    tme *  9, 3, 1.10, 1.10,
    tme * 11, 3, 0.90, 0.90,

    tme * 13, 3, 1.05, 1.05,
    tme * 15, 3, 0.95, 0.95,

    tme * 16, 3, 1.00, 1.00
  } );

end;
--------------------------------------------------------------------------------
function public.SetPos( x, y )
  
  private.pos_x = x;
  private.pos_y = y;
  
end;
--------------------------------------------------------------------------------
function public.SetScale( s )
  
  ObjSet( "obj_int_panel_stage_score", 
  {
    scale_x = s,
    scale_y = s
  } );
    
end;
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------