-- name=int_panel_stage_win
--------------------------------------------------------------------------------
function public.__InitModule ()
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_panel_stage_win" );
  
  ui.obj.ToCenter( "int_panel_stage_win" );
  
  private.message = {
    fox_appear     = ne.strings.Get( "str_int_panel_stage_win_bonus" ),
    level_complete = ne.strings.Get( "str_int_panel_stage_win_level_complete" )
  };

end;
--------------------------------------------------------------------------------
function public.Show ( animation, func_end, skin_current )

  private.active = true;
  
  ui.hub.AttachContent( "int_panel_stage_win" );
  
  if ( skin_current ) then

    private.skin = ui.skin.Attach(
      "obj_int_panel_stage_win_hero",
      skin_current
    );
    
    ui.anim.Play( private.skin, "run4" );
    
  end;
  
  local objects = {};
  
  table.insert( objects, 
  {
    "int_panel_stage_win", { active = true, visible = true }
  } );
  
  table.insert( objects, 
  {
    "anm_int_panel_stage_win", { message = private.message[ animation ] }
  } );

  ObjMultiSet( objects );
  
  -- JK: fox voice
  if ( animation == "fox_appear" ) then
  
     common.sound.Play( "flying_fox_end_level" );
  
  end;
  
  ui.anim.Play( "anm_int_panel_stage_win", animation, function()
   
    private.Hide();
    
    if ( private.skin ) then
      
      ui.skin.Detach( private.skin );
      
      private.skin = nil;
      
    end;
    
    if ( func_end ) then
      
      func_end();
      
    end;
    
  end );

end;
--------------------------------------------------------------------------------
function public.IsActive ()
  
  return private.active;
  
end;
--------------------------------------------------------------------------------
function private.Hide ()

  private.active = false;
  
  ui.hub.DetachContent( "int_panel_stage_win" );
  
  ObjSet( "int_panel_stage_win", { active = false, visible = false } );

end;
--------------------------------------------------------------------------------