-- name=int_popup_stage_bonus
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.anim_time = 0.3;
  
  private.pos_x = 250;
  private.pos_y = 250;
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( "int_popup_stage_bonus" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function public.SetPos ( x, y )
  
  private.pos_x = x;
  private.pos_y = y;
  
end;
--------------------------------------------------------------------------------
function public.Show ( chip_type, stage_type, ability, func_show )

  if ( private.active ) then

    return;

  end;

  ui.hub.AttachContent( "int_popup_stage_bonus" );
  
  ObjSet( "obj_int_popup_stage_bonus", { active = true, visible = true } );

  private.SetDefault( chip_type, stage_type, ability );

  local tme = private.anim_time;

  ObjAnimate( "obj_int_popup_stage_bonus", "scale_xy", 0, 0, func_show, 
  { 
    0.0, 0, 0, 0, 
    tme, 0, 1, 1 
  } );

   common.sound.Play( "desire" );

  private.active = true;
  
end;
--------------------------------------------------------------------------------
function public.Hide ( completed )

  if not ( private.active ) then
    return;
  end;

  private.active = false;

  local multiset_table = {};
  local animfunc = "icon_reject";

  if ( completed ) then

    animfunc = "icon_done";

  end;

  local func_end = function ()

    local func_end_anim = function () 

      ObjSet( "obj_int_popup_stage_bonus", { active = false, visible = false } );

      ui.hub.DetachContent( "int_popup_stage_bonus" ); 

    end;

    local tme = private.anim_time;

    ObjAnimate( "obj_int_popup_stage_bonus", "scale_xy", 0, 0, func_end_anim, 
    { 
      0.0, 0, 1, 1, 
      tme, 0, 0, 0 
    } );

  end;

  if ( completed == nil ) then

    func_end();

    return;

  end;

  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_check", { animfunc = animfunc, playing = true, visible = true } } );
  table.insert( multiset_table, { "obj_int_popup_stage_bonus_ability", { visible = false } } );
  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon", { visible = false } } );
  
  ObjMultiSet( multiset_table );

  ObjAnimate( "obj_int_popup_stage_bonus", "pos_z", 0, 0, func_end, 
  {
    0.0, 0, 0,
    0.6, 0, 0
  } );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.SetDefault ( chip_type, stage_type, ability )
  
  local pop_scale  = { 1.2, 1.0 };
  local chip_scale = 0.8;
  local chip_pos   = { - 38, 0, 0 };
  local multiset_table = {};

  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon", { visible = false } } );
  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon", 
  { 
    visible  = true, 
    animfunc = "chip_"..string.lower( chip_type ), 
    playing  = true,
    scale_x  = chip_scale,
    scale_y  = chip_scale,
    pos_x    = chip_pos[ 1 ],
    pos_y    = chip_pos[ 2 ],
    pos_z    = chip_pos[ 3 ]
  } } );

  table.insert( multiset_table, { "spr_int_popup_stage_bonus_icon_check", { visible = false } } );
  table.insert( multiset_table, { "obj_int_popup_stage_bonus",    { pos_x = private.pos_x, pos_y = private.pos_y   } } );
  table.insert( multiset_table, { "spr_int_popup_stage_bonus_bg", { scale_x = pop_scale[1], scale_y = pop_scale[2] } } );

  if ( ability ) then

    table.insert( multiset_table, { "obj_int_popup_stage_bonus_ability",        { visible = true } } );
    table.insert( multiset_table, { "txt_int_popup_stage_bonus_ability",        { text = "" } } );
    table.insert( multiset_table, { "spr_int_popup_stage_bonus_ability",        { animfunc = "icon_"..ability, playing = true } } );
    table.insert( multiset_table, { "spr_int_popup_stage_bonus_ability_remove", { visible = false } } );
  
  else

    table.insert( multiset_table, { "obj_int_popup_stage_bonus_ability", { visible = false } } );

  end;

  ui.obj.Multiset( multiset_table );

end;
--------------------------------------------------------------------------------