-- name=int_popup_stage_combo
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.this = {
    int = "int_popup_stage_combo"
  };
  
  private.count        =  0;
  private.start_pos_y  =  150;
  private.finish_pos_y = -150;
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( private.this.int );

end;
--------------------------------------------------------------------------------
function public.Attach ()

  ui.hub.AttachContent( private.this.int );

end;
--------------------------------------------------------------------------------
function public.Detach ()

  private.Hide();
  
  ui.hub.DetachContent( private.this.int );

end;
--------------------------------------------------------------------------------
function public.Show ( x, y, combo_number )

  ObjSet( "obj_int_popup_stage_combo", 
  { 
    visible = true,
    active  = true,
    pos_x = x,
    pos_y = y
  } );

  private.count = private.count + 1;

  local combo_name = "obj_int_popup_stage_combo_"..combo_number;

  local func_end = function ( params )

    ObjSet( params.sender, { visible = false, alp = 0, scale_x = 0.5, scale_y = 0.5 } );

    private.count = private.count - 1;

    if ( private.count == 0 ) then

      ObjSet( "obj_int_popup_stage_combo", { visible = false, active = false } );

    end;

  end;

  ObjSet( combo_name, { visible = true, alp = 0, scale_x = 0.5, scale_y = 0.5 } );

  ObjAnimate( combo_name, "pos_y", 0, 0, func_end, 
  {
    0.0, 3, private.start_pos_y, 
    2.0, 3, private.finish_pos_y
  } );

  ObjAnimate( combo_name, "scale_xy", 0, 0, "", 
  {
    0.0, 3, 0.5, 0.5,
    0.4, 3, 1, 1,
    1.4, 3, 1, 1,
    2.0, 3, 0.5, 0.5
  } );

  ObjAnimate( combo_name, "alp", 0, 0, "", 
  {
    0.0, 0, 0,
    0.4, 0, 1,
    1.4, 0, 1,
    2.0, 0, 0
  } );

   common.sound.Play( "congratulation_"..math.min( 5, combo_number ) );

end;
--------------------------------------------------------------------------------
function private.Hide ()
  
  private.StopAndSetDefaultParams( "obj_int_popup_stage_combo_1" );
  private.StopAndSetDefaultParams( "obj_int_popup_stage_combo_2" );
  private.StopAndSetDefaultParams( "obj_int_popup_stage_combo_3" );
  private.StopAndSetDefaultParams( "obj_int_popup_stage_combo_4" );
  private.StopAndSetDefaultParams( "obj_int_popup_stage_combo_99" );
  
end;
--------------------------------------------------------------------------------
function private.StopAndSetDefaultParams ( name )
  
  ObjStopAnimate( name, "pos_y" );
  ObjStopAnimate( name, "scale_xy" );
  ObjStopAnimate( name, "alp" );
  ObjSet( name, { visible = false, alp = 0, scale_x = 0.5, scale_y = 0.5 } );
  
end;
--------------------------------------------------------------------------------