-- name=int_popup_stage_score
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.this = {
    int = "int_popup_stage_score"
  };

  private.score_offset = 30;
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.hub.Create( private.this.int );

  -- JK: Generating 32 labels
  private.labels = {};

  for i = 1, 32 do

    private.Label_GenerateNew();

  end;
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Show ( pos_x, pos_y, color, value )

  local popup_number = private.Label_GetFreeNumber();
  local popup_name   = private.labels[ popup_number ].name;
  local popup_digits = "anm_int_popup_stage_score_digit_";
  
  private.labels[ popup_number ].free = false;

  local function func_end ()
  
    private.labels[ popup_number ].free = true;

    ui.obj.Disable( popup_name, true );

  end;
  
  ui.obj.Set(
    popup_name,
    {
      animfunc = "score",
      playing  = true,
      frame    = 0,
      active   = true,
      visible  = true,
      pos_x    = pos_x + private.score_offset,
      pos_y    = pos_y - private.score_offset,
      color_r  = color.r,
      color_g  = color.g,
      color_b  = color.b,
      endtrig  = func_end
    }
  );

  local digits = ui.text.FormatNumberToDigits( value );
  
  ui.obj.Set(
    "anm_int_popup_stage_score_digits_"..private.labels[ popup_number ].index,
    {
      animfunc = "number_"..#digits,
      playing = true
    }
  );
  
  for i = 1, #digits do
    
    ui.obj.Set( 
      popup_digits..i.."_"..private.labels[ popup_number ].index,
      {
        animfunc = private.GetAnimFunc( digits[i] ),
        playing = true
      }
    );
    
  end;
  
end;
--------------------------------------------------------------------------------
function public.Attach ()

  ui.hub.AttachContent( private.this.int );

end;
--------------------------------------------------------------------------------
function public.Detach ()
  
  for key, value in pairs( private.labels ) do
    if ( not value.free ) then
      private.labels[ key ].free = true;
      ui.obj.Disable( value.name, true );
    end;
  end;
  
  ui.hub.DetachContent( private.this.int );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Label_GenerateNew ()
  
  local index = #private.labels + 1;

  ui.obj.Clone(
    "anm_int_popup_stage_score",
    "obj_int_popup_stage_score",
    "_"..index, 
    1
  );

  table.insert(
    private.labels,
    {
      name = "anm_int_popup_stage_score_"..index,
      index = index,
      free = true
    }
  );
  
end;
--------------------------------------------------------------------------------
function private.Label_GetFreeNumber ()
  
  for p, popup in pairs( private.labels ) do
    
    if ( popup.free ) then
      
      return p;
      
    end;
    
  end;
  
  private.Label_GenerateNew();

  return #private.labels;
  
end;
--------------------------------------------------------------------------------
function private.GetAnimFunc ( digit )
  
  if ( digit == " " ) then
    return "digit_space";
  elseif ( digit == "," ) then
    return "digit_comma";
  elseif ( digit == "." ) then
    return "digit_dot";
  end;
  return "digit_"..digit;
  
end;
--------------------------------------------------------------------------------