-- name=int_splash_map_overtaken
--------------------------------------------------------------------------------
function public.__InitModule ()
  
  private.this =
  {
    hub = "int_splash_map_overtaken",
    obj = "obj_int_splash_map_overtaken",
    anm = "anm_int_splash_map_overtaken"
  };
  
  private.active = false;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ui.obj.ToCenter( private.this.obj );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Show ( map_obj, map_pos, leader, func_after )

  local player_name = leader.name or StringGet( "str_player_name" );
  local stage_title = common.string.FormatNameStage( leader.stage );
  
  ui.obj.Set(
    private.this.obj,
    {
      pos_x = map_pos.x,
      pos_y = map_pos.y,
      pos_z = 1010
    }
  );
  
  local str_title = "str_int_splash_map_overtaken";
  
  ui.obj.Set(
    private.this.anm,
    {
      playing  = false,
      frame    = 0,
      animfunc = "static",
      tt_title = StringGet( str_title, player_name, stage_title )
    }
  );
  
  
  if ( not private.active ) then
  
    ui.obj.Attach( private.this.obj, map_obj );
  
  end;
  
  private.active = true;
  
  ui.anim.Play( private.this.anm, "static", public.Hide );
  
  if ( func_after ) then func_after(); end;
  
end;
--------------------------------------------------------------------------------
function public.Hide ()

  if ( private.active ) then
  
    ui.obj.Detach( private.this.obj );
    private.active = false;
  
  end;

end;
--------------------------------------------------------------------------------