-- name=int_subtitles
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Skip     = function () end,
  Continue = function () end
};
  
local _this = {};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  _this = {
    int       = "int_subtitles",
    obj       = "obj_int_subtitles",
    skip      = "obj_int_subtitles_skip",
    timer     = "tmr_int_subtitles",
    text_obj  = "obj_int_subtitles_text",
    text_subs = "txt_int_subtitles",
    text_skip = "txt_int_subtitles_skip",
    panel     = {
      top    = "grd_int_subtitles_bg_top",
      bottom = "grd_int_subtitles_bg_bot"
    },
    anm_time  = 0.3
  };
  
  ui.hub.Create( _this.int );

  private.Adapt();

  ui.control.EventsSet(
    _this.skip, 
    {
      func_on_click = function ()

        private.Skip_AnimateClose(
          function () 

            _f.Skip(
              function ()
               
                private.Skip_AnimateOpen(
                  function()
                    
                    _f.Continue();
                    
                  end
                );
                
              end
            );

          end
        );

      end
    }
  );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Prepare ()

  --JK: try trigger __InitObjects
  ui.obj.Show( "int_subtitles" );
  
  ui.hub.AttachContent( _this.int );
  ObjSet( _this.obj, { alp = 1.0 } );

end;
--------------------------------------------------------------------------------
function public.Show ( subtitles_name, time_table )

  if ( _this.is_active ) then return; end;
  
  _this.is_active = true;
  
  private.current   = 1;
  private.time      = time_table;
  private.subtitles = subtitles_name;
  
  ui.obj.Set(
    _this.skip,
    {
      active  = true,
      visible = true,
      alp     = 0
    }
  );
  
  ui.anim.FadeIn(
    0.3, _this.skip, false,
    function () ui.input.On( _this.skip ); end
  );
  
  common.Defer( "int_subtitles_show", _this.anm_time, private.Timer );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.Adapt ()

  local app_w = ui.screen.Width();
  local app_h = ui.screen.Height();

  ui.obj.Set( _this.text_skip, { text = "str_subtitle_skip" } );

  ui.obj.Multiset( {
    { _this.int,          { pos_x = 0.5 * app_w, pos_y = 0.5 * app_h } },
    { _this.panel.top,    { pos_y = - 0.5 * app_h + 80 } },
    { _this.panel.bottom, { pos_y =   0.5 * app_h - 80 } },
    { _this.text_obj,     { pos_y =   0.5 * app_h - 50 } },
    { _this.skip,         { pos_y = - 0.5 * app_h + 50, pos_x = 0.5 * app_w - 90 } },
  } );

  _this.frame_0 = {
     0, { pos_x = - ( 0.5 * app_w + 22 ) },
     1, { pos_x = - ( 0.5 * app_w +  0 ) },
     2, { pos_x =   ( 0.5 * app_w + 22 ) },
     3, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     4, { pos_x = - ( 0.5 * app_w + 22 ) },
     5, { pos_x = - ( 0.5 * app_w +  0 ) },
     6, { pos_x =   ( 0.5 * app_w + 22 ) },
     7, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     8, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 0 },
     9, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 0 },
    10, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 0 },
    11, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 0 },

    12, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 22 },
    13, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 22 },
    14, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 22 },
    15, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 22 }
  };
  
  _this.frame_1 = {
     0, { pos_x = - ( 0.5 * app_w + 22 ) },
     1, { pos_x = - ( 0.5 * app_w +  0 ) },
     2, { pos_x =   ( 0.5 * app_w + 22 ) },
     3, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     4, { pos_x = - ( 0.5 * app_w + 22 ) },
     5, { pos_x = - ( 0.5 * app_w +  0 ) },
     6, { pos_x =   ( 0.5 * app_w + 22 ) },
     7, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     8, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h },
     9, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h },
    10, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h },
    11, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h },

    12, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h + 22 },
    13, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h + 22 },
    14, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h + 22 },
    15, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h + 22 }
  };  
  
  GridSet( _this.panel.top,    0, _this.frame_0 );
  GridSet( _this.panel.bottom, 0, _this.frame_0 );

  GridSet( _this.panel.top,    1, _this.frame_1 );
  GridSet( _this.panel.bottom, 1, _this.frame_1 );

  ui.obj.Multiset( {
    { _this.panel.top,    { frame = 0 } },
    { _this.panel.bottom, { frame = 0 } },
    { _this.text_obj,     { alp   = 0 } },
    { _this.text_subs,    { maxwidth = math.ceil( 0.85 * app_w ) } }
  } );

end;
--------------------------------------------------------------------------------
function private.Hide ( func_close )
  
  if ( not _this.is_active ) then return end;
  
  _this.is_active = false;

  ObjAnimate(
    _this.obj, "alp", 0, 0,
    function ()
      
      ui.hub.DetachContent( _this.int );
      if ( func_close ) then func_close(); end;
      
    end, 
    { 
      0.0,            0, 1.0, 
      _this.anm_time, 0, 0.0 
    }
  );

end;
--------------------------------------------------------------------------------
function private.Subtitle_ShowNext ()

  local func_end = function ()
  
    ObjAnimate( _this.text_obj, "alp", 0, 0, function ()

      if ( private.current == #private.time + 1 ) then

        private.Hide();

      end;

    end, 
    { 
      0.0,            0, 1.0, 
      _this.anm_time, 0, 0.0 
    } );

  end;

  ui.obj.Set(
    _this.text_subs,
    {
      text = "str_subtitle_"..private.subtitles.."_"..private.current
    }
  );
  
  ui.text.FontsizeByHeight( _this.text_subs, 80, 26 );

  ObjAnimate( _this.text_obj, "alp", 0, 0, func_end, 
  { 
    0.0,                  0, 0.0, 
    _this.anm_time,       0, 1.0,
    _this.anm_time + 2.5, 0, 1.0 
  } );

  private.current = private.current + 1;

  private.Timer();

end;
--------------------------------------------------------------------------------
function private.Timer ()

  if ( private.current < #private.time + 1 ) then
  
    local time =
      ( private.time[ private.current ] -
      ( private.time[ private.current - 1 ] or 0 ) );

    common.Timer_Start( _this.timer, time, private.Subtitle_ShowNext );

  end;

end;
--------------------------------------------------------------------------------
function private.Skip_AnimateClose ( func_skip )

  GridSet( _this.panel.top,    0, _this.frame_0 );
  GridSet( _this.panel.bottom, 0, _this.frame_0 );

  GridSet( _this.panel.top,    1, _this.frame_1 );
  GridSet( _this.panel.bottom, 1, _this.frame_1 );

  local zero_frame = { frame = 0 };
  
  ui.obj.Set( _this.panel.top,    zero_frame );
  ui.obj.Set( _this.panel.bottom, zero_frame );
  
  GridPlay(
    _this.panel.top,
    function () if ( func_skip ) then func_skip(); end; end
  );
  
  GridPlay( _this.panel.bottom, "" );
  
  local multiset = {};
  
  common.Timer_Stop( _this.timer, multiset );
  ui.obj.Disable( _this.skip, false, multiset );
  
  ui.obj.Multiset( multiset );

  ObjAnimate(
    _this.text_obj, "alp", 0, 0, "", 
    { 
      0.0,            0, ui.obj.Get( _this.text_obj ).alp, 
      _this.anm_time, 0, 0.0
    }
  );

end;
--------------------------------------------------------------------------------
function private.Skip_AnimateOpen ( func_end )


  GridSet( _this.panel.top,    0, _this.frame_1 );
  GridSet( _this.panel.bottom, 0, _this.frame_1 );

  GridSet( _this.panel.top,    1, _this.frame_0 );
  GridSet( _this.panel.bottom, 1, _this.frame_0 );

  local zero_frame = { frame = 0 };
  
  ui.obj.Set( _this.panel.top,    zero_frame );
  ui.obj.Set( _this.panel.bottom, zero_frame );
  
  GridPlay(
    _this.panel.top,
    function () private.Hide( func_end ); end
  );
  
  GridPlay( _this.panel.bottom, "" );

end;
--------------------------------------------------------------------------------