-- name=m_match3
--------------------------------------------------------------------------------
function public.__InitModule ()

  --Log.i( "Initialized." );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.StartData_Set ( data )
  private.data = data;
  private.data.section = private.data.section or "section_1";
end;
--------------------------------------------------------------------------------
function public.StartData_Get ()

  local data = {};
  data.field        = private.data.field;
  data.stage        = private.data.name;
  data.type         = private.data.type;
  data.state        = private.data.state;
  data.preset       = false;
  data.boosters     = private.data.boosters;
  data.attempts     = private.data.attempts;
  data.max_attempts = private.data.max_attempts;
  
  if ( not data.stage:match( "daily" ) ) then
    data.section = tonumber( private.data.section:match( "%d+" ) );
  end;
  
  if ( private.data.realtype == "minievent" ) then
    data.section = private.data.pet_id or data.section;
  end;

  if ( private.data.chips ) then
    data.preset = true;
  end;

  return data;

end;
--------------------------------------------------------------------------------
function private.ParseCellString ( string )

  local types = 
  {
    [ "F" ] = "Free",
    [ "H" ] = "Hole",
    [ "D" ] = "Dirt",
    [ "C" ] = "Cage",
    [ "R" ] = "Rock",
    [ "M" ] = "Mana",
    [ "0" ] = "Null"
  };

  local cell = {};

  local part_1 = string.sub( string, 1, 2 );
  local part_2 = string.sub( string, 3, 4 );

  local parsed_table  = 
  { 
    { type = types[ string.sub( part_1, 1, 1 ) ], level = tonumber( string.sub( part_1, 2, 2 ) ) }, 
    { type = types[ string.sub( part_2, 1, 1 ) ], level = tonumber( string.sub( part_2, 2, 2 ) ) }
  };

  for i = 1, #parsed_table do

    if not ( "Null" == parsed_table[ i ].type ) then

      if ( parsed_table[ i ].level == 0 ) then

        table.insert( cell, parsed_table[ i ].type );

      end;

      for j = 1, parsed_table[ i ].level do

        table.insert( cell, parsed_table[ i ].type );

      end;

    end;

  end;

  if not ( "Free" == cell[ #cell ] ) and not ( "Hole" == cell[ #cell ] ) then

    table.insert( cell, "Free" );
  
  end;

  return cell;

end;
--------------------------------------------------------------------------------