-- name=m_tutorial
--------------------------------------------------------------------------------
function public.__InitModule ()
  
  private.completed = {};
  
  local query =
  {
    query      = "find_all",
    group      = "player",
    collection = "tutorial"
  };

  private.completed = lib_db.Execute( query ).result;
  private.enable    = true; 
  
  if ( IsEditor() and debug ) then
    if (tostring(ConfigGetInfo( "tutorial_enable" )) == "0") then
      private.enable = false;
    end;
  end;
  
  --Log.i( "Initialized." );
  
end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Complete ( tutorial_name )

  if ( public.IsCompleted( tutorial_name ) ) then

    return;

  end;

  local query =
  {
    query      = "insert",
    group      = "player",
    collection = "tutorial",
    value      = 
    {
      name = tutorial_name
    }
  };

  lib_db.Execute( query );
  
  table.insert( private.completed, { name = tutorial_name } );

end;
--------------------------------------------------------------------------------
function public.IsEnabled ()
  
  return private.enable;

end;
--------------------------------------------------------------------------------
function public.IsCompleted ( tutorial_name )

  if ( common.IsEntityInList( private.completed, { name = tutorial_name }, "name" ) ) then
    
    return true;
    
  end;
  
  return false;

end;
--------------------------------------------------------------------------------
function public.GetCompletedList ()
  
  return private.completed;

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Entity_IsAdded ( tutorial_name, entity_name )

  local query = 
  {
    query      = "find",
    group      = "player",
    collection = "tutorial",
    indice     = "name",
    criteria   = {
      like = tutorial_name.."_"..entity_name
    }
  };

  return lib_db.Execute( query ).result ~= nil;

end;
--------------------------------------------------------------------------------
function public.Entity_Type ( entity_name )

  local query = 
  {
    query      = "find",
    group      = "static",
    collection = "boosters",
    indice     = "name",
    criteria   = {
      like = entity_name
    }
  }

  return lib_db.Execute( query ).result.type;

end;
--------------------------------------------------------------------------------