-- name=test
--------------------------------------------------------------------------------
function public.__InitObjects ()

  ObjSet( "obj_test_stage", { event_mdown = function () 

    public.Start();

  end } );

  ObjAttach( "obj_test_stage", "ng_interface" );

  ObjSet( "obj_test_stage",
  {
    pos_x = GetAppWidth() - 50,
    pos_y = 0.5 * GetAppHeight()
  } );

  rooms.SetRoom( "scr_test",
  {
    trg_preopen  = private.PreOpen,
    trg_open     = private.Open,
    trg_preclose = private.PreClose,
    trg_close    = private.Close
  } );

  ui.control.TapSet( "btn_test",
  {
    func_true = function ()

      for row = 1, 8 do

        for col = 1, 8 do

          local effect_name = "anm_test_effect_"..row.."_"..col;

          ObjDelete( effect_name );

        end;

      end;

      --ObjDelete( "anm_test_effect_big" );

      rooms.SwitchRoom( "scr_map" ); 

    end
  } );

  ObjAttach( "scr_test", "ne_storage" );

end;
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  rooms.SwitchRoom( "scr_test" );

end;
--------------------------------------------------------------------------------
function private.PreOpen ()

  --

end;
--------------------------------------------------------------------------------
function private.Open ()

  ObjSet( "obj_test_stage",
  {
    input = false
  } );

  private.TestAnim_Create();

  private.TestAnim_Play();

end;
--------------------------------------------------------------------------------
function private.PreClose ()

  --

end;
--------------------------------------------------------------------------------
function private.Close ()

  ObjSet( "obj_test_stage",
  {
    input = true
  } );

end;
--------------------------------------------------------------------------------
function private.TestAnim_Create ()

  for row = 1, 8 do

    for col = 1, 8 do

      local effect_name = "anm_test_effect_"..row.."_"..col;

      ObjCreate( effect_name, "anim" );
      ObjAttach( effect_name, "scr_test" );

      ObjSet( effect_name, 
      { 
        pos_x = - 14 + 75 * col, 
        pos_y =  150 + 75 * row, 
        res = "assets/content/match3/fx/anm_test_fx",
        playing = false 
      } );

    end;

  end;

  --[[local big_effect_name = "anm_test_effect_big";

  ObjCreate( big_effect_name, "anim" );
  ObjAttach( big_effect_name, "scr_test" );

  ObjSet( big_effect_name, 
  { 
    pos_x = - 14 + 75 * 4 + 38, 
    pos_y =  150 + 75 * 4 + 38,
    scale_x = 4,
    scale_y = 4,
    res = "assets/content/match3/fx/anm_match3",
    playing = false 
  } );]]

end;
--------------------------------------------------------------------------------
function private.TestAnim_Play ()

  --local anims = { "destroy_mana", "destroy_rock", "destroy_cage", "destroy_basic" };

  for row = 1, 8 do

    for col = 1, 8 do

      local effect_name = "anm_test_effect_"..row.."_"..col;

      AnimPlay( effect_name, "test_fx_"..math.random( 1, 6 )--[[anims[ math.random( 1, 4 ) ] ]], "" );

    end;

  end;

  --[[local big_effect_name = "anm_test_effect_big";

  AnimPlay( big_effect_name, anims[ math.random( 1, 4 ) ], "" );]]

  ObjSet( "tmr_test", { time = 1.0, playing = true, endtrig = private.TestAnim_Play } );

end;
--------------------------------------------------------------------------------