-- name=v_dailybonus
--------------------------------------------------------------------------------
-- function Modules ()
--------------------------------------------------------------------------------
local _modules = {
  "m_dailybonus",
  "int_dialog_dailybonus"
};
--------------------------------------------------------------------------------
function public.__GetDependencies ()

  return _modules;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()
  
  common.mod.Load( _modules );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.Dialog_TryShow ( func_close )

  if ( not m_dailybonus.IsReady() ) then return; end;

  private.Finish();

  local current_day    = m_dailybonus.Day_GetCurrent();
  local current_limits = m_dailybonus.Day_GetPeriodLimits( current_day );

  private.rewards = {};

  --JK: get rewards for current period from settings
  for day = current_limits[ 1 ], current_limits[ 2 ] do

    local reward = m_dailybonus.Settings( "rewards" )[ day ];

    table.insert( private.rewards, reward );

  end;

  current_day = m_dailybonus.Day_ToRelative( current_day );

  ------------------------------------------------------------------------------
  local func_claim = function ( day )
    
    -- JK: continue map update on reward chest closed
    private.Claim( day, func_close );

  end;
  ------------------------------------------------------------------------------
  local func_toppanel_show = function ()

    v_interface.panel.top.Show( true, "gold" );

  end;
  ------------------------------------------------------------------------------
  local func_dialog_hide = function ()
    
    local func_end;
    
    -- JK: continue map update on dialog closed if reward is not a chest
    if ( private.rewards[ current_day ].type ~= "chest" ) then
      func_end = function ()
        if ( v_screen.GetCurrentName() == "scr_map" ) then
          v_interface.panel.top.Highlight( nil );
        end;
        v_interface.panel.top.Hide( true );
        if ( func_close ) then
          func_close();
        end;
      end;
    end;
    
    private.Dialog_Hide( func_end );

  end;
  ------------------------------------------------------------------------------
  local func_show = function ()

    int_dialog_dailybonus.Show(
      current_day,
      private.rewards,
      func_claim,
      func_toppanel_show,
      func_dialog_hide,
      v_player.Skin_GetCurrent()
    );

  end;
  ------------------------------------------------------------------------------

  v_interface.window.AddToQueue( "int_dialog_dailybonus", func_show );
  
end;
--------------------------------------------------------------------------------
function public.Refresh ()
  
  m_dailybonus.Refresh();
  
end;
--------------------------------------------------------------------------------
function public.IsReady ()
  
  local is_ready = m_dailybonus.IsReady();
  
  return is_ready;
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function private.Dialog_Hide ( func_end )

  int_dialog_dailybonus.Hide(
    function ()

      v_interface.window.Hide( "int_dialog_dailybonus", func_end );

    end
  );

end;
--------------------------------------------------------------------------------
function private.Finish ()

  m_dailybonus.Finish();

end;
--------------------------------------------------------------------------------
function private.Claim ( day, func_close )

  local func_end = function ()
    if ( v_screen.GetCurrentName() == "scr_map" ) then
      v_interface.panel.top.Highlight( nil );
    end;
    v_interface.panel.top.Hide( true );
    if ( func_close ) then
      func_close();
    end;
  end;
  
  if ( private.rewards[ day ].type == "chest" ) then

    v_items.Chest_Show(
      private.rewards[ day ],
      {
        category   = "dailybonus",
        stage_name = private.rewards[ day ].name,
        silent     = true
      },
      nil,
      func_end,
      nil,
      ( func_close ~= nil )
    );

    return;

  end;

  private.Obtain( private.rewards[ day ], day, false );

end;
--------------------------------------------------------------------------------
function private.Obtain ( reward, day, silent )

  v_items.TryObtain({
    name       = reward.name,
    type       = reward.type,
    count      = reward.count,
    category   = "dailybonus",
    stage_name = "day_"..day,
    silent     = silent
  });

end;
--------------------------------------------------------------------------------