-- name=v_potions
--------------------------------------------------------------------------------
-- function Modules ()
--------------------------------------------------------------------------------
local _modules = {
  "m_potions"
};
--------------------------------------------------------------------------------
function public.__GetDependencies ()
  
  return _modules;
  
end;
--------------------------------------------------------------------------------
function public.__InitModule ()
  
  common.mod.Load( _modules );
  
end;
--------------------------------------------------------------------------------
function public.Init ()
  
  --Log.i( "Initialized." );
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.GetStatsBonusPotions ()
  
  local potions = public.GetPotionsData();
  local stats = {};
  
  for i = 1, #potions do
    if ( public.IsPotionActive( potions[ i ].name ) ) then
      for key, value in pairs( potions[ i ].bonus ) do
        stats[ key ] = ( stats[ key ] or 0 ) + value;
      end;
    end;
  end;
  
  return stats;
  
end;
--------------------------------------------------------------------------------
function public.GetPotionsData ( potion_name )
  
  local  potions = m_potions.GetFullData( potion_name );
  return potions;
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.TryObtain ( potion )
  
  public.AddPotion(
    potion.name,
    potion.count,
   ( potion.source or potion.category )
  );
  
  return true;
  
end;
--------------------------------------------------------------------------------
function public.AddPotion ( potion_name, count, source )
  
  m_potions.AddPotion( potion_name, count );
  
  v_log.Kontagent_LogEvent( "economy", 
  {
    description = "item_collected",
    category    = "potions",
    value       = count,
    name        = potion_name,
    source      = source or "reward"
  } );
  
end;
--------------------------------------------------------------------------------
function public.UsePotion ( potion_name )
  
  local data_potion = public.GetPotionsData( potion_name );
  
  if ( data_potion.count > 0 ) then
    
    m_potions.ActivatePotion( potion_name );
    
    v_log.Kontagent_LogEvent( "economy", 
    {
      description = "item_used",
      category    = "potions",
      value       = 1,
      name        = potion_name
    } );
    
    v_game.GameLog_Add( "potion_use", { name = potion_name } );
    
  end;
  
end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.GetRemainingTime ( potion_name )
  
  local  time = m_potions.GetRemainingTime( potion_name );
  return time;
  
end;
--------------------------------------------------------------------------------
function public.IsPotionActive ( potion_name )
  
  local  state = m_potions.IsPotionActive( potion_name );
  return state;
  
end;
--------------------------------------------------------------------------------
function public.Potions_GetActiveList ()
  
  local  potions_list = m_potions.Potions_GetActiveList();
  return potions_list; 
  
end;
--------------------------------------------------------------------------------