-- name=v_story
--------------------------------------------------------------------------------
local _modules = {
  "m_story",
  "int_dialog_story"
};
--------------------------------------------------------------------------------
function public.__GetDependencies ()

  return _modules;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  common.mod.Load( _modules );
  
  v_interface.window.RegisterAsFullscreen( "int_dialog_story" );

end;
--------------------------------------------------------------------------------
--function ... ()
--------------------------------------------------------------------------------
function public.IsExistStory( section_name, cond_type, cond_name )
  
  if not ( section_name ) then 
    return false;
  end;
  local story_data = m_story.GetData( section_name, cond_type, cond_name );
  if ( story_data ) then
    return true;
  end;
  return false;
  
end;
--------------------------------------------------------------------------------
function public.ShowStory( 
  section_name, 
  cond_type, 
  cond_name, 
  point, 
  func_after 
  )
  
  local story_data = m_story.GetData( section_name, cond_type, cond_name );
  
  local delegates = {
    Close = function ()
      
      local function func_anim_end ( func_after_end )
        int_dialog_story.Hide(
          function ()
            v_interface.window.Hide( "int_dialog_story" );
            if ( func_after_end ) then func_after_end(); end;
          end,
          true
        );
      end;
      
      if ( point == "stage" ) then 
        mediator.SubscribeOnce( "View_Interface_LoadingSplashIsShown", func_anim_end );
        if ( func_after ) then func_after(); end;
      else
        func_anim_end( func_after );
      end;
      
    end
  };
  common.delegate.Set( "int_dialog_story", delegates );
  v_interface.panel.top.Hide( true );
  v_interface.window.Show(
    "int_dialog_story",
    function ()
      int_dialog_story.Show( story_data );
    end
  );
  
end;
--------------------------------------------------------------------------------