-- name=int_tutorial_dailyquest_countdown
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Subscribe             = function () end,
  Unsubscribe           = function () end,
  Complete              = function () end,
  LogKontagentEvent     = function () end,
  GetDialogSettings     = function () end,
  ShowDialogInstantly   = function () end,
  HideDialog            = function () end,
  StartPending          = function () end,
  FinishPending         = function () end,
  Unload                = function () end,
  IsDailyquestSuspended = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ()

  private.dailyquest_countdown_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.dailyquest_countdown_first ()

  private.dailyquest_countdown_next1();

end;
--------------------------------------------------------------------------------
function private.dailyquest_countdown_next1 ()

  if ( _f.IsDailyquestSuspended() ) then
    _f.Complete();
    return;
  end;
  
  _f.Subscribe(
    "dailyquest_countdown",
    "View_Map_Update_Finished",
    private.dailyquest_countdown_next2
  );

end;
--------------------------------------------------------------------------------
function private.dailyquest_countdown_next2 ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_arena_countdown" } );

  _f.Unsubscribe(
    "dailyquest_countdown",
    "View_Map_Update_Finished",
    private.dailyquest_countdown_next2
  );
  
  _f.StartPending( "dailyquest_countdown", "map" );

  local focus_obj = "btn_int_panel_interface_left_dailyquest";
  local dialog_settings = _f.GetDialogSettings( focus_obj, 55 );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "arrow",
    focus    = focus_obj,    
    offset_x = 50,
    offset_y = 0,
    angle    = -1.57,
    scale    = 1.0,
    lock     = false,
    black    = false
  };

  local func_close = function ()

    _f.HideDialog( private.dailyquest_countdown_last1, true );

  end;

  _f.ShowDialogInstantly(
    "dailyquest_countdown_1",
    positions,
    hole,
    func_close,
    nil,
    {
      active = true,
      input  = false,
      notify = false
    }
  );

  mediator.Subscribe( 
    "View_Dailyquest_FeatureUpdate", 
    private.dailyquest_countdown_hide1 
  );
  
end;
--------------------------------------------------------------------------------
function private.dailyquest_countdown_hide1 ( data )
  
  if ( not data.active ) then
  
    _f.HideDialog( private.dailyquest_countdown_last1, true );
    
  end;
  
end;
--------------------------------------------------------------------------------
function private.dailyquest_countdown_last1 ()

  mediator.Unsubscribe( 
    "View_Dailyquest_FeatureUpdate", 
    private.dailyquest_countdown_hide1 
  );

  _f.Complete();
  _f.FinishPending( "dailyquest_countdown", "map" );
  _f.Unload();

end;
--------------------------------------------------------------------------------