-- name=int_tutorial_downright
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
  AddEntity           = function () end,
  GetDownrightIndex   = function () end,
  ShowEntity          = function () end,
  HideEntity          = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_data )

  private.downright_first( stage_data );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.downright_first ( stage_data )

  local index     = _f.GetDownrightIndex( stage_data );
  local focus_obj = "btn_int_dialog_stage_start_boosters_"..index;

  _f.Unsubscribe(
    "downright",
    "View_Stage_DialogStartActivated",
    private.downright_first
  );

  _f.AddEntity(  "downright", "downright", "booster" );
  _f.ShowEntity( "downright", "downright", focus_obj );

  private.downright_next1( focus_obj );

end;
--------------------------------------------------------------------------------
function private.downright_next1 ( focus_obj )

  local dialog_settings = _f.GetDialogSettings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type     = "arrow",
    focus    = focus_obj,
    offset_x = 0,
    offset_y = - 50,
    angle    = 0,
    scale    = 1,
    lock     = false
  };

  local func_close = function ()
    
    _f.HideEntity( focus_obj );
    _f.HideDialog( _f.Unload );

  end;

  _f.ShowDialogInstantly( "downright", positions, hole, func_close );

  private.downright_last1();

end;
--------------------------------------------------------------------------------
function private.downright_last1 ()

  _f.Complete();

end;
--------------------------------------------------------------------------------