-- name=int_tutorial_market
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Subscribe             = function () end,
  Unsubscribe           = function () end,
  Complete              = function () end,
  LogKontagentEvent     = function () end,
  ShowDialogInstantly   = function () end,
  HideDialog            = function () end,
  Unload                = function () end,
  IsSellMarketDisabled  = function () end
};
local _this = {};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( name )

  private.market_first( name );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.market_first ( name )
  
  if ( name ~= "market" ) then

    _f.Subscribe(
      "market",
      "View_Shop_TabOpened",
      private.market_first
    );

    _this.is_subscribed = true;

    return;

  end;  

  if ( _this.is_subscribed ) then

    _f.Unsubscribe(
      "market",
      "View_Shop_TabOpened",
      private.market_first
    );

    _this.is_subscribed = nil;

  end;

  common.Defer( "tutorial_market_delay", 0.3, private.market_next1 );

end;
--------------------------------------------------------------------------------
function private.market_next1 ()

  if ( not _f.IsSellMarketDisabled() ) then
  
    local positions = 
    {
      dlg_start   = 1200,
      dlg_pos_y   = ui.screen.Height() / 2 + 200
    };
    
    local hole =
    { 
      {
        type     = "arrow",
        focus    = "btn_int_dialog_shop_sell_slot_sell_1",
        offset_y = 20,
        angle    = math.rad( -155 ),
        scale    = 0.8,
        lock     = true
      },
      {
        type     = "arrow",
        focus    = "btn_int_dialog_shop_sell_slot_sell_2",
        offset_y = 20,
        angle    = math.rad( -155 ),
        scale    = 0.8,
        lock     = true
      },
      {
        type     = "arrow",
        focus    = "btn_int_dialog_shop_sell_slot_sell_3",
        offset_y = 20,
        angle    = math.rad( -155 ),
        scale    = 0.8,
        lock     = true
      }
    };

    local func_close = function () _f.HideDialog( private.market_next2 ); end;

    _f.ShowDialogInstantly( "market_1", positions, hole, func_close );
    
  else
    private.market_next2();
  end;

end;
--------------------------------------------------------------------------------
function private.market_next2 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = ui.screen.Height() / 2 - 200
  };
  
  local offset_x =   40;
  local offset_y = - 40;
  
  local hole =
  { 
    {
      type     = "arrow",
      focus    = "obj_int_dialog_shop_market_buy_slot_1",
      offset_x = offset_x,
      offset_y = offset_y,
      angle    = math.rad( -45 ),
      scale    = 0.8,
      lock     = true
    },
    {
      type     = "arrow",
      focus    = "obj_int_dialog_shop_market_buy_slot_2",
      offset_x = offset_x,
      offset_y = offset_y,
      angle    = math.rad( -45 ),
      scale    = 0.8,
      lock     = true
    },
    {
      type     = "arrow",
      focus    = "obj_int_dialog_shop_market_buy_slot_3",
      offset_x = offset_x,
      offset_y = offset_y,
      angle    = math.rad( -45 ),
      scale    = 0.8,
      lock     = true
    },
    {
      type     = "arrow",
      focus    = "btn_int_dialog_shop_market_buy_accept",
      offset_x = 120,
      offset_y = 0,
      angle    = math.rad( -90 ),
      scale    = 0.8,
      lock     = true
    }
  };

  local func_close = function () _f.HideDialog( private.market_last1 ); end;

  _f.ShowDialogInstantly( "market_2", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
--function private.market_next3 ()
--
--  local positions = 
--  {
--    dlg_start   = 1200,
--    dlg_pos_y   = ui.screen.Height() - 300
--  };
--  
--  local hole =
--  {
--    type     = "arrow",
--
--    focus    = "btn_int_dialog_shop_close",
--    offset_x = 0,
--    offset_y = 0,
--    angle    = 1.75 * math.pi,
--    scale    = 1.0,
--
--    lock     = true
--  };
--
--  local func_close = function ()
--
--    _f.HideDialog( private.market_last1 );
--
--  end;
--
--  _f.ShowDialogInstantly( "market_3", positions, hole, func_close );
--
--end;
--------------------------------------------------------------------------------
function private.market_last1 ()

  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------