-- name=int_tutorial_paint
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell        = function () end,
  Subscribe            = function () end,
  Unsubscribe          = function () end,
  Complete             = function () end,
  LogKontagentEvent    = function () end,
  GetDialogSettings    = function () end,
  ShowDialogInstantly  = function () end,
  HideDialog           = function () end,
  Unload               = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.paint_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.paint_first ()

  _f.Subscribe(
    "paint",
    "View_Stage_DialogTargetsHided",
    private.paint_highlight
  );

end;
--------------------------------------------------------------------------------
function private.paint_highlight ()

  _f.Unsubscribe(
    "paint",
    "View_Stage_DialogTargetsHided",
    private.paint_highlight
  );
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_paint" } );
  
  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4.5;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 11,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = cell.scale,
    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    _f.HideDialog( private.paint_show_match );

  end;

  _f.ShowDialogInstantly( "paint_1", positions, hole, func_close );
  
end;
--------------------------------------------------------------------------------
function private.paint_show_match ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_paintdone" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 6;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 1,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = - 0.5 * math.pi,
    scale  = cell.scale,
    lock   = true,
    hand   = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "move"
    }
  };

  local function func_close ()

    _f.Unsubscribe(
      "paint",
      "Model_Match3_FieldActivated", 
      func_close
    );

    _f.HideDialog( private.paint_highlight_result );

  end;

  _f.LogKontagentEvent( "tutorial", { name = "tut_paint_match" } );  
  _f.Subscribe( "paint", "Model_Match3_FieldActivated", func_close );
  _f.ShowDialogInstantly( "paint_2", positions, hole );

end;
--------------------------------------------------------------------------------
function private.paint_highlight_result ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_paint_matchdone" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5.5;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 11,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = cell.scale,
    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    _f.HideDialog( private.paint_complete );

  end;
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_paint_color" } );
  _f.ShowDialogInstantly( "paint_3", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.paint_complete ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_paint_colordone" } );
  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------