-- name=int_tutorial_questlist
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  StartPending        = function () end,
  FinishPending       = function () end,
  Unload              = function () end,
  GetButtonName       = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ()

  private.questlist_first()

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.questlist_first ()

  _f.StartPending( "questlist", "map" );

  private.questlist_next1();

end;
--------------------------------------------------------------------------------
function private.questlist_next1 ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_questlist" } );

  local func_close = function ( execute_tap )

    _f.HideDialog( private.questlist_last1 );

  end;
  
  local btn_name        = _f.GetButtonName();
  local dialog_settings = _f.GetDialogSettings( btn_name, 50 );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type     = "arrow",
    focus    = btn_name,
    offset_x = - 50,
    offset_y = 0,
    angle    = 1.575707,
    scale    = 1.0,
    lock     = false
  };

  _f.ShowDialogInstantly(
    "questlist", 
    positions,
    hole,
    func_close,
    nil,
    {
      active = true,
      input  = false,
      notify = false
    }
  );

end;
--------------------------------------------------------------------------------
function private.questlist_last1 ()

  _f.Complete();
  _f.FinishPending( "questlist", "map" );
  _f.Unload();

end;
--------------------------------------------------------------------------------