-- name=int_tutorial_questlist_quest
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
  GetScrollerName     = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( quests_list )

  private.questlist_quest_first( quests_list )

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.questlist_quest_first ( quests_list )
  
  local scc_obj = _f.GetScrollerName();
  local childs  = ne.obj.GetRelations( scc_obj ).childs;
  
  if ( #quests_list == 1 ) then
    private.questlist_quest_next1( childs[ 1 ] );
    return;
  end;
  
  private.questlist_quest_next1( childs[ 2 ] );

end;
--------------------------------------------------------------------------------
function private.questlist_quest_next1 ( cell_obj )
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_questlist_quest" } );

  local cell_anm = cell_obj:gsub( "obj", "anm" );
  local func_tap = ui.control.EventsGet( cell_anm ).func_on_click;
  
  local func_close = function ( execute_tap )
  
    ui.control.EventsSet( cell_anm, { func_on_click = func_tap } );
    _f.HideDialog( private.questlist_quest_last1 );

    ui.obj.Set(
      "scc_int_panel_questlist",
      { dragenabled = true }
    );
    
    func_tap();

  end;
  
  ui.control.EventsSet( cell_anm, { func_on_click = func_close } );

  local dialog_settings = _f.GetDialogSettings( cell_anm );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type     = "flashlight",
    focus    = cell_anm,
    res_id   = 14,
    offset_x = -155,
    offset_y = -2,
    angle    = 0,
    scale_x  = 1,
    scale_y  = 1,
    lock     = true,
    black    = true,
    wait     = true,
    hand     = {  
      offset_x = 0,
      offset_y = 0,
      scale_x  = -1,
      angle    = 0, 
      type     = "click"
    }    
  };
     
  ui.obj.Set(
    "scc_int_panel_questlist",
    { dragenabled = false }
  );

  _f.ShowDialogInstantly( "questlist_quest_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.questlist_quest_last1 ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_questlist_questdone" } );
  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------