-- name=int_tutorial_replay
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Backup              = function () end,
  Restore             = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  ShowDialogFromQueue = function () end,
  HideDialog          = function () end,
  StartPending        = function () end,
  FinishPending       = function () end,
  GetStageState       = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_1_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.replay_first ()
      
  if ( _f.GetStageState() < 3 ) then

    common.Defer( "tutorial_replay_delay", 0.5, private.replay_next1 );

  end;

end;
--------------------------------------------------------------------------------
function private.replay_next1 ()

  local func_close = function ( execute_tap )

    local func_stage_tap = _f.Restore( "replay", "stage_tap" );

    ui.control.TapSet( "btn_map_point_stage_5", { func_true = func_stage_tap } );

    _f.HideDialog( private.replay_next2 );

    if ( execute_tap ) then

      func_stage_tap();

    end;

  end;

  _f.Backup( "replay", "stage_tap", ui.control.TapGet( "btn_map_point_stage_5" ).func_true );

  ui.control.TapSet( "btn_map_point_stage_5", { func_true = function () func_close( true ); end } );

  local positions = 
  {
    dlg_start = 1200,
    dlg_pos_y = 0.5 * ui.screen.Height() + 100
  };

  local hole = 
  {
    type       = "flashlight",
    res_id     = 3,
    focus      = "obj_map_point_stage_5",
    scale      = 0.8,  
    lock       = true,
    black      = false,
    hand       = {
      angle    = 0,
      offset_x = 0,
      offset_y = 0,
      type     = "click"
    }
  };

  _f.ShowDialogFromQueue( "replay_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.replay_next2 ()

  local positions = 
  {
    dlg_start = 1200,
    dlg_pos_y = 0.5 * ui.screen.Height() + 100
  };

  local hole = 
  {
    type     = "arrow",
    focus    = "obj_int_dialog_stage_start_states_3",
    scale    = 1.0,
    offset_x = - 50,
    offset_y = 0,
    angle    = 1.575707,  
    lock     = true
  };

  local func_close = function () _f.Dialog_Hide( private.replay_next3 ); end;
  _f.ShowDialogInstantly( "replay_2", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.replay_next3 ()

  local positions = 
  {
    dlg_start = 1200,
    dlg_pos_y = 400
  };

  local hole = 
  {
    type       = "flashlight",
    res_id     = 4,
    focus      = "btn_int_dialog_stage_start_play",
    scale      = 1.5,  
    lock       = true,
    black      = false,
    hand       = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "click"
    }
  };

  local func_close = function () _f.HideDialog( private.replay_last1 ); end;

  local func_tap =
    ui.control.TapGet( "btn_int_dialog_stage_start_play" ).func_true;

  ui.control.TapSet(
    "btn_int_dialog_stage_start_play",
    {
      func_true = function ()

        func_close();
        func_tap();

        ui.control.TapSet(
          "btn_int_dialog_stage_start_play",
          {
            func_true = func_tap
          }
        );

      end
    }
  );

  _f.ShowDialogInstantly( "replay_3", positions, hole, func_close );
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.replay_last1 ()

  _f.Unload();

end;
--------------------------------------------------------------------------------