-- name=int_tutorial_spellbook
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  StartPending        = function () end,
  FinishPending       = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ()

  private.spellbook_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.spellbook_first ()
      
  _f.Subscribe(
    "spellbook",
    "View_Map_Update_Finished",
    private.spellbook_next1
  );

end;
--------------------------------------------------------------------------------
function private.spellbook_next1 ()

  _f.Unsubscribe(
    "spellbook",
    "View_Map_Update_Finished",
    private.spellbook_next1
  );
  
  _f.StartPending( "spellbook", "map" );

  local func_close = function ( execute_tap )

    _f.HideDialog( private.spellbook_last1 );

  end;

  local focus_obj       = "obj_map_spells_spell_1";
  local dialog_settings = _f.GetDialogSettings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type     = "arrow",
    res_id   = 3,
    focus    = focus_obj,
    scale    = 1,
    offset_x = 0,
    offset_y = - 80,  
    lock     = false
  };

  _f.ShowDialogInstantly(
    "spellbook_1",
    positions,
    hole,
    func_close,
    nil,
    {
      active = true,
      input  = true,
      notify = false
    }
  );

end;
--------------------------------------------------------------------------------
function private.spellbook_last1 ()

  _f.Complete();
  _f.FinishPending( "spellbook", "map" );
  _f.Unload();

end;
--------------------------------------------------------------------------------