-- name=int_tutorial_stage_1
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  GetTargetCount      = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  ui.input.Off( "obj_match3" );
  private.stage_1_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_1_first ()

  _f.Subscribe(
    "stage_1",
    "View_Stage_DialogTargetsHided",
    private.stage_1_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_1_next1 ()
    
  _f.Unsubscribe(
    "stage_1",
    "View_Stage_DialogTargetsHided",
    private.stage_1_next1
  );
 
  _f.LogKontagentEvent( "tutorial", { name  = "tut_level_1_goal" } );

  local focus_obj = "anm_int_panel_stage_top_goals_goal2";
  
  local dialog_settings = _f.GetDialogSettings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type     = "arrow",
    focus    = focus_obj,
    offset_x = 0,
    offset_y = 0,
    scale    = 1,
    angle    = 1.25 * math.pi,
    lock     = true
  };

  local func_close = function ()

    ui.screen.Lock( true );
    _f.HideDialog( private.stage_1_next2 );
    
  end;

  local text_param = _f.GetTargetCount();

  _f.ShowDialogInstantly( "stage_1_1", positions, hole, func_close, text_param );
  _f.Complete();
  ui.input.On( "obj_match3" );

end;
--------------------------------------------------------------------------------
function private.stage_1_next2 ()

  _f.Subscribe(
    "stage_1",
    "Model_Match3_FieldActivated",
    private.stage_1_last
  );

  _f.LogKontagentEvent( "tutorial", { name  = "tut_level_1_swipe" } );

  local match3_pos = ui.obj.Position( "match" );
  
  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 3;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole =
  {
    type    = "flashlight",
    res_id  = 1,
    pos_x   = pos_x,
    pos_y   = pos_y,
    angle   = 3.1415,
    scale   = cell.scale,
    hand = {
      offset_x = 0,
      offset_y = 0,
      scale_x  = - 1,
      type     = "move"
    },
    lock    = true
  };

  _f.ShowDialogInstantly( "stage_1_2", positions, hole );
  ui.screen.Lock( false );

end;
--------------------------------------------------------------------------------
function private.stage_1_last ()

  _f.Unsubscribe(
    "stage_1",
    "Model_Match3_FieldActivated",
    private.stage_1_last
  );

  _f.HideDialog( function () _f.Unload(); end );

end;
--------------------------------------------------------------------------------