-- name=int_tutorial_stage_111
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_111_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_111_first ()

  _f.Subscribe(
    "stage_111",
    "View_Stage_DialogTargetsHided",
    private.stage_111_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_111_next1 ()

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3 - cell.size / 1.5;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",
    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = 0,  
    lock  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_111_next2 );
    
  end;

  _f.ShowDialogInstantly(
    "stage_111_1",
    positions,
    hole,
    func_close
  );

end;
--------------------------------------------------------------------------------
function private.stage_111_next2 ()

  _f.Unsubscribe(
    "stage_111",
    "View_Stage_DialogTargetsHided",
    private.stage_111_next1
  );

  _f.Subscribe(
    "stage_111",
    "Model_Match3_FieldActivated",
    private.stage_111_last1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 1,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = math.pi,
    scale  = cell.scale,    
    hand   = {
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    },
    lock   = true
  };

  _f.ShowDialogInstantly( "stage_111_2", positions, hole );

end;
--------------------------------------------------------------------------------
function private.stage_111_last1 ()

  _f.Unsubscribe(
    "stage_111",
    "Model_Match3_FieldActivated",
    private.stage_111_last1
  );

  _f.HideDialog();
  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------