-- name=int_tutorial_stage_125
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
  RestoreBooster      = function () end,
  CompleteOther       = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_125_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_125_first ()

  _f.Subscribe(
    "stage_125",
    "View_Stage_DialogTargetsHided",
    private.stage_125_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_125_next1 ()

  _f.Unsubscribe(
    "stage_125",
    "View_Stage_DialogTargetsHided",
    private.stage_125_next1
  );
  
  _f.Subscribe(
    "stage_125",
    "Model_Match3_FieldActivated",
    private.stage_125_hide1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 1,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 3.1415,
    scale  = cell.scale,    
    hand   = {
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    },
    lock   = true
  };

  _f.ShowDialogInstantly( "stage_125_1", positions, hole );

end;
--------------------------------------------------------------------------------
function private.stage_125_hide1 ()

  _f.Unsubscribe(
    "stage_125",
    "Model_Match3_FieldActivated",
    private.stage_125_hide1
  );

  _f.HideDialog( private.stage_125_next2 );

end;
--------------------------------------------------------------------------------
function private.stage_125_next2 ()

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",
    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = math.pi,  
    lock  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_125_next3 );
    
  end;

  _f.ShowDialogInstantly( "stage_125_2", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_125_next3 ()

  _f.Subscribe(
    "stage_125",
    "Model_Match3_FieldActivated",
    private.stage_125_hide2
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 1,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = - 0.5 * math.pi,
    scale  = cell.scale,
    lock   = true,
    hand   = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    }
  };

  _f.ShowDialogInstantly( "stage_125_3", positions, hole );

end;
--------------------------------------------------------------------------------
function private.stage_125_hide2 ()

  _f.Unsubscribe(
    "stage_125",
    "Model_Match3_FieldActivated",
    private.stage_125_hide2
  );

  _f.RestoreBooster(
    "stage_125_tap",
    "",
    false,
    "btn_int_dialog_stage_start_boosters"
  );  
  
  _f.HideDialog( private.stage_125_last );

end;
--------------------------------------------------------------------------------
function private.stage_125_last ()
 
  _f.Complete();
  _f.CompleteOther( "stage_125_tap" );  

end;
--------------------------------------------------------------------------------