-- name=int_tutorial_stage_1_tap
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell         = function () end,
  Subscribe             = function () end,
  Unsubscribe           = function () end,
  Complete              = function () end,
  LogKontagentEvent     = function () end,
  GetDialogSettings     = function () end,
  ShowDialogInstantly   = function () end,
  HideDialog            = function () end,
  StartPending          = function () end,
  FinishPending         = function () end,
  GetCurrentSectionName = function () end,
  Unload                = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()


end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ()

  private.stage_1_tap_next();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_1_tap_next ()
  
  -- Fix for cheater section switch.
  if ( _f.GetCurrentSectionName() ~= "section_1" ) then

    _f.Complete();
    return;

  end;
  
  _f.LogKontagentEvent( "tutorial", { name  = "tut_level_1" } );
  
  local events = ui.control.EventsGet( "btn_map_point_stage_1" );
  local func_on_click = events.func_on_click;
  
  local func_close = function ()

    events.func_on_click = func_on_click;
    
    _f.HideDialog( private.stage_1_tap_last );
    func_on_click();

  end;

  events.func_on_click = func_close;
  
  local dialog_settings = _f.GetDialogSettings( "obj_map_point_stage_1" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type   = "flashlight",

    res_id = 3,
    focus  = "obj_map_point_stage_1",
    scale  = 1,
  
    lock   = true,
    black  = true,
    hand   = {
      angle = 0.5 * math.pi,
      type  = "click"
    }
  };

  _f.ShowDialogInstantly(
    "stage_1_tap_1", 
    positions,
    hole,
    func_close,
    nil,
    {
      active = true,
      input  = true,
      notify = false
    }
  );
  
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_1_tap_last ()

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_1_tap" } );
  _f.Unload();

end;
--------------------------------------------------------------------------------