-- name=int_tutorial_stage_221
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_221_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_221_first ()

  _f.Subscribe(
    "stage_221",
    "View_Stage_DialogTargetsHided",
    private.stage_221_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_221_next1 ()
  
  _f.Unsubscribe(
    "stage_221",
    "View_Stage_DialogTargetsHided",
    private.stage_221_next1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 3 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 7;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",
    pos_x = pos_x,
    pos_y = pos_y,
    angle = 0,
    scale = cell.scale,
    lock  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_221_next2 );
    
  end;

  _f.ShowDialogInstantly( "stage_221_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_221_next2 ()

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 7;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 1,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = -0.5 * math.pi,
    scale  = cell.scale,
    lock   = true,
    hand   = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    }
  };


  local func_close;
  
  func_close = function ()
  
    _f.Unsubscribe(
      "stage_221",
      "Model_Match3_FieldActivated",
      func_close
    );

    _f.HideDialog( _f.Unload );

  end;
  
  _f.Subscribe(
    "stage_221",
    "Model_Match3_FieldActivated",
    func_close
  );

  _f.ShowDialogInstantly( "stage_221_2", positions, hole );

  private.stage_221_last();
 
end;
--------------------------------------------------------------------------------
function private.stage_221_last ()

  _f.Complete();

end;
--------------------------------------------------------------------------------