-- name=int_tutorial_stage_26
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Backup              = function () end,
  Restore             = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
  GetCurrentStageData = function () end,
  AddEntity           = function () end,
  ShowEntity          = function () end,
  HideEntity          = function () end,
  GetEntityIndex      = function () end,
  BackupBooster       = function () end,
  RestoreBooster      = function () end,
  AnimateBoosterPanel = function () end,
  OnStageAbandoned    = function () end,
  SetPauseButtonInput = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_26_first();

end;
--------------------------------------------------------------------------------
function private.OnStageAbandoned ()

  _f.Unsubscribe(
    "stage_26",
    "Model_Match3_FieldActivated",
    private.stage_26_next1 
  );

  _f.OnStageAbandoned();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_26_first ()

  _f.Subscribe(
    "stage_26",
    "Model_Match3_FieldActivated",
    private.stage_26_next1
  );

  mediator.SubscribeOnce( "View_Stage_StageAbandon", private.OnStageAbandoned );

  private.moves = 0;

  _f.SetPauseButtonInput( true );

end;
--------------------------------------------------------------------------------
function private.stage_26_next1 ()
  
  local stage_data = _f.GetCurrentStageData();

  private.moves = private.moves + 1;

  if ( ( stage_data.moves - private.moves ) == stage_data.items[ 1 ].move ) then

    _f.SetPauseButtonInput( false );

    _f.Unsubscribe(
      "stage_26",
      "Model_Match3_FieldActivated",
      private.stage_26_next1 
    );

    _f.Subscribe(
      "stage_26",
      "View_Match3_FieldEstablished",
      private.stage_26_next1_1
    ); 

  end;

end;
--------------------------------------------------------------------------------
function private.stage_26_next1_1 ()
  
  _f.Unsubscribe(
    "stage_26",
    "View_Match3_FieldEstablished",
    private.stage_26_next1_1
  );

  mediator.Unsubscribe( "View_Stage_StageAbandon", private.OnStageAbandoned );

  local wind_index = _f.GetEntityIndex(
    _f.GetCurrentStageData().boosters,
    "wind",
    "stage"
  );

  _f.Backup(
    "stage_26",
    "wind_tap",
    ui.control.EventsGet( "obj_int_panel_stage_booster_"..wind_index ).func_on_click
  );

  ui.control.EventsSet(
    "obj_int_panel_stage_booster_"..wind_index,
    { func_on_click = function () end }
  );

  _f.BackupBooster( "stage_26", wind_index );

  _f.Backup(
    "stage_26",
    "settings_tap",
    ui.control.EventsGet( "btn_int_panel_stage_settings_panel" ).func_on_click
  );

  ui.control.EventsSet(
    "btn_int_panel_stage_settings_panel",
    { func_on_click = function () end }
  );
  
  private.stage_26_next1_2();

end;
--------------------------------------------------------------------------------
function private.stage_26_next1_2 ()
  
  local index = _f.GetEntityIndex( _f.GetCurrentStageData().boosters, "wind", "stage" );
  
  local focus_obj       = "obj_int_panel_stage_booster_"..index;
  local dialog_settings = _f.GetDialogSettings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type       = "flashlight",
    res_id     = 3,
    focus      = focus_obj,
    scale      = 1,  
    lock       = true,
    black      = false,
    hand       = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "click"
    }
  };

  local func_close = function ()

    _f.HideDialog( function () private.stage_26_next2( index ); end );
    _f.HideEntity( "obj_int_panel_stage_booster_"..index );

  end;

  ui.control.EventsSet(
    "obj_int_panel_stage_booster_"..index,
    { func_on_click = func_close }
  );

  _f.ShowDialogInstantly( "stage_26_1", positions, hole );  
  _f.AddEntity( "stage_26", "wind", "booster" );
  _f.ShowEntity( "stage_26", "wind", "obj_int_panel_stage_booster_"..index );

end;
--------------------------------------------------------------------------------
function private.stage_26_next2 ( index )

  _f.Subscribe(
    "stage_26",
    "View_Boosters_BoosterUsed",
    private.stage_26_last1
  );

  _f.Subscribe(
    "stage_26",
    "View_Boosters_BoosterUsageFailed",
    private.stage_26_reset
  );

  ne.msg.Subscribe(
    "Event_Match3_WindBoosterFirstSelected",
    private.stage_26_hide2
  );

  local func_settings_tap = _f.Restore( "stage_26", "settings_tap" );

  ui.control.EventsSet(
    "btn_int_panel_stage_settings_panel",
    { func_on_click = func_settings_tap }
  );

  local func_wind_tap = _f.Restore( "stage_26", "wind_tap" );

  ui.control.EventsSet(
    "obj_int_panel_stage_booster_"..index,
    { func_on_click = func_wind_tap }
  );

  _f.RestoreBooster( "stage_26", index );

  if ( func_wind_tap ) then

    func_wind_tap();

  end;

  local items_data = _f.GetCurrentStageData().items;
  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * items_data[ 1 ].col - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * items_data[ 1 ].row - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 3,
    pos_x      = pos_x,
    pos_y      = pos_y,
    scale      = 0.5,  
    lock       = true,
    black      = false,
    hand       = {
      offset_x = 0,
      offset_y = 0,
      scale    = 1,
      angle    = 0,
      type     = "click"
    },
    input      = false
  };

  local func_close = function () _f.HideDialog(); end;

  _f.ShowDialogInstantly( "stage_26_2", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_26_hide2 ()
  
  ne.msg.Unsubscribe(
    "Event_Match3_WindBoosterFirstSelected", 
    private.stage_26_hide2
  );

  _f.HideDialog( private.stage_26_next3 );

end;
--------------------------------------------------------------------------------
function private.stage_26_next3 ()

  local stage_data = _f.GetCurrentStageData();
  local items_data = stage_data.items; 

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * items_data[ 1 ].col   - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * stage_data.field[ 1 ] - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 3,
    pos_x      = pos_x,
    pos_y      = pos_y,
    scale      = 0.5,  
    lock       = true,
    black      = false,
    hand       = {
      offset_x = 0,
      offset_y = 0,
      scale    = 1,
      angle    = 0,
      type     = "click"
    },
    input      = false
  };

  local func_close = function () _f.HideDialog(); end;

  _f.ShowDialogInstantly( "stage_26_3", positions, hole, func_close );
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_26_last1 ()

  mediator.Unsubscribe( "View_Stage_StageAbandon", private.OnStageAbandoned );

  _f.Unsubscribe(
    "stage_26",
    "View_Boosters_BoosterUsageFailed",
    private.stage_26_reset
  );

  _f.Unsubscribe(
    "stage_26",
    "View_Boosters_BoosterUsed",
    private.stage_26_last1
  );

  _f.HideDialog( _f.Unload );

end;
--------------------------------------------------------------------------------
function private.stage_26_reset ()

  local func_fake_tap = function ()
    
    common.MessageSend(
      Event_Match3_BoosterActivated,
      {
        name     = "wind",
        row      = nil,
        col      = nil,
        vertical = nil 
      }
    );
    
    _f.AnimateBoosterPanel( "wind" );
    
  end;

  func_fake_tap();

end;
--------------------------------------------------------------------------------