-- name=int_tutorial_stage_2_modification_2
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_2_modification_2_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_2_modification_2_first ()
  
  _f.Subscribe(
    "stage_2_modification_2",
    "View_Stage_DialogTargetsHided",
    private.stage_2_modification_2_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_next1 ()

  _f.Unsubscribe(
    "stage_2_modification_2",
    "View_Stage_DialogTargetsHided",
    private.stage_2_modification_2_next1
  );

  _f.Subscribe(
    "stage_2_modification_2",
    "Model_Match3_FieldActivated",
    private.stage_2_modification_2_hide1
  );

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_2_match4" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 2,
    pos_x      = pos_x,
    pos_y      = pos_y,
    angle      = 0,
    scale      = cell.scale,
    lock       = true,
    hand       = {
      angle    = - 0.5 * math.pi,
      offset_x = cell.size,
      offset_y = 0,
      type     = "move"
    }
  };

  _f.ShowDialogInstantly(
    "stage_2_modification_2_1",
    positions,
    hole  
  );
  
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_hide1 ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_level_2_match4done" } );  

  _f.Unsubscribe(
    "stage_2_modification_2",
    "Model_Match3_FieldActivated",
    private.stage_2_modification_2_hide1
  );

  _f.HideDialog( private.stage_2_modification_2_next2 );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_next2 ()

  _f.Subscribe( 
    "stage_2_modification_2", 
    "Model_Match3_FieldActivated", 
    private.stage_2_modification_2_hide2 
  );

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_2_bonus" } );

  local match3_pos = ui.obj.Position( "match" );

  local cell = _f.GetMatch3Cell();
  
  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 1,
    pos_x      = pos_x,
    pos_y      = pos_y,
    angle      = -0.5 * math.pi,
    scale      = cell.scale,    
    hand       = {
      offset_x = 0,
      offset_y = 0,
      scale_x  = - 1,
      angle    = 0.5 * math.pi,
      type     = "move"
    },
    lock       = true
  };

  _f.ShowDialogInstantly(
    "stage_2_modification_2_2",
    positions,
    hole
  );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_hide2 ()

  _f.Unsubscribe( 
    "stage_2_modification_2", 
    "Model_Match3_FieldActivated", 
    private.stage_2_modification_2_hide2 
  );

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_2_bonusdone" } );
  _f.HideDialog( private.stage_2_modification_2_next3 );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_next3 ()
  
  _f.Subscribe(
    "stage_2_modification_2",
    "Model_Match3_FieldActivated",
    private.stage_2_modification_2_hide3
  );

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_2_match4blue" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 2;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 16,
    pos_x      = pos_x,
    pos_y      = pos_y,
    angle      = 0,
    scale      = cell.scale,
    lock       = true,
    hand       = {
      angle    = - 0.5 * math.pi,
      offset_x = - cell.size,
      offset_y = 0,
      type     = "move"
    }
  };

  _f.ShowDialogInstantly(
    "stage_2_modification_2_3",
    positions,
    hole
  );
  
end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_hide3 ()

  _f.Unsubscribe( 
    "stage_2_modification_2", 
    "Model_Match3_FieldActivated", 
    private.stage_2_modification_2_hide3 
  );
  
  _f.LogKontagentEvent( "tutorial", { name  = "tut_level_2_match4bluedone" } );
  _f.HideDialog( private.stage_2_modification_2_next4 );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_next4 ()

  _f.Subscribe(
    "stage_2_modification_2", 
    "Model_Match3_FieldActivated", 
    private.stage_2_modification_2_hide4 
  );

  _f.LogKontagentEvent( "tutorial", { name  = "tut_level_2_bonusblue" } );

  local match3_pos = ui.obj.Position( "match" );

  local cell = _f.GetMatch3Cell();
  
  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 3 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 2;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 1,
    pos_x      = pos_x,
    pos_y      = pos_y,
    angle      = 0.5 * math.pi,
    scale      = cell.scale,    
    hand       = {
      offset_x = 0,
      offset_y = 0,
      scale_x  = - 1,
      angle    = 0.5 * math.pi,
      type     = "move"
    },
    lock       = true
  };

  _f.ShowDialogInstantly(
    "stage_2_modification_2_4",
    positions,
    hole
  );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_hide4 ()

  _f.Unsubscribe( 
    "stage_2_modification_2", 
    "Model_Match3_FieldActivated", 
    private.stage_2_modification_2_hide4 
  );
  
  _f.LogKontagentEvent( "tutorial", { name  = "tut_level_2_bonusbluedone" } );
  _f.HideDialog( private.stage_2_modification_2_last );

end;
--------------------------------------------------------------------------------
function private.stage_2_modification_2_last ()

  _f.Unload();

end;
--------------------------------------------------------------------------------