-- name=int_tutorial_stage_3_modification_1
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  GetTargetCount      = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_3_modification_1_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_3_modification_1_first ( stage_name )

  _f.Subscribe(
    "stage_3_modification_1",
    "View_Stage_DialogTargetsHided",
    private.stage_3_modification_1_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_3_modification_1_next1 ()

  _f.Unsubscribe(
    "stage_3_modification_1",
    "View_Stage_DialogTargetsHided",
    private.stage_3_modification_1_next1
  );

  _f.Subscribe(
    "stage_3_modification_1",
    "Model_Match3_FieldActivated",
    private.stage_3_modification_1_hide1
  );

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_3_matchl" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 13,
    pos_x      = pos_x - cell.size,
    pos_y      = pos_y,
    angle      = 0,
    scale      = cell.scale,
    lock       = true,
    hand       = {
      angle    = 0.5 * math.pi,
      offset_x = -2 * cell.size,
      offset_y = -2 * cell.size,
      type     = "move"
    }
  };

  _f.ShowDialogInstantly( "stage_3_modification_1_1", positions, hole );  
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_3_modification_1_hide1 ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_level_3_matchldone" } );   
  
  _f.Unsubscribe(
    "stage_3_modification_1",
    "Model_Match3_FieldActivated",
    private.stage_3_modification_1_hide1
  );
  
  _f.HideDialog( private.stage_3_modification_1_next2 );
  
end;
--------------------------------------------------------------------------------
function private.stage_3_modification_1_next2 ()

  _f.Subscribe( 
    "stage_3_modification_1", 
    "Model_Match3_FieldActivated", 
    private.stage_3_modification_1_hide2 
  );

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_3_bonus" } );

  local match3_pos = ui.obj.Position( "match" );

  local cell = _f.GetMatch3Cell();
  
  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",
    res_id     = 12,
    pos_x      = pos_x,
    pos_y      = pos_y,
    angle      = 0.5 * math.pi,
    scale      = cell.scale,    
    hand = {
      offset_x = 0,
      offset_y = - 2 * cell.size,
      scale_x  = - 1,
      angle    = 0.5 * math.pi,
      type     = "move"
    },
    lock       = true
  };

  _f.ShowDialogInstantly( "stage_3_modification_1_2", positions, hole );

end;
--------------------------------------------------------------------------------
function private.stage_3_modification_1_hide2 ()

  _f.Unsubscribe( 
    "stage_3_modification_1", 
    "Model_Match3_FieldActivated", 
    private.stage_3_modification_1_hide2 
  );
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_level_3_bonusdone" } );
  _f.HideDialog( _f.Unload );

end;
--------------------------------------------------------------------------------