-- name=int_tutorial_stage_44
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Backup              = function () end,
  Restore             = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
  AddEntity           = function () end,
  ShowEntity          = function () end,
  HideEntity          = function () end,
  GetCascadeIndex     = function () end,
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_44_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_44_first ()

  _f.Subscribe(
    "stage_44",
    "View_Stage_DialogTargetsHided",
    private.stage_44_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_44_next1 ()

  local index = _f.GetCascadeIndex();

  _f.Unsubscribe(
    "stage_44",
    "View_Stage_DialogTargetsHided",
    private.stage_44_next1
  );

  _f.Backup(
    "stage_44",
    "booster_tap",
    ui.control.EventsGet( "obj_int_panel_stage_booster_"..index ).func_on_click
  );

  local focus_obj       = "obj_int_panel_stage_booster_"..index;
  local dialog_settings = _f.GetDialogSettings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    focus  = focus_obj,
    scale  = 1,
    lock   = true,
    black  = true,
    hand   = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "click"
    }
  };

  local func_close = function ()

    _f.HideDialog( function () private.stage_44_next2( index ); end );

  end;

  ui.control.EventsSet( focus_obj, { func_on_click = func_close } );

  _f.ShowDialogInstantly( "stage_44_1", positions, hole );  
  _f.AddEntity( "stage_44", "cascade", "booster" );
  _f.ShowEntity( "stage_44", "cascade", focus_obj );

end;
--------------------------------------------------------------------------------
function private.stage_44_next2 ( index )

  local booster_obj = "obj_int_panel_stage_booster_"..index;

  _f.Subscribe(
    "stage_44",
    "View_Boosters_BoosterUsed",
    private.stage_44_last1
  );

  local func_booster_tap = _f.Restore( "stage_44", "booster_tap" );

  ui.control.EventsSet( booster_obj, { func_on_click = func_booster_tap } );

  if ( func_booster_tap ) then

    func_booster_tap();

    _f.HideEntity( booster_obj );

  end;

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 2 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3 + cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y - 200 } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    scale  = 0.6,
    lock   = true,
    black  = true,
    hand   = {
      offset_x = 0,
      offset_y = 0,
      scale    = 1,
      angle    = 0,
      type     = "click"
    }
  };

  _f.ShowDialogInstantly( "stage_44_2", positions, hole );
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_44_last1 ()

  _f.Unsubscribe(
    "stage_44",
    "View_Boosters_BoosterUsed",
    private.stage_44_last1
  );

  _f.HideDialog( _f.Unload );

end;
--------------------------------------------------------------------------------