-- name=int_tutorial_stage_45
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_45_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_45_first ()

  _f.Subscribe(
    "stage_45",
    "View_Stage_DialogTargetsHided",
    private.stage_45_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_45_next1 ()

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y + cell.size,
    angle  = 0,
    scale  = 1,
    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_45_next2 );
    
  end;

  local text_param = v_stage.Stage_GetCurrentData().targets[ 1 ].count;

  _f.ShowDialogInstantly(
    "stage_45_1",
    positions,
    hole,
    func_close,
    text_param
  );

end;
--------------------------------------------------------------------------------
function private.stage_45_next2 ()

  _f.Unsubscribe(
    "stage_45",
    "View_Stage_DialogTargetsHided",
    private.stage_45_next1
  );
 
  _f.Subscribe(
    "stage_45",
    "Model_Match3_FieldActivated",
    private.stage_45_hide1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4 - cell.size;

  local v_pref = 25;
  
  if ( ui.screen.IsLandscape() ) then
    
    v_pref = nil;
    
  end;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y }, v_pref );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 1,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 3.1415,
    scale  = cell.scale,    
    hand   = {
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    },

    lock   = true
  };

  _f.ShowDialogInstantly( "stage_45_2", positions, hole );

end;
--------------------------------------------------------------------------------
function private.stage_45_hide1 ()

  _f.Unsubscribe(
    "stage_45",
    "Model_Match3_FieldActivated",
    private.stage_45_hide1
  );

  _f.HideDialog( private.stage_45_last1 );
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_45_last1 ()

  _f.Unload();

end;
--------------------------------------------------------------------------------