-- name=int_tutorial_stage_661
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_661_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_661_first ( stage_name )
  
  _f.Subscribe(
    "stage_661",
    "View_Stage_DialogTargetsHided",
    private.stage_661_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_661_next1 ()

  _f.Unsubscribe(
    "stage_661",
    "View_Stage_DialogTargetsHided",
    private.stage_661_next1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 11,
    pos_x  = pos_x,
    pos_y  = pos_y + cell.size,
    angle  = 0,
    scale  = cell.scale,
    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_661_next2 );

  end;

  _f.ShowDialogInstantly( "stage_661_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_661_next2 ()

  _f.Subscribe(
    "stage_661",
    "Model_Match3_FieldActivated",
    private.stage_661_hide2
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 3 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type          = "flashlight",
    res_id        = 1,
    pos_x         = pos_x,
    pos_y         = pos_y,
    angle         = 0.5 * math.pi,
    scale         = cell.scale,
    lock          = true,
    hand          = {
         angle    = 0.5 * math.pi,
         offset_x = 0,
         offset_y = 0,
         type     = "move"
    }
  };

  local func_close = function ()

    --
    
  end;

  _f.ShowDialogInstantly( "stage_661_2", positions, hole, func_close );

  private.stage_661_last1();

end;
--------------------------------------------------------------------------------
function private.stage_661_hide2 ()

  _f.Unsubscribe(
    "stage_661",
    "Model_Match3_FieldActivated",
    private.stage_661_hide2
  );

  _f.HideDialog();

end;
--------------------------------------------------------------------------------
function private.stage_661_last1 ()

  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------