-- name=int_tutorial_stage_683
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_683_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_683_first ()
    
  _f.Subscribe(
    "stage_683",
    "View_Stage_DialogTargetsHided",
    private.stage_683_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_683_next1 ()
  
  _f.Unsubscribe(
    "stage_683",
    "View_Stage_DialogTargetsHided",
    private.stage_683_next1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 4 + cell.size;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );
  
  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = 0.7,
    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_683_next2 );
    
  end;

  _f.ShowDialogInstantly( "stage_683_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_683_next2 ()
  
  _f.Subscribe(
    "stage_683",
    "Model_Match3_FieldActivated",
    private.stage_683_hide2
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type          = "flashlight",
    res_id        = 1,
    pos_x         = pos_x,
    pos_y         = pos_y,
    angle         = 0.5 * math.pi,
    scale         = cell.scale,
    lock          = true,
    hand          = {
         angle    = 0.5 * math.pi,
         offset_x = 0,
         offset_y = 0,
         type     = "move"
    }
  };

  local func_close = function ()

    --
    
  end;

  _f.ShowDialogInstantly( "stage_683_2", positions, hole, func_close );
  
end;
--------------------------------------------------------------------------------
function private.stage_683_hide2 ()

  _f.Unsubscribe(
    "stage_683",
    "Model_Match3_FieldActivated",
    private.stage_683_hide2
  );

  _f.HideDialog( private.stage_683_next3 );

end;
--------------------------------------------------------------------------------
function private.stage_683_next3 ()

  _f.Subscribe(
    "stage_683",
    "Model_Match3_FieldActivated",
    private.stage_683_hide3
  );

  local match3_pos = ui.obj.Position( "match" );
  
  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 6;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = cell.scale,
    
    hand = {
         offset_x = 0,
         offset_y = 0,
         scale_x  = - 1,
         type     = "move"
    },

    lock           = true
  };

  local func_close = function ()

    --

  end;

  _f.ShowDialogInstantly( "stage_683_3", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_683_hide3 ()

  _f.Unsubscribe(
    "stage_683",
    "Model_Match3_FieldActivated",
    private.stage_683_hide3
  );

  _f.HideDialog( private.stage_683_next4 );

end;
--------------------------------------------------------------------------------
function private.stage_683_next4 ()

  _f.Subscribe(
    "stage_683",
    "Model_Match3_FieldActivated",
    private.stage_683_hide4
  );

  local match3_pos = ui.obj.Position( "match" );
  
  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 3;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 3.1415,
    scale          = cell.scale,
    
    hand = {
         offset_x = 0,
         offset_y = 0,
         scale_x  = - 1,
         type     = "move"
    },

    lock           = true
  };

  local func_close = function ()

    --

  end;

  _f.ShowDialogInstantly( "stage_683_4", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_683_hide4 ()

  _f.Unsubscribe(
    "stage_683",
    "Model_Match3_FieldActivated",
    private.stage_683_hide4
  );

  _f.HideDialog( private.stage_683_next5 );

end;
--------------------------------------------------------------------------------
function private.stage_683_next5 ()
  
  local match3_pos = ui.obj.Position( "match" );
  
  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale,
    character_pos_y = dialog_settings.ch_pos_y
  };
  
  local hole = 
  {
    type   = "arrow",
    pos_x  = pos_x,
    pos_y  = pos_y,
    scale  = 1,
    angle  = 0,
    length = 270,
    lock   = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_683_last1 );
    
  end;

  _f.ShowDialogInstantly( "stage_683_5", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_683_last1 ()

  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------