-- name=int_tutorial_stage_69
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_69_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_69_first ()
    
  _f.Subscribe(
    "stage_69",
    "View_Stage_DialogTargetsHided",
    private.stage_69_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_69_next1 ()

  _f.Unsubscribe(
    "stage_69",
    "View_Stage_DialogTargetsHided",
    private.stage_69_next1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 2 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 8;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type  = "arrow",
    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,  
    lock  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_69_next2 );
    
  end;

  _f.ShowDialogInstantly( "stage_69_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_69_next2 ()

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 7 - cell.size;
  local pos_y = match3_pos[ 2 ];

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type  = "arrow",
    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = 3.1415,  
    lock  = true
  };

  local func_close = function ()

    _f.HideDialog( private.stage_69_last1 );
    
  end;

  _f.ShowDialogInstantly( "stage_69_2", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_69_last1 ()

  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------