-- name=int_tutorial_stage_6_modification_1
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell        = function () end,
  Subscribe            = function () end,
  Unsubscribe          = function () end,
  Complete             = function () end,
  LogKontagentEvent    = function () end,
  GetDialogSettings    = function () end,
  ShowDialogInstantly  = function () end,
  HideDialog           = function () end,
  Unload               = function () end,
  SetBoosterPanelInput = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_6_modification_1_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_6_modification_1_first ( stage_name )

  _f.Subscribe(
    "stage_6_modification_1",
    "View_Stage_DialogTargetsHided",
    private.stage_6_modification_1_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_6_modification_1_next1 ()

  _f.Unsubscribe(
    "stage_6_modification_1",
    "View_Stage_DialogTargetsHided",
    private.stage_6_modification_1_next1
  );

  _f.Subscribe(
    "stage_6_modification_1",
    "Model_Match3_FieldActivated",
    private.stage_6_modification_1_hide1
  );
  
  _f.Subscribe(
    "stage_6_modification_1",
    "View_Stage_Match_ShadesOff",
    private.stage_6_modification_1_next2
  );

  _f.SetBoosterPanelInput( false, "tutorial" );
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_level_6_match5" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 3 + cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type   = "flashlight",
    res_id = 5,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = cell.scale,
    lock   = true,
    hand   = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    }
  };

  _f.ShowDialogInstantly( "stage_6_modification_1_1", positions, hole );
  
end;
--------------------------------------------------------------------------------
function private.stage_6_modification_1_hide1 ()

  _f.LogKontagentEvent( "tutorial", { name = "tut_level_6_match5done" } );

  _f.Unsubscribe(
    "stage_6_modification_1",
    "Model_Match3_FieldActivated",
    private.stage_6_modification_1_hide1
  );
  
  _f.HideDialog();

end;
--------------------------------------------------------------------------------
function private.stage_6_modification_1_next2 ()

  _f.Unsubscribe(
    "stage_6_modification_1",
    "View_Stage_Match_ShadesOff",
    private.stage_6_modification_1_next2
  );
  
  _f.Subscribe(
    "stage_6_modification_1",
    "Model_Match3_FieldActivated",
    private.stage_6_modification_1_hide2
  );

  _f.SetBoosterPanelInput( true );
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_level_6_fireworks" } ); 

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 3;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 4,
    pos_x  = pos_x - cell.size,
    pos_y  = pos_y,
    angle  = 0.5 * math.pi,
    scale  = cell.scale,
    lock   = true,
    hand   = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "move"
    }
  };

  _f.ShowDialogInstantly( "stage_6_modification_1_2", positions, hole );  
  _f.Complete();
  
end;
--------------------------------------------------------------------------------
function private.stage_6_modification_1_hide2 ()
  
  _f.LogKontagentEvent( "tutorial", { name = "tut_level_6_fireworksdone" } );  

  _f.Unsubscribe(
    "stage_6_modification_1",
    "Model_Match3_FieldActivated",
    private.stage_6_modification_1_hide2
  );

  _f.HideDialog( _f.Unload );
  
end;
--------------------------------------------------------------------------------