-- name=int_tutorial_stage_771
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_771_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_771_first ()
  
  _f.Subscribe(
    "stage_771",
    "View_Stage_DialogTargetsHided",
    private.stage_771_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_771_next1 ()

  _f.Unsubscribe(
    "stage_771",
    "View_Stage_DialogTargetsHided",
    private.stage_771_next1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = 0.8,
    lock   = false,
    black  = true,
    input  = true
  };
  
  local func_close = function ()

    _f.HideDialog( private.stage_771_next2 );

  end;

  _f.ShowDialogInstantly( "stage_771_1", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_771_next2 ()

  _f.Subscribe(
    "stage_771",
    "Model_Match3_FieldActivated",
    private.stage_771_hide2
  );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 2,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = cell.scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = cell.size,
         offset_y  = 0,
         type      = "move"
    }
  };

  local func_close = function ()

    --
    
  end;

  _f.ShowDialogInstantly( "stage_771_2", positions, hole, func_close );

end;
--------------------------------------------------------------------------------
function private.stage_771_hide2 ()

  _f.Unsubscribe(
    "stage_771",
    "Model_Match3_FieldActivated",
    private.stage_771_hide2
  );

  _f.HideDialog( private.stage_771_next3 );

end;
--------------------------------------------------------------------------------
function private.stage_771_next3 ()

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5 - cell.size;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5 - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = 0.8,
    lock   = false,
    black  = true,
    input  = true
  };
  
  local func_close = function () _f.HideDialog( _f.Unload ); end;

  _f.ShowDialogInstantly( "stage_771_3", positions, hole, func_close );

  private.stage_771_last1();
  
end;
--------------------------------------------------------------------------------
function private.stage_771_last1 ()

  _f.Complete();

end;
--------------------------------------------------------------------------------