-- name=int_tutorial_stage_80
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  Backup              = function () end,
  Restore             = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  Unload              = function () end,
  AddEntity           = function () end,
  GetFireburstIndex   = function () end,
  ShowEntity          = function () end,
  HideEntity          = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.stage_80_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.stage_80_first ( stage_name )

  _f.Subscribe(
    "stage_80",
    "View_Stage_DialogTargetsHided",
    private.stage_80_next1
  );

end;
--------------------------------------------------------------------------------
function private.stage_80_next1 ()

  _f.Unsubscribe(
    "stage_80",
    "View_Stage_DialogTargetsHided",
    private.stage_80_next1
  );

  local index     = _f.GetFireburstIndex();
  local focus_obj = "obj_int_panel_stage_booster_"..index;
  
  local dialog_settings = _f.GetDialogSettings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",
    res_id      = 3,
    focus       = focus_obj,
    scale       = 1,  
    lock        = true,
    black       = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    _f.HideDialog( function () private.stage_80_next2( focus_obj ); end );
    _f.HideEntity( focus_obj );

  end;

  _f.Backup(
    "stage_80",
    "booster_tap",
    ui.control.EventsGet( focus_obj ).func_on_click
  );

  ui.control.EventsSet( focus_obj, { func_on_click = func_close } );

  _f.ShowDialogInstantly( "stage_80_1", positions, hole );  
  _f.AddEntity(  "stage_80", "fireburst", "booster" );
  _f.ShowEntity( "stage_80", "fireburst", focus_obj );

end;
--------------------------------------------------------------------------------
function private.stage_80_next2 ( focus_obj )

  _f.Subscribe(
    "stage_80",
    "View_Boosters_BoosterUsed",
    private.stage_80_last
  );

  local func_booster_tap = _f.Restore( "stage_80", "booster_tap" );

  ui.control.EventsSet( focus_obj, { func_on_click = func_booster_tap } );

  if ( func_booster_tap ) then func_booster_tap(); end;

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 5 * 2 * cell.size - cell.size;
  local pos_y = match3_pos[ 2 ] + 7 * 2 * cell.size - cell.size;

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    scale  = 0.7,  
    lock   = true,
    black  = true,
    hand   = {
      offset_x = 0,
      offset_y = 0,
      scale    = 1,
      angle    = 0,
      type     = "click"
    }
  };

  _f.ShowDialogInstantly( "stage_80_2", positions, hole );
  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.stage_80_last ()

  _f.Unsubscribe(
    "stage_80",
    "View_Boosters_BoosterUsed",
    private.stage_80_last
  );

  _f.HideDialog( _f.Unload );

end;
--------------------------------------------------------------------------------