-- name=int_tutorial_swordstone
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell       = function () end,
  Subscribe           = function () end,
  Unsubscribe         = function () end,
  Complete            = function () end,
  LogKontagentEvent   = function () end,
  GetDialogSettings   = function () end,
  ShowDialogInstantly = function () end,
  HideDialog          = function () end,
  StartPending        = function () end,
  FinishPending       = function () end,
  Unload              = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ()

  private.stage_1_first();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.swordstone_first ()

  _f.Subscribe(
    "swordstone",
    "View_Map_Update_Build_Animated",
    private.swordstone_next1
  );

end;
--------------------------------------------------------------------------------
function private.swordstone_next1 ()
  
  _f.Unsubscribe( 
    "swordstone",
    "View_Map_Update_Build_Animated",
    private.swordstone_next1
  );
  
  _f.StartPending( "swordstone", "map" );
  _f.Complete();
  
  local pref_vertical = 75;
  
  if ( ui.screen.IsLandscape() ) then
    
    pref_vertical = 60;
    
  end;
  
  local dialog_settings =
    _f.GetDialogSettings( "obj_map_builds_puzzle_1", pref_vertical );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "arrow",
    focus    = "obj_map_builds_puzzle_1",
    offset_x = -40,
    offset_y = -70,
    angle    = 1.5 * math.pi,
    scale    = -1,
    lock     = true
  };

  _f.ShowDialogInstantly(
    "swordstone",
    positions,
    hole,
    private.swordstone_last1,
    nil,
    { active = true },
    true
  );

end;
--------------------------------------------------------------------------------
function private.swordstone_last1 ()

  _f.LogKontagentEvent( "tutorial", { name  = "tut_swordstone" } );
  _f.HideDialog(
    function ()

      _f.FinishPending( "swordstone", "map" );
      _f.Unload();

    end
  );

end;
--------------------------------------------------------------------------------