-- name=int_tutorial_wind
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  GetMatch3Cell        = function () end,
  Subscribe            = function () end,
  Unsubscribe          = function () end,
  Complete             = function () end,
  LogKontagentEvent    = function () end,
  GetDialogSettings    = function () end,
  ShowDialogInstantly  = function () end,
  HideDialog           = function () end,
  StartPending         = function () end,
  FinishPending        = function () end,
  GetMatch3FieldCenter = function () end,
  ShowMatch3Effect     = function () end,
  HideMatch3Effect     = function () end,
  Unload               = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  private.wind_start();

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.wind_start ()

  _f.StartPending( "wind", "stage" );
  
  _f.Subscribe(
    "wind",
    "View_Stage_DialogTargetsHided",
    private.wind_step1
  );

end;
--------------------------------------------------------------------------------
function private.wind_step1 ()

  _f.Unsubscribe(
    "wind",
    "View_Stage_DialogTargetsHided",
    private.wind_step1
  );
  
  _f.LogKontagentEvent( "tutorial", { name  = "tut_wind" } );

  local pos_x, pos_y = _f.GetMatch3FieldCenter();

  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",

    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = 5,

    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    _f.HideMatch3Effect();
    _f.HideDialog( private.wind_step2 );

  end;

  _f.ShowDialogInstantly( "wind_1", positions, hole, func_close );  
  _f.ShowMatch3Effect();
  
end;
--------------------------------------------------------------------------------
function private.wind_step2 ()
  
  _f.LogKontagentEvent( "tutorial", { name  = "tut_winddone" } );

  local match3_pos = GetObjPosByObj( "match" );

  local cell = _f.GetMatch3Cell();

  local pos_x = match3_pos[ 1 ] + 2 * cell.size * 5;
  local pos_y = match3_pos[ 2 ] + 2 * cell.size * 5 - cell.size;
  
  local dialog_settings = _f.GetDialogSettings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = cell.scale,

    lock           = true,
    hand           = {
         angle     = 0,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    _f.Unsubscribe(
      "wind",
      "Model_Match3_FieldActivated", 
      func_close
    );

    _f.HideDialog( private.wind_complete );

  end;

  _f.LogKontagentEvent( "tutorial", { name  = "tut_wind_match" } );
  
  _f.Subscribe(
    "wind",
    "Model_Match3_FieldActivated",
    func_close
  );

  _f.ShowDialogInstantly( "wind_2", positions, hole );

end;
--------------------------------------------------------------------------------
function private.wind_complete ()
  
  _f.LogKontagentEvent( "tutorial", { name  = "tut_wind_matchdone" } );
  _f.Complete();
  _f.Unload();

end;
--------------------------------------------------------------------------------