-- name=int_tutorial_worldmap
--------------------------------------------------------------------------------
-- function DelegateScheme ()
--------------------------------------------------------------------------------
local _f = {
  Subscribe            = function () end,
  Unsubscribe          = function () end,
  Backup               = function () end,
  Restore              = function () end,
  Complete             = function () end,
  LogKontagentEvent    = function () end,
  GetDialogSettings    = function () end,
  ShowDialogInstantly  = function () end,
  HideDialog           = function () end,
  StartPending         = function () end,
  FinishPending        = function () end,
  Unload               = function () end
};
--------------------------------------------------------------------------------
function public.__GetDelegateScheme ()

  return _f;

end;
--------------------------------------------------------------------------------
function public.__InitModule ()

  --

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Start ( stage_name )

  _f.Subscribe(
    "worldmap",
    "View_Map_Update_Finished",
    private.worldmap_first
  );

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function private.worldmap_first ()

  _f.Unsubscribe(
    "worldmap",
    "View_Map_Update_Finished",
    private.worldmap_first
  );
  
  _f.StartPending( "worldmap", "map" );

  private.worldmap_next1();

end;
--------------------------------------------------------------------------------
function private.worldmap_next1 ()

  local focus_obj       = "btn_map_portal_section_1_next";
  local dialog_settings = _f.GetDialogSettings( focus_obj );
  
  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type   = "flashlight",
    res_id = 3,
    focus  = focus_obj,
    angle  = 0,
    scale  = 2.00,    
    hand   = {
      offset_x = - 50,
      offset_y = 0,
      scale_x  = - 1,
      type     = "click"
    },
    black  = false,
    lock   = true
  };

  local func_close = function ()

    _f.HideDialog(
      function()

        private.worldmap_last1( focus_obj );

      end
    );

  end;

  _f.Backup(
    "worldmap",
    "portal_tap",
    ui.control.TapGet( focus_obj ).func_true
  );

  ui.control.TapSet( focus_obj, { func_true = func_close } );

  v_map.Focus(
    focus_obj,
    {
      time = 0.6,
      func_after = function ()
      
        _f.ShowDialogInstantly( 
          "worldmap", positions, hole, nil, nil, 
          { active = true, input = true, notify = true }
        );
      
      end
    }
  );

  _f.Complete();

end;
--------------------------------------------------------------------------------
function private.worldmap_last1 ( focus_obj )

  local func_portal_tap = _f.Restore( "worldmap", "portal_tap" );

  ui.control.TapSet( focus_obj, { func_true = func_portal_tap } );

  if ( func_portal_tap ) then func_portal_tap(); end;
  
  _f.FinishPending( "worldmap", "map" );

  _f.Unload();

end;
--------------------------------------------------------------------------------