-- name=tests
--------------------------------------------------------------------------------
function public.__InitModule ()    
  math.randomseed( os.time() );
end;
--------------------------------------------------------------------------------
function public.Start(scene, settings)
  
  private.scene = scene;
  private.settings = settings;
  private.fixedDT = settings.fixedDT or 0.1;
  private.ApplySettings();    
  
  private.LoadStandardCursors();  
  ne.msg.Subscribe( Event_Application_LoadingComplete, private.AppLoadingComplete );  
  ne.msg.Send( Event_Menu_LoadingComplete, {} );
  
end;
--------------------------------------------------------------------------------
function private.AppLoadingComplete()  

  ne.mod.LoadLazily( "assets/dev/tests/mod_"..private.scene );
  _G[ private.scene ].Start(private.settings);

end;
--------------------------------------------------------------------------------
function private.ApplySettings()

  if ( private.fixedDT ) then
    ne.dbg.Trace('Apply Settings is runned!', true);
    ne.dbg.SetFixedDT(private.fixedDT);
  end
  
end;
--------------------------------------------------------------------------------
function private.LoadStandardCursors()
  SetSysCursor( GetSysCursor() );
  local count = 0;
  local CursorLoad = function ( cur_name, cur_path, cur_idx )
    _G[ cur_name ] = count;
    CursorLoad( cur_path, cur_idx );
    count = count + 1;
  end;
  
  CursorLoad( "CURSOR_NULL",    "", 0 );
  CursorLoad( "CURSOR_DEFAULT", "assets/cursors/cursor_default_a", 2 );
  CursorLoad( "CURSOR_HAND",    "assets/cursors/cursor_hand_a",    4 );
  
  SetCursor( CURSOR_DEFAULT );
end;
--------------------------------------------------------------------------------
  