-- name=dbg_match3
--------------------------------------------------------------------------------
---- function *** Init *** (
--------------------------------------------------------------------------------
function public.__InitModule()
  private.match3 = {};
  
  private.current_section = 1;
  private.current_stage   = 1;
  private.current_state   = 1;
  private.start_count      = 10;
    
  ne.msg.Subscribe( "Event_Cheat_KeyPressed", private.Handle_Event_Cheat_KeyPressed );

  ne.mod.LoadLazily( "assets/content/scripts/mod_common" );
  
  common.mod.Load({
    "mediator",
    "lib_rpc",
    "lib_db",
    "ui",
    "v_features",
    "v_log",
    "v_game",
    "v_interface",
    "v_tutorial",
    "v_screen",
    "v_hearts",
    "v_boosters",
    "v_player",
    "v_potions",
    "v_match3",
    "v_stage"
  });

  mediator.CheatDisableQueue();
  
  ne.mod.LoadLazily( "assets/dev/tests/mod_bot" );
  private.Info("Initialized.");
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects()  
  ObjAttach("obj_dbg_match3", "ng_application");  
end;
--------------------------------------------------------------------------------
function public.Start( settings )

  private.Info(
    "Start: section_"..tostring( settings.section )..
    ", stage_"..tostring( settings.stage )..
    ", state: "..tostring( settings.state )
  );
  
  private.attempt_count = settings.attempts or private.start_count;
  private.current_section = settings.section or private.current_section;
  private.current_stage   = settings.stage   or private.current_stage;
  private.current_state   = settings.state   or private.current_state;
  
  lib_db.AddLevels("stages_" .. private.current_section); 
  
  private.Info( "Loading section: <"..private.current_section.."> stage: <"..private.current_stage.."> state: <"..private.current_state.."> attempts: <".. private.attempt_count..">");
  
  bot.Start(
    settings.attempts or private.attempt_count,
    private.current_section,
    private.current_stage,
    private.current_state,
  settings.outfile_stat_all,
  settings.outfile_stat_summary
  );
  
end;
--------------------------------------------------------------------------------
function public.Set ()
  
  local state   = private.current_state;
  local stage   = private.current_stage; 
  local section = private.current_section;
  
  local stage_data = m_stage.GetStaticData( "stage_"..stage, state );  
  
  private.match3 = {};
  
  private.match3.state   = state;
  private.match3.stage   = stage;
  private.match3.section = section;
  private.match3.moves   = stage_data.state[ state ].moves;
      
  ObjDelete( "match" );
  ObjCreate( "match", "matchbox" );
  
  v_stage.Init();
  
  --local player_data = {
  --  health        = 100,
  --  score         = 0,
  --  enemy_attack  = 0,
  --  enemy_health  = 0,
  --  attack        = 
  --  attack_factor = 1
  --};
  
  stage_data = m_stage.Start(
    v_player.Stats_GetPlayerData(),
    "stage_"..private.match3.stage,
    private.match3.state,
    stage_data.state[ state ].enemy,
    true
  );
  
  bot.SetStageType( stage_data.type );
  
  ObjSet( "match", 
  { 
    stage     = "stage_"..private.match3.stage, 
    state     = private.match3.state,
    boosters  = {},
    section   = private.match3.section,
    attempts  = 0,
    max_attempts  = 999
  } );
  
  ObjAttach( "match", "obj_matchbox" );
  
end;
--------------------------------------------------------------------------------
function private.Handle_Event_Cheat_KeyPressed(msg, params)
  local key    = params.key or 0;
  if (key == 49 ) then -- 1
    ne.msg.Send( Event_Match3_BoosterActivated,
    {
      name     = "hammer",
      row      = nil,
      col      = nil,
      vertical = nil 
    });
  elseif (key == 50 ) then -- 2
    ne.msg.Send( Event_Match3_BoosterActivated,
    {
      name     = "super_hammer",
      row      = nil,
      col      = nil,
      vertical = nil 
    });
  elseif (key == 51 ) then -- 3
    bot.Step();
  elseif (key == 52 ) then -- 4
    bot.SwitchStep();
  elseif (key == 53 ) then -- 5
    ne.msg.Send( Event_Match3_BoosterActivated, { name = "print_chips" } );
  end;
end;
--------------------------------------------------------------------------------
function private.Match3_FieldActivated ()
  private.match3.moves = private.match3.moves - 1;
end;
--------------------------------------------------------------------------------
function private.Info( text )
  DbgTrace("[DBG_MATCH3] "..tostring(text));
end;
--------------------------------------------------------------------------------
function private.Exception( text )
  DbgTrace("[DBG_MATCH3][ERROR] "..tostring(text));
end;
--------------------------------------------------------------------------------